// JavaScript Document
var cc;
var cs;

var id;

var bW;
var bH;

var cW;
var cH;

var cX;
var cY;

var base;

var line0;
var line1;

var commonBack0;
var commonBack1;
var commonLine;

//矢印
var arrowX;

//点と破線
var p0;
var p1;

//テキスト
var tx;
var t0;
var t1;

var nc0;
var nc1;

//色
var c0;
var c1;


var span;

//数値
var num0_0;
var num0_1;
var num0_2;
var num0_3;
var num1_0;
var num1_1;
var num1_2;
var num1_3;

var symArray = [];

var sym0;
var sym1;

var browse;

var data;


//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

function loadContentHandler()
{
	try
	{
		document.getElementById("windowBlock").style.marginRight = "20px";
		document.getElementById("windowBlock").style.width = "370px";
		document.getElementById("windowBlock").style.textAlign = "left";
		
		$(".simEq").css("position", "relative");
		
		$(".formula").css("width", "330px");
		$(".formula").css("marginLeft", "30px");
		
		$("#simEq0").css("margin-bottom", "10px");
		$("#simEq1").css("margin-bottom", "10px");
		$("#simEq1").css("margin-top", "10px");
		
		
		//スマートフォン
		var ua = navigator.userAgent;
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			browse = false;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			browse = false;
		}
		else
		{
			browse = false;
		}
		
		bW = 540;
		bH = 180;
		
		document.getElementById("graphBlock").style.border = "none";
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		
		document.getElementById("symbolBlock0").style.marginTop = "10px";
		document.getElementById("symbolBlock1").style.marginTop = "10px";
		
		cc = document.getElementById("lineCanvas");
		cs = new createjs.Stage(cc);
		cc.width = bW;
		cc.height = bH;
		
		createjs.Touch.enable(cs);
		
		cX = bW/2;
		cY = bH/2 + 50;
		
		sym0 = 3;
		sym1 = 2;
		
		configSymbolButtonHandler(0, sym0);
		configSymbolButtonHandler(1, sym1);
		
		
		num0_0 = 5;
		num0_1 = 4;
		num0_2 = 2;
		num0_3 = 7;
		
		num1_0 = 7;
		num1_1 = -6;
		num1_2 = 4;
		num1_3 = 9;
		
		symArray = ["＝", "＜", "≦", "＞", "≧"];
		
		
		span = 30;
		
		//矢印と背景の色
		c0 = "#E9F6FD";
		c1 = "#009FE8";
		
		dFlag = true;
		
		base = new createjs.Shape();
		base.graphics.setStrokeStyle(0);
		base.graphics.beginStroke("#FFFFFF");
		base.graphics.beginFill("#FFFFFF");
		base.graphics.drawRect(0, 0, bW, bH);
		base.graphics.endFill();
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		base.graphics.moveTo(0, cY);
		base.graphics.lineTo(bW, cY);
		base.graphics.endStroke();
		cs.addChild(base);
		
		//共通の領域描画
		commonBack0 = new createjs.Shape();
		cs.addChild(commonBack0);
		commonBack1 = new createjs.Shape();
		cs.addChild(commonBack1);
		
		//矢印
		arrowX = new createjs.Shape();
		arrowX.graphics.setStrokeStyle(0);
		arrowX.graphics.beginStroke("#000000");
		arrowX.graphics.beginFill("#000000");
		arrowX.graphics.moveTo(-10, 0);
		arrowX.graphics.lineTo(-10, 3);
		arrowX.graphics.lineTo(0, 0);
		arrowX.graphics.lineTo(-10, -3);
		arrowX.graphics.lineTo(-10, 0);
		arrowX.graphics.endStroke();
		
		arrowX.x = bW;
		arrowX.y = cY;
		
		cs.addChild(arrowX);
		
		//領域の線
		line0 = new createjs.Shape();
		cs.addChild(line0);
		line0.y = cY;
		line1 = new createjs.Shape();
		line1.y = cY;
		cs.addChild(line1);
		
		//
		commonLine = new createjs.Shape();
		cs.addChild(commonLine);
		
		//
		nc0 = new createjs.Text("③", "18px Arial", "#000000");
		nc0.y = cY - 40;
		nc1 = new createjs.Text("④", "18px Arial", "#000000");
		nc1.y = cY - 80;
		
		tx = new createjs.Text("x", "italic 18px Times New Roman", "#000000");
		tx.x = bW - 15;
		tx.y = cY + 5;
		t0 = new createjs.Text("", "18px Arial", "#000000");
		t0.y = cY + 5;
		t1 = new createjs.Text("", "18px Arial", "#000000");
		t1.y = cY + 5;
		
		cs.addChild(nc0);
		cs.addChild(nc1);
		cs.addChild(tx);
		cs.addChild(t0);
		cs.addChild(t1);
		
		document.getElementById("gCheck0").checked = false;
		document.getElementById("gCheck1").checked = false;
		document.getElementById("gCheck2").checked = false;
		document.getElementById("gCheck0").addEventListener("change", changeCheckHandler);
		document.getElementById("gCheck1").addEventListener("change", changeCheckHandler);
		document.getElementById("gCheck2").addEventListener("change", changeCheckHandler);
		
		document.getElementById("upBtn0_0").addEventListener("click", changeNumberHandler);
		document.getElementById("upBtn0_1").addEventListener("click", changeNumberHandler);
		document.getElementById("upBtn0_2").addEventListener("click", changeNumberHandler);
		document.getElementById("upBtn0_3").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn0_0").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn0_1").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn0_2").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn0_3").addEventListener("click", changeNumberHandler);
		
		document.getElementById("upBtn1_0").addEventListener("click", changeNumberHandler);
		document.getElementById("upBtn1_1").addEventListener("click", changeNumberHandler);
		document.getElementById("upBtn1_2").addEventListener("click", changeNumberHandler);
		document.getElementById("upBtn1_3").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn1_0").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn1_1").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn1_2").addEventListener("click", changeNumberHandler);
		document.getElementById("downBtn1_3").addEventListener("click", changeNumberHandler);
		
		document.getElementById("text0_0").value = num0_0;
		document.getElementById("text0_1").value = num0_1;
		document.getElementById("text0_2").value = num0_2;
		document.getElementById("text0_3").value = num0_3;
		
		document.getElementById("text1_0").value = num1_0;
		document.getElementById("text1_1").value = num1_1;
		document.getElementById("text1_2").value = num1_2;
		document.getElementById("text1_3").value = num1_3;
		
		document.getElementById("text0_0").addEventListener("input", changeTextHandler);
		document.getElementById("text0_1").addEventListener("input", changeTextHandler);
		document.getElementById("text0_2").addEventListener("input", changeTextHandler);
		document.getElementById("text0_3").addEventListener("input", changeTextHandler);
		document.getElementById("text1_0").addEventListener("input", changeTextHandler);
		document.getElementById("text1_1").addEventListener("input", changeTextHandler);
		document.getElementById("text1_2").addEventListener("input", changeTextHandler);
		document.getElementById("text1_3").addEventListener("input", changeTextHandler);
		
		document.getElementById("onBtn0_0").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn0_1").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn0_2").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn0_3").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn0_4").addEventListener("click", changeSymbolButtonHandler);
		
		document.getElementById("onBtn1_0").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn1_1").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn1_2").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn1_3").addEventListener("click", changeSymbolButtonHandler);
		document.getElementById("onBtn1_4").addEventListener("click", changeSymbolButtonHandler);
		
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		changeFormulaTextHandler();
		
		changeBracHandler();
		
		drawLineHandler();
		
		cs.update();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function getFormulaString(n0, n1)
{
	try
	{
		var str0;
		var str1;
		var str2;
		var str3;
		
		var str = "";
		
		if(n0 != 0)
		{
			if(n0 == 1)
			{
				str0 = "";
			}
			else if(n0 == -1)
			{
				str0 = "-";
			}
			else
			{
				str0 = n0.toString();
			}

			str0 = str0 + '<span class="times">x</span>';
		}
		else
		{
			str0 = "";
		}
		
		if(n1 == 0)
		{
			if(n0 != 0)
			{
				str1 = "";
			}
			else
			{
				str1 = "0";
			}
		}
		else if(n1 > 0)
		{
			if(n0 != 0)
			{
				str1 = "+" + n1.toString();
			}
			else
			{
				str1 = n1.toString();
			}
		}
		else
		{
			str1 = n1.toString();
		}
		
		
		str = str0 + str1;
		
		return str;
	}
	catch(e)
	{
		alert("getFormulaString:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		var id = parseInt(e.currentTarget.id.substring(6,7));
		
		if(!e.currentTarget.checked)
		{
			id--;
		}
		
		for(var i=0; i<3; i++)
		{
			if(i <= id)
			{
				document.getElementById("gCheck"+i).checked = true;
			}
			else
			{
				document.getElementById("gCheck"+i).checked = false;
			}
		}
		
		if(document.getElementById("gCheck0").checked)
		{
			calcAreaHandler(true);
		}
		else
		{
			document.getElementById("ans0").innerHTML = "";
		}
		
		if(document.getElementById("gCheck1").checked)
		{
			calcAreaHandler(false);
		}
		else
		{
			document.getElementById("ans1").innerHTML = "";
		}
		
		if(document.getElementById("gCheck2").checked)
		{
			calcCommonAreaHandler();
		}
		else
		{
			document.getElementById("ans2").innerHTML = "";
		}
		
		drawLineHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

function changeFormulaTextHandler()
{
	try
	{
		//上の連立方程式
		document.getElementById("form0_0").innerHTML = getFormulaString(num0_0, num0_1);
		document.getElementById("form0_1").innerHTML = getFormulaString(num0_2, num0_3);
		document.getElementById("form1_0").innerHTML = getFormulaString(num1_0, num1_1);
		document.getElementById("form1_1").innerHTML = getFormulaString(num1_2, num1_3);
		
		document.getElementById("sym0").innerHTML = symArray[sym0];
		document.getElementById("fSym0").innerHTML = symArray[sym0];
		document.getElementById("sym1").innerHTML = symArray[sym1];
		document.getElementById("fSym1").innerHTML = symArray[sym1];
		
	}
	catch(e)
	{
		alert("changeFormulaTextHandler:" + e.toString());
	}
}
	
//入力での数値変更
function changeTextHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert("changeTextHandler:" + e.toString());
	}
}

function changeNumberHandler(e)
{
	try
	{
		var str = e.target.id;
		
		var type = parseInt(str.substring(str.length-3, str.length-2));
		var id = parseInt(str.substring(str.length-1, str.length));
		
		var f;
		
		//数を上げる
		if(str.indexOf("upBtn") == 0)
		{
			//係数の場合
			if(type == 0 && id == 0)
			{
				num0_0 += 1;
								
				if(num0_0 == num0_2)
				{
					num0_0 = num0_2 + 1;
				}
				
				f = 0;
				document.getElementById("text0_0").value = num0_0;
			}
			else if(type == 0 && id == 2)
			{
				num0_2 += 1;
				
				if(num0_2 == num0_0)
				{
					num0_2 = num0_0 + 1;
				}
				
				f = 1;
				document.getElementById("text0_2").value = num0_2;
			}
			else if(type == 1 && id == 0)
			{
				num1_0 += 1;
				
				if(num1_0 == num1_2)
				{
					num1_0 = num1_2 + 1;
				}
				
				f = 2;
				document.getElementById("text1_0").value = num1_0;
			}
			else if(type == 1 && id == 2)
			{
				num1_2 += 1;
				
				if(num1_2 == num1_0)
				{
					num1_2 = num1_0 + 1;
				}
				
				f = 3;
				document.getElementById("text1_2").value = num1_2;
			}
			//係数でない数
			else
			{	
				switch(str)
				{
					case "upBtn0_1":
						num0_1 += 1;
						f = 0;
						document.getElementById("text0_1").value = num0_1;
						break;
					case "upBtn0_3":
						num0_3 += 1;
						f = 1;
						document.getElementById("text0_3").value = num0_3;
						break;
					case "upBtn1_1":
						num1_1 += 1;
						f = 2;
						document.getElementById("text1_1").value = num1_1;
						break;
					case "upBtn1_3":
						num1_3 += 1;
						f = 3;
						document.getElementById("text1_3").value = num1_3;
						break;
				}
			}
		}
		//数を下げる
		else
		{
			//係数の場合
			if(type == 0 && id == 0)
			{
				num0_0 -= 1;
				
				if(num0_0 == num0_2)
				{
					num0_0 = num0_2-1;
				}
				
				f = 0;
				document.getElementById("text0_0").value = num0_0;
			}
			else if(type == 0 && id == 2)
			{
				num0_2 -= 1;
				
				if(num0_2 == num0_0)
				{
					num0_2 = num0_0-1;
				}
				
				f = 1;
				document.getElementById("text0_2").value = num0_2;
			}
			else if(type == 1 && id == 0)
			{
				num1_0 -= 1;
				
				if(num1_0 == num1_2)
				{
					num1_0 = num1_2-1;
				}
				
				f = 2;
				document.getElementById("text1_0").value = num1_0;
			}
			//係数でない場合
			else if(type == 1 && id == 2)
			{
				if(num1_2 == 1)
				{
					num1_2 = -1;
				}
				else
				{
					num1_2 -= 1;
				}
				
				if(num1_2 == num1_0)
				{
					num1_2 = num1_0-1;
					
					if(num1_2 == 0)
					{
						num1_2 = -1;
					}
				}
				
				f = 3;
				document.getElementById("text1_2").value = num1_2;
			}
			else
			{	
				switch(str)
				{
					case "downBtn0_1":
						num0_1 -= 1;
						f = 0;
						document.getElementById("text0_1").value = num0_1;
						break;
					case "downBtn0_3":
						num0_3 -= 1;
						f = 1;
						document.getElementById("text0_3").value = num0_3;
						break;
					case "downBtn1_1":
						num1_1 -= 1;
						f = 2;
						document.getElementById("text1_1").value = num1_1;
						break;
					case "downBtn1_3":
						num1_3 -= 1;
						f = 3;
						document.getElementById("text1_3").value = num1_3;
						break;
				}
			}
		}
		
		switch(f)
		{
			case 0:
				document.getElementById("form0_0").innerHTML = getFormulaString(num0_0, num0_1);
				break;
			case 1:
				document.getElementById("form0_1").innerHTML = getFormulaString(num0_2, num0_3);
				break;
			case 2:
				document.getElementById("form1_0").innerHTML = getFormulaString(num1_0, num1_1);
				break;
			case 3:
				document.getElementById("form1_1").innerHTML = getFormulaString(num1_2, num1_3);
				break;
		}
		
		if(type == 0)
		{
			calcAreaHandler(true);
		}
		else
		{
			calcAreaHandler(false);
		}
		
		if(document.getElementById("gCheck2").checked)
		{
			calcCommonAreaHandler();
		}
		
		drawLineHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeNumberHandler:" + e.toString());
	}
}

function changeSymbolButtonHandler(e)
{
	try
	{
		var id = parseInt(e.target.id.substring(5, 6));
		
		sym = parseInt(e.target.id.substring(7, 8));
		
		configSymbolButtonHandler(id, sym);
		
		if(id == 0)
		{
			sym0 = sym;
			
			document.getElementById("sym0").innerHTML = symArray[sym0];
			document.getElementById("fSym0").innerHTML = symArray[sym0];
			
			if(document.getElementById("gCheck0").checked)
			{
				calcAreaHandler(true);
			}
		}
		else
		{
			sym1 = sym;
			
			document.getElementById("sym1").innerHTML = symArray[sym1];
			document.getElementById("fSym1").innerHTML = symArray[sym1];
			
			if(document.getElementById("gCheck1").checked)
			{
				calcAreaHandler(false);
			}
		}
		
		if(document.getElementById("gCheck2").checked)
		{
			calcCommonAreaHandler();
		}
		
		drawLineHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeSymbolButtonHandler:" + e.toString());
	}
}

function configSymbolButtonHandler(id, num)
{
	try
	{
		for(var i=0; i<5; i++)
		{
			if(i == num)
			{
				document.getElementById("onBtn"+id+"_"+i).style.display = "none";
				
				document.getElementById("offBtn"+id+"_"+i).style.display = "inline-block";
			}
			else
			{
				document.getElementById("onBtn"+id+"_"+i).style.display = "inline-block";
				
				document.getElementById("offBtn"+id+"_"+i).style.display = "none";
			}
		}
	}
	catch(e)
	{
		alert("configSymbolButtonHandler:" + e.toString());
	}
}

function createTextObject(str, type)
{
	try
	{
		var cont = new createjs.Container();
		var fb = new createjs.Shape();
		fb.name = "fb";
		cont.addChild(fb);
		
		
		var ft0;
		
		if(str != "O")
		{
			ft0 = new createjs.Text("", "italic 18px Times New Roman", "#000000");
		}
		else
		{
			ft0 = new createjs.Text("", "18px Times New Roman", "#000000");
		}
		ft0.name = "ft0";
		cont.addChild(ft0);
		var ft1 = new createjs.Text("", "18px Arial", "#000000");
		ft1.name = "ft1";
		cont.addChild(ft1);
		
		if(type == 1)
		{
			var sp = new createjs.Shape();
			sp.name = "sp";
			cont.addChild(sp);
		}
		
		changeTextObject(cont, str, type);
		
		return cont;
	}
	catch(e)
	{
		alert("createTextObject:" + e.toString());
	}
}


function calcAreaHandler(f)
{
	try
	{
		var num0;
		var num1;
		
		var sym;
		var str = "";
		
		//上の式
		if(f)
		{
			num0 = num0_0 - num0_2;
			num1 = num0_3 - num0_1;
			
			if(num0 < 0)
			{
				if(sym0 == 1)
				{
					sym = symArray[3];
				}
				else if(sym0 == 2)
				{
					sym = symArray[4];
				}
				else if(sym0 == 3)
				{
					sym = symArray[1];
				}
				else if(sym0 == 4)
				{
					sym = symArray[2];
				}
				else
				{
					sym = symArray[0];
				}
			}
			else
			{
				sym = symArray[sym0];
			}
		}
		else
		{
			num0 = num1_0 - num1_2;
			num1 = num1_3 - num1_1;
			
			if(num0 < 0)
			{
				if(sym1 == 1)
				{
					sym = symArray[3];
				}
				else if(sym1 == 2)
				{
					sym = symArray[4];
				}
				else if(sym1 == 3)
				{
					sym = symArray[1];
				}
				else if(sym1 == 4)
				{
					sym = symArray[2];
				}
				else
				{
					sym = symArray[0];
				}
			}
			else
			{
				sym = symArray[sym1];
			}
		}
		
		num1 = Math.round(num1/num0 * 100)/100;
		
		str = '<span class="times">x</span>' +" "+ sym +" "+ num1;
		
		if(f)
		{
			if(document.getElementById("gCheck0").checked)
			{
				document.getElementById("ans0").innerHTML = str;
			}
			else
			{
				document.getElementById("ans0").innerHTML = "";
			}
		}
		else
		{
			if(document.getElementById("gCheck1").checked)
			{
				document.getElementById("ans1").innerHTML = str;
			}
			else
			{
				document.getElementById("ans1").innerHTML = "";
			}
		}
	}
	catch(e)
	{
		alert("calcAreaHandler:" + e.toString());
	}
}

function calcCommonAreaHandler()
{
	try
	{
		var str = "";
		
		var num0 = (num0_3 - num0_1)/(num0_0 - num0_2);
		var num1 = (num1_3 - num1_1)/(num1_0 - num1_2);
		
		var n0;
		var n1;
		
		var s0;
		var s1;
		
		data = [];
		
		//符号の逆転判定
		if(num0_0 - num0_2 >= 0)
		{
			s0 = sym0;
		}
		else
		{
			if(sym0 == 1)
			{
				s0 = 3;
			}
			else if(sym0 == 2)
			{
				s0 = 4;
			}
			else if(sym0 == 3)
			{
				s0 = 1;
			}
			else if(sym0 == 4)
			{
				s0 = 2;
			}
			else
			{
				s0 = 0;
			}
		}
		
		if(num1_0 - num1_2 >= 0)
		{
			s1 = sym1;
		}
		else
		{
			if(sym1 == 1)
			{
				s1 = 3;
			}
			else if(sym1 == 2)
			{
				s1 = 4;
			}
			else if(sym1 == 3)
			{
				s1 = 1;
			}
			else if(sym1 == 4)
			{
				s1 = 2;
			}
			else
			{
				s1 = 0;
			}
		}
		
		
		//符号が同じ場合
		if(s0 == s1)
		{
			//イコールの場合
			if(s0 == 0)
			{
				//値が同じ
				if(num0 == num1)
				{
					str = '<span class="times">x</span>＝' + Math.round(num0 * 100)/100;
					
					data[0] = num0;
				}
				else
				{
					str = "なし";
				}
			}
			//"＜"，"≦"
			else if(s0 == 1 || s0 == 2)
			{
				var n = Math.min(num0, num1);
				
				data[0] = n;
				data[1] = s0;
				
				n = Math.round(n * 100)/100;
				str = '<span class="times">x</span>'+symArray[s0]+n;
			}
			//"＞"，"≧"
			else
			{
				var n = Math.max(num0, num1);
				
				data[0] = n;
				data[1] = s0;
				
				n = Math.round(n * 100)/100;
				str = '<span class="times">x</span>'+symArray[s0]+n;
			}
		}
		//符号が異なる場合
		else
		{
			var n0 = Math.round(num0*100)/100;
			var n1 = Math.round(num1*100)/100;
			
			//どちらかがイコール
			if(s0 == 0 || s1 == 0)
			{
				if(s0 == 0)
				{
					if(s1 == 1 || s1 == 2)
					{
						if(s1 == 1 && num0 < num1)
						{
							str = '<span class="times">x</span>＝'+n0;
							
							data[0] = num0;
						}
						else if(s1 == 2 && num0 <= num1)
						{
							str = '<span class="times">x</span>＝'+n0;
							
							data[0] = num0;
						}
						else
						{
							str = "なし";
						}
					}
					else if(s1 == 3 || s1 == 4)
					{
						if(s1 == 3 && num0 > num1)
						{
							str = '<span class="times">x</span>＝'+n0;
							
							data[0] = num0;
						}
						else if(s1 == 4 && num0 >= num1)
						{
							str = '<span class="times">x</span>＝'+n0;
							
							data[0] = num0;
						}
						else
						{
							str = "なし";
						}
					}
				}
				else
				{
					if(s0 == 1 || s0 == 2)
					{
						if(s0 == 1 && num1 < num0)
						{
							str = '<span class="times">x</span>＝'+n1;
							
							data[0] = num1;
						}
						else if(s0 == 2 && num1 <= num0)
						{
							str = '<span class="times">x</span>＝'+n1;
							
							data[0] = num1;
						}
						else
						{
							str = "なし";
						}
					}
					else if(s0 == 3 || s0 == 4)
					{
						if(s0 == 3 && num1 > num0)
						{
							str = '<span class="times">x</span>＝'+n1;
							
							data[0] = num1;
						}
						else if(s0 == 4 && num1 >= num0)
						{
							str = '<span class="times">x</span>＝'+n1;
							
							data[0] = num1;
						}
						else
						{
							str = "なし";
						}
					}
				}
			}
			//どちらも以下，より小さい
			else if((s0 == 1 || s0 == 2) && (s1 == 1 || s1 == 2))
			{
				if(num0 == num1)
				{
					if(s0 == 1 || s1 == 1)
					{
						str = '<span class="times">x</span>'+symArray[1]+n0;
						
						data[0] = num0;
						data[1] = 1;
					}
					else
					{
						str = '<span class="times">x</span>'+symArray[2]+n0;
						
						data[0] = num0;
						data[1] = 2;
					}
				}
				else if(num1 < num0)
				{
					str = '<span class="times">x</span>'+symArray[s1]+n1;
					
					data[0] = num1;
					data[1] = s1;
				}
				else
				{
					str = '<span class="times">x</span>'+symArray[s0]+n0;
					
					data[0] = num0;
					data[1] = s0;
				}
			}
			//どちらも以上，より大きい
			else if((s0 == 3 || s0 == 4) && (s1 == 3 || s1 == 4))
			{
				if(num0 == num1)
				{
					if(s0 == 3 || s1 == 3)
					{
						str = '<span class="times">x</span>'+symArray[3]+n0;
						
						data[0] = num0;
						data[1] = 3;
					}
					else
					{
						str = '<span class="times">x</span>'+symArray[4]+n0;
						
						data[0] = num0;
						data[1] = 4;
					}
				}
				else if(num1 > num0)
				{
					str = '<span class="times">x</span>'+symArray[s1]+n1;
					
					data[0] = num1;
					data[1] = s1;
				}
				else
				{
					str = '<span class="times">x</span>'+symArray[s0]+n0;
					
					data[0] = num0;
					data[1] = s0;
				}
			}
			//
			else
			{
				//＜:1, ≦:2, ＞:3, ≧:4
				if((num0 == num1 && s0 == 2 && s1 == 4) || (num0 == num1 && s0 == 4 && s1 == 2))
				{
					str = '<span class="times">x</span>＝' + n0;
					
					data[0] = num0;
				}
				else if(num0 < num1 && (s0 == 3 || s0 == 4) && (s1 == 1 || s1 == 2))
				{
					if(s0 == 3)
					{
						s0 = 1;
					}
					else
					{
						s0 = 2;
					}
					
					str = n0 + symArray[s0] + '<span class="times">x</span>' + symArray[s1] + n1;
					
					data[0] = num0;
					data[1] = num1;
					data[2] = s0;
					data[3] = s1;
				}
				else if(num1 < num0 && (s0 == 1 || s0 == 2) && (s1 == 3 || s1 == 4))
				{
					if(s1 == 3)
					{
						s1 = 1;
					}
					else
					{
						s1 = 2;
					}
					
					str = n1 + symArray[s1] + '<span class="times">x</span>' + symArray[s0] + n0;
					
					data[0] = num1;
					data[1] = num0;
					data[2] = s1;
					data[3] = s0;
				}
				else
				{
					str = "なし";
				}
			}
		}
		
		document.getElementById("ans2").innerHTML = str;
	}
	catch(e)
	{
		alert("calcCommonAreaHandler:" + e.toString());
	}
}

function drawLineHandler()
{
	try
	{
		var num0 = (num0_3 - num0_1)/(num0_0 - num0_2);
		var num1 = (num1_3 - num1_1)/(num1_0 - num1_2);
		
		var s0;
		var s1;
		
		//符号の逆転判定
		if(num0_0 - num0_2 >= 0)
		{
			s0 = sym0;
		}
		else
		{
			if(sym0 == 1)
			{
				s0 = 3;
			}
			else if(sym0 == 2)
			{
				s0 = 4;
			}
			else if(sym0 == 3)
			{
				s0 = 1;
			}
			else if(sym0 == 4)
			{
				s0 = 2;
			}
			else
			{
				s0 = 0;
			}
		}
		
		if(num1_0 - num1_2 >= 0)
		{
			s1 = sym1;
		}
		else
		{
			if(sym1 == 1)
			{
				s1 = 3;
			}
			else if(sym1 == 2)
			{
				s1 = 4;
			}
			else if(sym1 == 3)
			{
				s1 = 1;
			}
			else if(sym1 == 4)
			{
				s1 = 2;
			}
			else
			{
				s1 = 0;
			}
		}
		
		if(document.getElementById("gCheck0").checked)
		{
			line0.graphics.clear();
			line0.graphics.setStrokeStyle(1);
			line0.graphics.beginStroke("#000000");
			
			if(s0 == 1)
			{
				line0.graphics.moveTo(0, 0);
				line0.graphics.lineTo(-10, -20);
				line0.graphics.lineTo(-(cX+span*num0)-bW, -20);
			}
			else if(s0 == 2)
			{
				line0.graphics.moveTo(0, 0);
				line0.graphics.lineTo(0, -20);
				line0.graphics.lineTo(-(cX+span*num0)-bW, -20);
			}
			else if(s0 == 3)
			{
				line0.graphics.moveTo(0, 0);
				line0.graphics.lineTo(10, -20);
				line0.graphics.lineTo((cX+span*num0)+bW, -20);
			}
			else if(s0 == 4)
			{
				line0.graphics.moveTo(0, 0);
				line0.graphics.lineTo(0, -20);
				line0.graphics.lineTo((cX+span*num0)+bW, -20);
			}
			
			if(s0 == 0 || s0 == 2 || s0 == 4)
			{
				line0.graphics.beginFill("#000000");
				line0.graphics.drawCircle(0, 0, 3);
				line0.graphics.endFill();
			}
			else
			{
				line0.graphics.beginFill("#FFFFFF");
				line0.graphics.drawCircle(0, 0, 3);
				line0.graphics.endFill();
			}
			
			
			line0.x = cX + span * num0;
			
			t0.visible = true;
			num0 = Math.round(num0 * 100)/100;
			t0.text = num0;
			t0.x = line0.x - t0.getBounds().width/2;
			
			nc0.visible = true;
			nc0.x = line0.x - nc0.getBounds().width/2;
		}
		else
		{
			nc0.visible = false;
			t0.visible = false;
			line0.graphics.clear();
		}
		
		if(document.getElementById("gCheck1").checked)
		{
			line1.graphics.clear();
			line1.graphics.setStrokeStyle(1);
			line1.graphics.beginStroke("#000000");
			
			if(s1 == 1)
			{
				line1.graphics.moveTo(0, 0);
				line1.graphics.lineTo(-20, -50);
				line1.graphics.lineTo(-(cX+span*num1)-bW, -50);
			}
			else if(s1 == 2)
			{
				line1.graphics.moveTo(0, 0);
				line1.graphics.lineTo(0, -50);
				line1.graphics.lineTo(-(cX+span*num1)-bW, -50);
			}
			else if(s1 == 3)
			{
				line1.graphics.moveTo(0, 0);
				line1.graphics.lineTo(20, -50);
				line1.graphics.lineTo((cX+span*num0)+bW, -50);
			}
			else if(s1 == 4)
			{
				line1.graphics.moveTo(0, 0);
				line1.graphics.lineTo(0, -50);
				line1.graphics.lineTo((cX+span*num0)+bW, -50);
			}
			
			if(s1 == 0 || s1 == 2 || s1 == 4)
			{
				line1.graphics.beginFill("#000000");
				line1.graphics.drawCircle(0, 0, 3);
				line1.graphics.endFill();
			}
			else
			{
				line1.graphics.beginFill("#FFFFFF");
				line1.graphics.drawCircle(0, 0, 3);
				line1.graphics.endFill();
			}
			
			line1.x = cX + span * num1;
			
			t1.visible = true;
			num1 = Math.round(num1 * 100)/100;
			t1.text = num1;
			t1.x = line1.x - t1.getBounds().width/2;
			
			nc1.visible = true;
			nc1.x = line1.x - nc1.getBounds().width/2;
		}
		else
		{
			nc1.visible = false;
			t1.visible = false;
			line1.graphics.clear();
		}
		
		commonBack0.graphics.clear();
		commonBack1.graphics.clear();
		commonLine.graphics.clear();
			
		
		if(document.getElementById("gCheck2").checked)
		{
			
			var str = document.getElementById("ans2").innerHTML;
			
			//点
			if(str.indexOf("＝") != -1)
			{
				commonLine.graphics.setStrokeStyle(2);
				commonLine.graphics.beginStroke("#009FE8");
				
				commonLine.graphics.beginFill("#009FE8");
				commonLine.graphics.drawCircle(cX + span * data[0], cY, 3);
			}
			//
			else if(str.indexOf("<span") == 0)
			{
				commonLine.graphics.setStrokeStyle(4);
				commonLine.graphics.beginStroke("#009FE8");
				
				if(data[1] == 1 || data[1] == 2)
				{
					commonLine.graphics.moveTo(cX + data[0] * span, cY);
					commonLine.graphics.lineTo(-bW * 2, cY);
				}
				else
				{
					commonLine.graphics.moveTo(cX + data[0] * span, cY);
					commonLine.graphics.lineTo(bW * 2, cY);
				}
				
				if(data[1] == 1 || data[1] == 3)
				{
					commonLine.graphics.setStrokeStyle(1);
					commonLine.graphics.beginStroke("#000000");
					commonLine.graphics.beginFill("#FFFFFF");
					commonLine.graphics.drawCircle(cX + data[0] * span, cY, 3);
					commonLine.graphics.endFill();
				}
				else
				{
					commonLine.graphics.setStrokeStyle(2);
					commonLine.graphics.beginStroke("#009FE8");
					commonLine.graphics.beginFill("#009FE8");
					commonLine.graphics.drawCircle(cX + data[0] * span, cY, 3);
					commonLine.graphics.endFill();
				}
				
				commonBack1.mask = null;
				commonBack1.visible = true;
				
				commonBack0.graphics.setStrokeStyle(0);
				commonBack0.graphics.beginStroke("#E9F6FD");
				commonBack0.graphics.beginFill("#E9F6FD");
				commonBack0.graphics.moveTo(cX + data[0] * span, cY);
				
				if(data[0] == num0)
				{
					if(data[1] == 1)
					{
						commonBack0.graphics.lineTo(cX + data[0] * span - 10, cY - 20);
						commonBack0.graphics.lineTo(cX - bW, cY - 20);
						commonBack0.graphics.lineTo(cX - bW, cY);
					}
					else if(data[1] == 3)
					{
						commonBack0.graphics.lineTo(cX + data[0] * span + 10, cY - 20);
						commonBack0.graphics.lineTo(cX + bW, cY - 20);
						commonBack0.graphics.lineTo(cX + bW, cY);
					}
					else
					{
						commonBack0.graphics.lineTo(cX + data[0] * span, cY - 20);
						
						if(data[1] == 2)
						{
							commonBack0.graphics.lineTo(cX - bW, cY - 20);
							commonBack0.graphics.lineTo(cX - bW, cY);
						}
						else
						{
							commonBack0.graphics.lineTo(cX + bW, cY - 20);
							commonBack0.graphics.lineTo(cX + bW, cY);
						}
					}
				}
				else
				{
					if(data[1] == 1)
					{
						commonBack0.graphics.lineTo(cX + data[0] * span - 8, cY - 20);
						commonBack0.graphics.lineTo(cX - bW, cY - 20);
						commonBack0.graphics.lineTo(cX - bW, cY);
					}
					else if(data[1] == 3)
					{
						commonBack0.graphics.lineTo(cX + data[0] * span + 8, cY - 20);
						commonBack0.graphics.lineTo(cX + bW, cY - 20);
						commonBack0.graphics.lineTo(cX + bW, cY);
					}
					else
					{
						commonBack0.graphics.lineTo(cX + data[0] * span, cY - 20);
						
						if(data[1] == 2)
						{
							commonBack0.graphics.lineTo(cX - bW, cY - 20);
							commonBack0.graphics.lineTo(cX - bW, cY);
						}
						else
						{
							commonBack0.graphics.lineTo(cX + bW, cY - 20);
							commonBack0.graphics.lineTo(cX + bW, cY);
						}
					}
				}
				
				commonBack0.graphics.endFill();
			}
			//限定範囲
			else if(str.indexOf("なし") == -1)
			{
				commonLine.graphics.setStrokeStyle(4);
				commonLine.graphics.beginStroke("#009FE8");
				
				commonLine.graphics.moveTo(cX + data[0] * span, cY);
				commonLine.graphics.lineTo(cX + data[1] * span, cY);
				
				if(data[2] == 1 || data[2] == 3)
				{
					commonLine.graphics.setStrokeStyle(1);
					commonLine.graphics.beginStroke("#000000");
					commonLine.graphics.beginFill("#FFFFFF");
					commonLine.graphics.drawCircle(cX + data[0] * span, cY, 3);
					commonLine.graphics.endFill();
				}
				else
				{
					commonLine.graphics.setStrokeStyle(2);
					commonLine.graphics.beginStroke("#009FE8");
					commonLine.graphics.beginFill("#009FE8");
					commonLine.graphics.drawCircle(cX + data[0] * span, cY, 3);
					commonLine.graphics.endFill();
				}
				
				if(data[3] == 1 || data[3] == 3)
				{
					commonLine.graphics.setStrokeStyle(1);
					commonLine.graphics.beginStroke("#000000");
					commonLine.graphics.beginFill("#FFFFFF");
					commonLine.graphics.drawCircle(cX + data[1] * span, cY, 3);
					commonLine.graphics.endFill();
				}
				else
				{
					commonLine.graphics.setStrokeStyle(2);
					commonLine.graphics.beginStroke("#009FE8");
					commonLine.graphics.beginFill("#009FE8");
					commonLine.graphics.drawCircle(cX + data[1] * span, cY, 3);
					commonLine.graphics.endFill();
				}
				
				commonBack0.graphics.setStrokeStyle(0);
				commonBack0.graphics.beginStroke("#E9F6FD");
				commonBack0.graphics.beginFill("#E9F6FD");
				commonBack0.graphics.moveTo(cX + data[0] * span, cY);
				
				if(data[0] == num0)
				{
					if(data[2] == 1)
					{
						commonBack0.graphics.lineTo(cX + data[0] * span + 10, cY-20);
					}
					else
					{
						commonBack0.graphics.lineTo(cX + data[0] * span, cY-20);
					}
				}
				else
				{
					if(data[2] == 1)
					{
						commonBack0.graphics.lineTo(cX + data[0] * span + 8, cY-20);
					}
					else
					{
						commonBack0.graphics.lineTo(cX + data[0] * span, cY-20);
					}
				}
				
				commonBack0.graphics.lineTo(cX + bW, cY-20);
				commonBack0.graphics.lineTo(cX + bW, cY);
				commonBack0.graphics.endFill();
				
				
				commonBack1.graphics.setStrokeStyle(0);
				commonBack1.graphics.beginStroke("#E9F6FD");
				commonBack1.graphics.beginFill("#E9F6FD");
				commonBack1.graphics.moveTo(cX + data[1] * span, cY);
				
				if(data[1] == num0)
				{
					if(data[3] == 1)
					{
						commonBack1.graphics.lineTo(cX + data[1] * span - 10, cY-20);
					}
					else
					{
						commonBack1.graphics.lineTo(cX + data[1] * span, cY-20);
					}
				}
				else
				{
					if(data[3] == 1)
					{
						commonBack1.graphics.lineTo(cX + data[1] * span - 8, cY-20);
					}
					else
					{
						commonBack1.graphics.lineTo(cX + data[1] * span, cY-20);
					}
				}
				
				commonBack1.graphics.lineTo(cX - bW, cY-20);
				commonBack1.graphics.lineTo(cX - bW, cY);
				commonBack1.graphics.endFill();
				
				commonBack0.mask = commonBack1;
				commonBack1.visible = false;
			}
		}
	}
	catch(e)
	{
		alert("drawLineHandler:" +e.toString());
	}
}

function changeBracHandler()
{
	try
	{
		var h0 = $("#simEq0").innerHeight();
		document.getElementById("brac0").style.float = "left";
		document.getElementById("brac0").style.width = "20px";
		document.getElementById("brac0").style.height = h0 + "px";
		document.getElementById("bCenter0").style.top = (h0-20)/2 + "px";
		$("#brac0").css({background:'url("img/bracBack.png")'});
		
		var h1 = $("#simEq1").innerHeight();
		document.getElementById("brac1").style.float = "left";
		document.getElementById("brac1").style.width = "20px";
		document.getElementById("brac1").style.height = h1 + "px";
		document.getElementById("bCenter1").style.top = (h1-20)/2 + "px";
		$("#brac1").css({background:'url("img/bracBack.png")'});
	
		
	}
	catch(e)
	{
		alert("changeBracHandler:" + e.toString());
	}
}


function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = num0_0;
		array[0][1] = num0_1;
		array[0][2] = num0_2;
		array[0][3] = num0_3;
		
		array[1] = [];
		array[1][0] = num1_0;
		array[1][1] = num1_1;
		array[1][2] = num1_2;
		array[1][3] = num1_3;
		
		array[2] = [];
		array[2][0] = sym0;
		array[2][1] = sym1;
		
		if(document.getElementById("gCheck2").checked)
		{
			array[3] = 2;
		}
		else if(document.getElementById("gCheck1").checked)
		{
			array[3] = 1;
		}
		else if(document.getElementById("gCheck0").checked)
		{
			array[3] = 0;
		}
		else
		{
			array[3] = -1;
		}
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		num0_0 = array[0][0];
		num0_1 = array[0][1];
		num0_2 = array[0][2];
		num0_3 = array[0][3];
		
		num1_0 = array[1][0];
		num1_1 = array[1][1];
		num1_2 = array[1][2];
		num1_3 = array[1][3];
		
		sym0 = array[2][0];
		sym1 = array[2][1];
		
		configSymbolButtonHandler(0, sym0);
		configSymbolButtonHandler(1, sym1);
		
		for(var i=0; i<4; i++)
		{
			if(i < array[3])
			{
				document.getElementById("gCheck"+i).checked = true;
			}
			else
			{
				document.getElementById("gCheck"+i).checked = false;
			}
		}
		
		changeFormulaTextHandler();
		
		if(document.getElementById("gCheck0").checked)
		{
			calcAreaHandler(true);
		}
		else
		{
			document.getElementById("ans0").innerHTML = "";
		}
		
		if(document.getElementById("gCheck1").checked)
		{
			calcAreaHandler(false);
		}
		else
		{
			document.getElementById("ans1").innerHTML = "";
		}
		
		if(document.getElementById("gCheck2").checked)
		{
			calcCommonAreaHandler();
		}
		else
		{
			document.getElementById("ans2").innerHTML = "";
		}
		
		drawLineHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}



function resetHandler(e)
{
	try
	{
		sym0 = 3;
		sym1 = 2;
		
		configSymbolButtonHandler(0, sym0);
		configSymbolButtonHandler(1, sym1);
		
		
		num0_0 = 5;
		num0_1 = 4;
		num0_2 = 2;
		num0_3 = 7;
		
		num1_0 = 7;
		num1_1 = -6;
		num1_2 = 4;
		num1_3 = 9;
		
		document.getElementById("text0_0").value = num0_0;
		document.getElementById("text0_1").value = num0_1;
		document.getElementById("text0_2").value = num0_2;
		document.getElementById("text0_3").value = num0_3;
		
		document.getElementById("text1_0").value = num1_0;
		document.getElementById("text1_1").value = num1_1;
		document.getElementById("text1_2").value = num1_2;
		document.getElementById("text1_3").value = num1_3;
		
		document.getElementById("gCheck0").checked = false;
		document.getElementById("gCheck1").checked = false;
		document.getElementById("gCheck2").checked = false;
		
		changeFormulaTextHandler();
		
		document.getElementById("ans0").innerHTML = "";
		document.getElementById("ans1").innerHTML = "";
		document.getElementById("ans2").innerHTML = "";
		
		drawLineHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}
