// JavaScript Document
var cc;
var cs;

var bW;
var bH;

var cW;
var cH;

var grid;
var base;

var axisX;
var axisY;

var arrowX;
var arrowY;

var tx;
var ty;
var t0;

var maxNum;
var minNum;

var minY;
var maxY;

var defMin;
var defMax;

var dPnt;
var minA;
var maxA;
var lineA;

var lx0;
var ly0;
var line0;
var line1;

var lineY;

var axis;

var form0;

var span;

var dotLine;

var prevA;
var prevB;
var prevC;

var backA;
var backB;
var backC;

var gA;
var gB;
var gC;

var dX;
var dY;

//頂点座標
var peakX;
var peakY;

var type;

var dFlag;

var browse;

var area;

var pnt;

var span0_0;
var span1_0;
var span1_1;

var spanID;

var spanArray;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

function loadContentHandler()
{
	try
	{
		//軸の１めもり当たりのドット数
		span = 30;
		
		cW = parseInt((540)/span) * span;
		
		cH = 18 * span;
		
		bW = cW;
		bH = cH;
		
		document.getElementById("graphBlock").style.width = cW + "px";
		document.getElementById("graphBlock").style.height = cH + "px";
		
		document.getElementById("graphCanvas").style.position = "absolute";
		
		document.getElementById("graphCanvas").style.left = -cW + "px";
		document.getElementById("graphCanvas").style.top = -cH + "px";
		
		document.getElementById("leftConfig").style.height = cH + "px";
		
		cW = cW * 3;
		cH = cH * 3;
		
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFFFFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		
		cs.addChild(bg);
		
		area = new createjs.Shape();
		cs.addChild(area);
		
		grid = new createjs.Shape();
		cs.addChild(grid);
		
		//軸の線
		base = new createjs.Shape();
		cs.addChild(base);
		
		axisX = new createjs.Shape();
		cs.addChild(axisX);
		
		axisY = new createjs.Shape();
		cs.addChild(axisY);
		
		//矢印の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		
		axisX.graphics.beginFill("#000000");
		axisX.graphics.moveTo(-20, 0);
		axisX.graphics.lineTo(-20, -4);
		axisX.graphics.lineTo(-2, 0);
		axisX.graphics.lineTo(-20, 4);
		axisX.graphics.lineTo(-20, 0);
		axisX.graphics.endFill();
		
		axisY.graphics.beginFill("#000000");
		axisY.graphics.moveTo(0, 20);
		axisY.graphics.lineTo(-4, 20);
		axisY.graphics.lineTo(0, 2);
		axisY.graphics.lineTo(4, 20);
		axisY.graphics.lineTo(0, 20);
		axisY.graphics.endFill();
		axisY.graphics.endStroke();
		
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2);
		numY = -numY.substring(0, numY.length-2);
		
		axisX.x = numX + bW;
		axisX.y = cH/2;
		
		axisY.x = cW/2;
		axisY.y = numY;
		
		//軸のテキスト
		tx = new createjs.Text("x", "italic 20px Times New Roman", "#000000");
		tx.x = cW-tx.getBounds().width-5;
		tx.y = cH/2 + 5;
		
		ty = new createjs.Text("y", "italic 20px Times New Roman", "#000000");
		ty.x = cW/2+10;
		ty.y = 2;
		
		t0 = new createjs.Text("O", "20px Times New Roman", "#000000");
		t0.x = cW/2+5;
		t0.y = cH/2+5;
		
		tA = new createjs.Text("a", "20px Times New Roman", "#000000");
		tA.x = cW/2;
		tA.y = cH/2 + 5;
		cs.addChild(tA);
		tA.visible = false;
		
		minNum = -2;
		maxNum = 3; 
		
		defMin = -2;
		defMax = 3;
		
		prevA = 1;
		prevB = -2;
		prevC = -2;
		
		type = 1;
		
		axis = new createjs.Shape();
		axis.name = "axis";
		cs.addChild(axis);
		
		//間の値
		minY = new createjs.Text("", "20px Times New Roman", "#000000");
		maxY = new createjs.Text("", "20px Times New Roman", "#000000");
		
		//式
		form0 = new createjs.Container();
		form0.name = "form0";
		changeFormulaContainer(form0, getFormulaString(false));
		
		//それぞれの頂点の座標
		lx0 = new createjs.Text("", "20px Times New Roman", "#000000");
		ly0 = new createjs.Text("", "20px Times New Roman", "#000000");
		
		cs.addChild(tx);
		cs.addChild(ty);
		cs.addChild(t0);
		cs.addChild(minY);
		cs.addChild(maxY);
		cs.addChild(form0);
		
		cs.addChild(lx0);
		cs.addChild(ly0);
		
		changeAxisPositionHandler();
		
		dotLine = new createjs.Shape();
		dotLine.name = "dotLine";
		cs.addChild(dotLine);
		
		//放物線
		line0 = new createjs.Shape();
		line0.name = "line0";
		cs.addChild(line0);
		
		line1 = new createjs.Shape();
		line1.name = "line1";
		cs.addChild(line1);
		
		pnt = new createjs.Shape();
		pnt.name = "pnt";
		cs.addChild(pnt);
		
		//Y軸の線の描画
		lineY = new createjs.Shape();
		lineY.name = "lineY";
		cs.addChild(lineY);
		
		//範囲の描画
		lineA = new createjs.Shape();
		lineA.name = "lineA";
		lineA.graphics.setStrokeStyle(4);
		lineA.graphics.beginStroke("rgba(0, 159, 232, 1)");
		lineA.graphics.moveTo(cW/2 + minNum * span, cH/2);
		lineA.graphics.lineTo(cW/2 + maxNum * span, cH/2);
		lineA.graphics.endStroke();
		
		minA = new createjs.Shape();
		minA.name = "minA";
		minA.x = cW/2 + minNum * span;
		minA.y = cH/2;
		
		maxA = new createjs.Shape();
		maxA.name = "maxA";
		maxA.x = cW/2 + maxNum * span;
		maxA.y = cH/2;
		
		cs.addChild(lineA);
		cs.addChild(minA);
		cs.addChild(maxA);
		
		minA.addEventListener("mousedown", pointDragStart);
		maxA.addEventListener("mousedown", pointDragStart);
		
		document.getElementById("formula0").innerHTML = getFormulaString(true);
		
		document.getElementById("areaX").style.display = "inline-block";
		
		$('.onBtn').css('vertical-align', 'text-bottom');
		
		document.getElementById("text0_0").value = minNum;
		document.getElementById("text0_1").value = maxNum;
		
		document.getElementById("text1_0").value = prevA;
		document.getElementById("text1_1").value = prevB;
		document.getElementById("text1_2").value = prevC;
		
		document.getElementById("check0").checked = true;
		document.getElementById("check1").checked = false;
		document.getElementById("check2").checked = true;
		document.getElementById("check3").checked = true;
		document.getElementById("check4").checked = true;
		document.getElementById("check5").checked = false;
		
		//直接設定
		document.getElementById("upBtn0_0").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn0_1").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn1_0").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn1_1").addEventListener("click", changeDataHandler);
		document.getElementById("upBtn1_2").addEventListener("click", changeDataHandler);
		
		document.getElementById("downBtn0_0").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn0_1").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn1_0").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn1_1").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn1_2").addEventListener("click", changeDataHandler);
		
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		document.getElementById("check4").addEventListener("change", changeCheckHandler);
		document.getElementById("check5").addEventListener("change", changeCheckHandler);
		
		document.getElementById("onBtn0_0").style.marginTop = "5px";
		document.getElementById("onBtn0_1").style.marginTop = "5px";
		document.getElementById("onBtn1_0").style.marginTop = "5px";
		document.getElementById("onBtn1_1").style.marginTop = "5px";
		
		document.getElementById("onBtn0_0").style.display = "inline-block";
		document.getElementById("onBtn1_0").style.display = "inline-block";
		document.getElementById("onBtn0_1").style.display = "none";
		document.getElementById("onBtn1_1").style.display = "none";
		
		document.getElementById("onBtn0_0").addEventListener("click", changeSymbolHandler);
		document.getElementById("onBtn0_1").addEventListener("click", changeSymbolHandler);
		document.getElementById("onBtn1_0").addEventListener("click", changeSymbolHandler);
		document.getElementById("onBtn1_1").addEventListener("click", changeSymbolHandler);
		
		document.getElementById('optionBtn0').addEventListener('click', openOptionHandler);
		document.getElementById('optionBtn1').addEventListener('click', openOptionHandler);
		
		document.getElementById('optionClose0').addEventListener('click', closeModalHandler);
		document.getElementById('optionClose1').addEventListener('click', closeModalHandler);
		document.getElementById('optionCancel').addEventListener('click', closeModalHandler);
		document.getElementById('spanClose').addEventListener('click', closeModalHandler);
		document.getElementById('spanCancel').addEventListener('click', closeModalHandler);
		
		document.getElementById("gCheck0").checked = true;
		document.getElementById("gCheck1").checked = false;
		
		document.getElementById("gCheck0").addEventListener("change", changeCheckHandler);
		document.getElementById("gCheck1").addEventListener("change", changeCheckHandler);
		
		document.getElementById("addBtn").addEventListener("click", changeModeHandler);
		
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		
		grid.visible = false;
		$(".lineText").focus(function(){$(this).blur();});
		
		dFlag = true;
		
		cs.addEventListener("mousedown", canvasDragStart);
		
		span0_0 = 1;
		span1_0 = 1;
		
		spanArray = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		
		document.getElementById('spanDown').addEventListener('click', spanNumberChangeHandler);
		document.getElementById('spanUp').addEventListener('click', spanNumberChangeHandler);
		document.getElementById('spanBtn0_0').addEventListener('click', showSpanChangeBlock);
		document.getElementById('spanBtn1_0').addEventListener('click', showSpanChangeBlock);
		document.getElementById('spanSet').addEventListener('click', setSpanHandler);
		
		document.getElementById('compSq0').style.color = 'rgb(255, 255, 255)';
		document.getElementById('compSqBtn0').addEventListener('click', showCompletingSquare);
		
		changeCompletingSquare();
		
		drawGridHandler();
		
		changePartsHandler();
		drawGraphHandler();
		
		changeFormulaPositionHandler();
		
		setModal('optionBlock');
		setModal('optionBlock1');
		setModal('spanChange');
		
		cs.update();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function openOptionHandler(e)
{
	try
	{
		if(e.target.id == "optionBtn0")
		{
			backA = prevA;
			backB = prevB;
			backC = prevC;
			
			span1_1 = span1_0;
			
			//式の値を設定
			document.getElementById('text1_0').value = prevA;
			document.getElementById('text1_1').value = prevB;
			document.getElementById('text1_2').value = prevC;
			
			showModal('optionBlock');
		}
		else
		{
			showModal('optionBlock1');
		}
	}
	catch(e)
	{
		alert('openOptionHandler:' + e.toString());
	}
}


function showSpanChangeBlock(e)
{
	try
	{
		spanID = e.target.id;
		
		//きざみ幅の値を設定
		if(e.target.id == "spanBtn0_0")
		{
			document.getElementById('spanText').value = span0_0;
		}
		else
		{
			document.getElementById('spanText').value = span1_0;
		}
		
		showModal('spanChange');
	}
	catch(e)
	{
		alert("showSpanChangeBlock" + e.toString());
	}
}

function closeModalHandler(e)
{
	try
	{
		//オプションを閉じる
		if(e.target.id.indexOf("optionClose") != -1 || e.target.id.indexOf("optionCancel") != -1)
		{
			if(e.target.id != "optionClose1")
			{
				//値を戻す
				prevA = backA;
				prevB = backB;
				prevC = backC;

				//式の値を設定
				document.getElementById('text1_0').value = prevA;
				document.getElementById('text1_1').value = prevB;
				document.getElementById('text1_2').value = prevC;
			}
			
			closeModal();
		}
		//きざみ幅を閉じる
		else
		{
			if(spanID == "spanBtn1_0")
			{
				showModal('optionBlock');
			}
			else
			{
				closeModal();
			}
		}
	}
	catch(e)
	{
		alert('modalCloseHandler:' + e.toString());
	}
}

function setSpanHandler(e)
{
	try
	{
		var num = Number(document.getElementById('spanText').value);
		
		//最大，最小のきざみ幅の設定
		if(spanID == "spanBtn0_0")
		{
			span0_0 = num;
			
			minNum = Math.round(minNum / span0_0) * span0_0;
			maxNum = Math.round(maxNum / span0_0) * span0_0;
			
			if(minNum >= maxNum)
			{
				maxNum = minNum + span0_0;
			}
			else if(maxNum <= minNum)
			{
				maxNum = minNum + span0_0;
			}
			
			if(minNum.toString().length > 4)
			{
				minNum = Math.round(minNum * 10000)/10000;
			}
			
			
			if(maxNum.toString().length > 4)
			{
				maxNum = Math.round(maxNum * 10000)/10000;
			}
			
			document.getElementById('text0_0').value = minNum;
			document.getElementById('text0_1').value = maxNum;
			
			drawGraphHandler();
			
			cs.update();
			
			closeModal();
		}
		//式の刻み幅を変更
		else
		{
			span1_1 = num;
		
			var n = Math.round(prevA/span1_1);
			
			if(n == 0)
			{
				if(prevA > 0)
				{
					prevA = span1_1;
				}
				else
				{
					prevA = -span1_1;
				}
			}
			else
			{
				prevA = n * span1_1;
			}
			
			prevB = Math.round(prevB/span1_1) * span1_1;
			prevC = Math.round(prevC/span1_1) * span1_1;
			
			if(prevA.toString().length > 4)
			{
				prevA = Math.round(prevA * 10000)/10000;
			}
			
			if(prevB.toString().length > 4)
			{
				prevB = Math.round(prevB * 10000)/10000;
			}
			
			if(prevC.toString().length > 4)
			{
				prevC = Math.round(prevC * 10000)/10000;
			}
			
			document.getElementById('text1_0').value = prevA;
			document.getElementById('text1_1').value = prevB;
			document.getElementById('text1_2').value = prevC;
			
			showModal('optionBlock');
		}
	}
	catch(e)
	{
		alert('setSpanHandler:' + e.toString());
	}
}

function spanNumberChangeHandler(e)
{
	try
	{
		var id = spanArray.indexOf(Number(document.getElementById('spanText').value));
		
		if(e.target.id == "spanDown")
		{
			if(id != 0)
			{
				id -= 1;
				
				document.getElementById('spanText').value = spanArray[id];
			}
		}
		else
		{
			if(id < 6)
			{
				id += 1;
				
				document.getElementById('spanText').value = spanArray[id];
			}
		}
	}
	catch(e)
	{
		alert('spanNumberChangeHandler:' + e.toString());
	}
}


function showCompletingSquare(e)
{
	try
	{
		var n = e.target.id.substring(e.target.id.length-1, e.target.id.length);
		
		if(document.getElementById('compSq'+n).style.color == 'rgb(255, 255, 255)')
		{
			document.getElementById('compSq'+n).style.color = 'rgb(0, 0, 0)';
		}
		else
		{
			document.getElementById('compSq'+n).style.color = 'rgb(255,255,255)';
		}
	}
	catch(e)
	{
		alert("showCompletingSquare:" + e.toString());
	}
}

function changeModeHandler(e)
{
	try
	{
		if(e.target.id == "changeBtn")
		{
			document.getElementById("windowBlock").style.display = "none";
			//document.getElementById("formulaConfig").style.display = "block";
		}
		else
		{
			if(checkInput())
			{
				span0_0 = 1;
				
				span1_0 = span1_1;
				
				//状態を戻す
				minNum = defMin;
				maxNum = defMax;
				
				document.getElementById("text0_0").value = minNum;
				document.getElementById("text0_1").value = maxNum;
				
				document.getElementById("onBtn0_0").style.display = "inline-block";
				document.getElementById("onBtn0_1").style.display = "none";
				document.getElementById("onBtn1_0").style.display = "inline-block";
				document.getElementById("onBtn1_1").style.display = "none";
				
				document.getElementById("gCheck0").checked = true;
				document.getElementById("gCheck1").checked = false;
				
				document.getElementById("formula0").innerHTML = getFormulaString(true);
				changeFormulaContainer(form0, getFormulaString(false));
				
				changeCompletingSquare();
				
				document.getElementById("compSq0").style.color = 'rgb(255, 255, 255)';
				
				//
				changePartsHandler();
				
				drawGraphHandler();
				
				changeFormulaPositionHandler();
				
				cs.update();
				
				closeModal();
			}
			else
			{
				alert("-9～9(x²の係数は0以外)の値を入力してください。");
			}
		}
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}

function changeSymbolHandler(e)
{
	try
	{
		if(e.target.id == "onBtn0_0" || e.target.id == "onBtn1_0")
		{
			document.getElementById("onBtn0_0").style.display = "none";
			document.getElementById("onBtn1_0").style.display = "none";
			
			document.getElementById("onBtn0_1").style.display = "inline-block";
			document.getElementById("onBtn1_1").style.display = "inline-block";
		}
		else
		{
			document.getElementById("onBtn0_0").style.display = "inline-block";
			document.getElementById("onBtn1_0").style.display = "inline-block";
			
			document.getElementById("onBtn0_1").style.display = "none";
			document.getElementById("onBtn1_1").style.display = "none";
		}
		
		if(document.getElementById("gCheck1").checked == true)
		{
			drawAreaPointHandler();
			drawGraphHandler();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeSymbolHandler:" + e.toString());
	}
}

function drawGridHandler()
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var dSpan = span * span0_0;
		
		var i;
		//横線
		for(i=cH/2; i>0; i-= dSpan)
		{
			grid.graphics.moveTo(0, i);
			grid.graphics.lineTo(cW, i);
		}
		
		for(i=cH/2; i<cH; i+= dSpan)
		{
			grid.graphics.moveTo(0, i);
			grid.graphics.lineTo(cW, i);
		}
		
		//縦線
		for(i=cW/2; i>0; i-= dSpan)
		{
			grid.graphics.moveTo(i, 0);
			grid.graphics.lineTo(i, cH);
		}
		
		for(i=cW/2; i<cW; i+= dSpan)
		{
			grid.graphics.moveTo(i, 0);
			grid.graphics.lineTo(i, cH);
		}
		
		grid.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawGridHandler:" + e.toString());
	}
}


function changeFormulaContainer(form, str)
{
	try
	{
		while(form.getNumChildren() != 0)
		{
			form.removeChild(form.getChildAt(0));
		}
		
		var yIndex = str.indexOf('y');
		var xIndex = str.indexOf('x');
		
		var tArr = str.split('x');
		
		for(var i=0; i<tArr.length; i++)
		{
			var t;
			var x;
			
			if(i==0)
			{
				var yt = new createjs.Text("y", "italic 20px Times New Roman", "#000000");
				form.addChild(yt);
				
				t = new createjs.Text(tArr[0].substring(1, tArr[0].length), "20px Times New Roman", "#000000");
				x = form.getBounds().width;
				t.x = x;
				form.addChild(t);
			}
			else
			{
				t = new createjs.Text(tArr[i].substring(0, tArr[i].length), "20px Times New Roman", "#000000");
				x = form.getBounds().width;
				t.x = x;
				form.addChild(t);
			}
			
			//後ろにxをつける
			if(i != tArr.length-1)
			{
				var xt = new createjs.Text("x", "italic 20px Times New Roman", "#000000");
				x = form.getBounds().width;
				xt.x = x;
				form.addChild(xt);
			}
		}
	}
	catch(e)
	{
		alert('changeFormulaContainer:' + e.toString());
	}
}



function changeCompletingSquare()
{
	try
	{
		var pA = prevA;
		var pB = prevB;
		var pC = prevC;
		
		//平方完成
		var p0 = prevB/(2*prevA);
		var q0 = prevC-(prevB)*(prevB)/(4*prevA);
		
		var str0 = "y=";
		
		//係数部分の設定
		var strA;
		if(pA == 1)
		{
			strA = "";
		}
		else if(pA == -1)
		{
			strA = "-";
		}
		else
		{
			strA = pA.toString();
		}
		
		//x方向の移動
		if(p0 == 0)
		{
			str0 = str0 + strA + "x²";
		}
		else if(p0 > 0)
		{
			str0 = str0 + strA + "(x+"+p0.toString()+")²"
		}
		else
		{
			str0 = str0 + strA + "(x"+p0.toString()+")²";
		}
		
		//y方向の移動
		if(q0 > 0)
		{
			str0 = str0 + "+" + q0.toString();
		}
		else if(q0 < 0)
		{
			str0 = str0 + q0.toString();
		}
		
				
		//文字の斜体用の置換
		str0 = str0.replace("y", "<span class='times'>y</span>");
		var before = "x";
		var reg = new RegExp(before, "g");
		str0 = str0.replace(reg, "<span class='times'>x</span>");
		
		document.getElementById('compSq0').innerHTML = str0;
	}
	catch(e)
	{
		alert("changeCompletingSquare:" + e.toString());
	}
}


function changeDataHandler(e)
{
	try
	{
		var id = e.target.id.substring(e.target.id.lastIndexOf("n")+1, e.target.id.length);
		
		var elm = document.getElementById("text"+id);
		
		var f = false;
		
		//数字をあげる
		if(e.target.id.indexOf("upBtn") != -1)
		{
			var num0 = Number(elm.value);
			
			if(num0 < 30)
			{
				//式のx²の係数
				if(e.target.id == "upBtn1_0" && num0 == -span1_1)
				{
					num0 = span1_1;
				}
				//最小値の設定
				else if(e.target.id == "upBtn0_0" && num0 >= maxNum-span0_0)
				{
					num0 = maxNum-span0_0;
				}
				else if(e.target.id.indexOf('0_') != -1)
				{
					num0 += span0_0;
				}
				else
				{
					num0 += span1_1;
				}
				
				if(num0.toString().length > 4)
				{
					num0 = Math.round(num0 * 10000) /10000;
				}
				
				
				switch(e.target.id)
				{
					//範囲
					case "upBtn0_0":
						minNum = num0;
						f = true;
						break;
					case "upBtn0_1":
						maxNum = num0;
						f = true;
						break;
					
					//式
					case "upBtn1_0":
						prevA = num0;
						break;
					case "upBtn1_1":
						prevB = num0;
						break;
					case "upBtn1_2":
						prevC = num0;
						break;
				}
				
				elm.value = num0;
			}
		}
		//下げる
		else
		{
			var num1 = Number(elm.value);
			
			if(num1 > -30)
			{
				//式のx²の係数
				if(e.target.id == "downBtn1_0" && num1 == span1_1)
				{
					num1 = -span1_1;
				}
				else if(e.target.id == "downBtn0_1" && num1 <= minNum+span0_0)
				{
					num1 = minNum+span0_0;
				}
				else if(e.target.id.indexOf('0_') != -1)
				{
					num1 -= span0_0;
				}
				else
				{
					num1 -= span1_1;
				}
				
				if(num1.toString().length > 4)
				{
					num1 = Math.round(num1 * 10000) /10000;
				}
				
				switch(e.target.id)
				{
					case "downBtn0_0":
						minNum = num1;
						f = true;
						break;
					case "downBtn0_1":
						maxNum = num1;
						f = true;
						break;
					
					case "downBtn1_0":
						prevA = num1;
						break;
					case "downBtn1_1":
						prevB = num1;
						break;
					case "downBtn1_2":
						prevC = num1;
						break;
				}
				
				elm.value = num1;
			}
		}
		
		if(f == true && document.getElementById("gCheck1").checked)
		{
			drawGraphHandler();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}


function drawGraphHandler()
{
	try
	{
		//グラフの描画なし
		if(document.getElementById("gCheck0").checked == false)
		{
			type = 0;
		}
		//グラフの描画あり
		else if(document.getElementById("gCheck0").checked)
		{
			//定義域なし
			if(!document.getElementById("gCheck1").checked)
			{
				type = 1;
			}
			//≦の定義域
			else if(document.getElementById("onBtn0_0").style.display == "inline-block")
			{
				type = 2;
			}
			//<の定義域
			else
			{
				type = 3;
			}
		}
			
		minA.x = cW/2 + minNum * span;
		maxA.x = cW/2 + maxNum * span;
		
		lineA.graphics.clear();
		lineA.graphics.setStrokeStyle(3);
		lineA.graphics.beginStroke("rgba(0, 159, 232, 1)");
		lineA.graphics.moveTo(cW/2 + minNum * span, cH/2);
		lineA.graphics.lineTo(cW/2 + maxNum * span, cH/2);
		lineA.graphics.endStroke();
		
		drawAreaPointHandler();
		
		drawAreaHandler();
		
		if(type != 0)
		{
			drawLine();
		}
		
		drawPeakHandler();
		
		changeTextPositionHandler();
		
		drawPointHandler();
	}
	catch(e)
	{
		alert("drawGraphHandler:" + e.toString());
	}
}

function getFormulaString(f)
{
	try
	{
		//式の設定
		var strA;
		var strB;
		var strC;
		
		if(prevA == 1)
		{
			strA = "y=x";
		}
		else if(prevA == -1)
		{
			strA = "y=-x";
		}
		else
		{
			strA = "y="+prevA+"x";
		}
		
		strA = strA + "²";
		
		
		if(prevB == 0)
		{
			strB = "";
		}
		else if(prevB > 0)
		{
			if(prevB == 1)
			{
				strB = "+"+"x";
			}
			else
			{
				strB = "+"+prevB+"x";
			}
		}
		else
		{
			if(prevB == -1)
			{
				strB = "-x";
			}
			else
			{
				strB = prevB+"x";
			}
		}
		
		if(prevC == 0)
		{
			strC = "";
		}
		else if(prevC > 0)
		{
			strC = "+"+prevC;
		}
		else
		{
			strC = prevC;
		}
		
		strA = strA + strB + strC;
		
		if(f)
		{
			//文字の斜体用の置換
			strA = strA.replace("y", "<span class='times'>y</span>");
			var before = "x";
			var reg = new RegExp(before, "g");
			strA = strA.replace(reg, "<span class='times'>x</span>");
		}
		
		return strA;
	}
	catch(e)
	{
		alert("getFormulaString:" + e.toString());
	}
}

function drawLine()
{
	try
	{
		//頂点の座標
		peakX = -prevB/(2 * prevA);
		peakY = prevC-(prevB*prevB)/(4*prevA);
		
		//軸の描画
		axis.graphics.clear();
		axis.graphics.setStrokeStyle(2);
		axis.graphics.beginStroke("rgba(234,85,9, 1)");
		axis.graphics.moveTo(cW/2 + peakX * span, 0);
		axis.graphics.lineTo(cW/2 + peakX * span, cH);
		axis.graphics.endStroke();
		
		
		//実線の描画
		line0.graphics.clear();
		line0.graphics.setStrokeStyle(2);
		line0.graphics.beginStroke("#0000000");
		
		//破線の描画
		line1.graphics.clear();
		line1.graphics.setStrokeStyle(2);
		line1.graphics.setStrokeDash([5,5], 0);
		line1.graphics.beginStroke("#0000000");
		
		var i;
		
		//初期座標
		var p = peakX;
		
		//頂点座標
		var cx = cW/2 + p * span;
		var cy = cH/2 - (prevA * (p * p) + prevB * p + prevC) * span;
		
		var f0 = false;
		var f1 = false;
		
		//
		var nx = cx;
		var ny = cy;
		
		var minX = cW/2 + minNum * span;
		var maxX = cW/2 + maxNum * span;
		
		var f;
		var startFlag = false;
		
		var tx;
		var ty;
		
		
		var num = 0.1;
		var spanD = 30;
		
		//放物線の右半分
		while(true)
		{
			nx = cW/2 + p * spanD;
			ny = cH/2 - (prevA * (p * p) + prevB * p + prevC) * spanD;
			
			if(ny < -cH*2 || ny > cH*2)
			{
				break;	
			}
			else
			{
				if(type == 1)
				{
					if(startFlag = false && f0 == false)
					{
						line0.graphics.moveTo(nx, ny);
						f0 = true;
						f1 = false;
						startFlag = true;
					}
					else
					{
						line0.graphics.lineTo(nx, ny);
					}
				}
				else if(type == 2 || type == 3)
				{
				
					f = false;
					
					//
					if(nx >= minX && nx <= maxX)
					{
						f = true;
					}	
					
					//定義域内
					if(f)
					{
						if(startFlag == false && f0 == false)
						{
							
							line0.graphics.moveTo(nx, ny);
							f0 = true;
							f1 = false;
							startFlag = true;
						}
						else
						{
							line0.graphics.lineTo(nx, ny);
							
							tx = cW/2 + (p + num) * spanD;
							ty = cH/2 - (prevA * ((p + num) * (p + num)) + prevB * (p + num) + prevC) * spanD;
							
							if(tx < minX || tx > maxX)
							{
								line1.graphics.moveTo(nx, ny);
								f0 = false;
								f1 = true;
							}
						}
					}
					//定義域外
					else
					{
						if(startFlag == false && f1 == false)
						{
							line1.graphics.moveTo(nx, ny);
							f0 = false;
							f1 = true;
							startFlag = true;
						}
						else
						{
							line1.graphics.lineTo(nx, ny);
							
							tx = cW/2 + (p + num) * spanD;
							ty = cH/2 - (prevA * ((p + num) * (p + num)) + prevB * (p + num) + prevC) * spanD;
							
							if(tx >= minX && tx <= maxX)
							{
								line1.graphics.lineTo(tx, ty);
								line0.graphics.moveTo(tx, ty);
								f0 = true;
								f1 = false;
							}
						}
					}
				}
				
				p += num;
			}
		}
		
		startFlag = false;
		
		f0 = false;
		f1 = false;
		
		p = peakX;
		cx = cW/2 + p * span;
		cy = cH/2 - (prevA * (p * p) + prevB * p + prevC) * spanD;
		
		//放物線の左半分
		while(true)
		{
			p -= num;
			nx = cW/2 + p * spanD;
			ny = cH/2 - (prevA * (p * p) + prevB * p + prevC) * spanD;
			
			if(ny < -cH*2 || ny > cH*2)
			{
				break;
			}
			else
			{
				if(type == 1)
				{
					if(startFlag == false && f0 == false)
					{
						line0.graphics.moveTo(cx, cy);
						f0 = true;
						f1 = false;
						startFlag = true;
					}
					
					line0.graphics.lineTo(nx, ny);
				}
				else if(type == 2 || type == 3)
				{
					//定義領域内
					f = false;
					
					//
					if(nx >= minX && nx <= maxX)
					{
						f = true;
					}
					
					if(f)
					{
						if(startFlag == false && f0 == false)
						{
							line0.graphics.moveTo(cx, cy);
							f0 = true;
							f1 = false;
							startFlag = true;
						}
						
						line0.graphics.lineTo(nx, ny);
						
						tx = cW/2 + (p - num) * spanD;
						ty = cH/2 - (prevA * ((p - num) * (p - num)) + prevB * (p - num) + prevC) * spanD;
						
						if(tx < minX || tx > maxX)
						{
							line1.graphics.moveTo(nx, ny);
							f0 = false;
							f1 = true;
						}
					}
					else
					{
						if(startFlag == false && f1 == false)
						{
							line1.graphics.moveTo(cx, cy);
							f0 = false;
							f1 = true;
							startFlag = true;
						}
						
						line1.graphics.lineTo(nx, ny);
						
						tx = cW/2 + (p - num) * spanD;
						ty = cH/2 - (prevA * ((p - num) * (p - num)) + prevB * (p - num) + prevC) * spanD;
						
						if(tx >= minX && tx <= maxX)
						{
							line1.graphics.lineTo(tx, ty);
							line0.graphics.moveTo(tx, ty);
							f0 = true;
							f1 = false;
						}
					}
				}
			}
		}
		
		line0.graphics.endStroke();
		line1.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawLine:" + e.toString());
	}
}


function checkInput()
{
	try
	{
		var f = true;
		
		var str0 = document.getElementById("text1_0").value;
		var str1 = document.getElementById("text1_1").value;
		var str2 = document.getElementById("text1_2").value;
		
		//入力内容が正しくない場合
		if(str0.match(/^[-]?[0-9]?$/) == "" || str1.match(/^[-]?[0-9]?$/) == "" || str2.match(/^[-]?[0-9]?$/) == "")
		{
			f = false;
			return f;
		}
		
		if(document.getElementById("text1_0").value == "" || document.getElementById("text1_0").value == "0")
		{
			f = false;
			
			return f;
		}
		
		if(document.getElementById("text1_1").value == "")
		{
			f = false;
			
			return f;
		}
		
		if(document.getElementById("text1_2").value == "")
		{
			f = false;
			
			return f;
		}
		
		return f;
	}
	catch(e)
	{
		alert("checkInput:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		//グラフの再描画
		if(e.target.id=="gCheck0" || e.target.id == "gCheck1")
		{
			//グラフ
			if(e.target.id == "gCheck0" && !document.getElementById("gCheck0").checked)
			{
				if(document.getElementById("gCheck1").checked)
				{
					document.getElementById("gCheck1").checked = false;
				}
				
				pnt.graphics.clear();
				changePartsHandler();
				cs.update();
			}
			else
			{
				if(e.target.id == "gCheck1" && document.getElementById("gCheck1").checked && !document.getElementById("gCheck0").checked)
				{
					document.getElementById("gCheck0").checked = true;
				}
				
				changePartsHandler();
				
				drawGraphHandler();
				cs.update();
			}
		}
		else
		{
			changePartsHandler();
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

function changePartsHandler()
{
	try
	{
		//頂点座標
		if(document.getElementById("gCheck0").checked && document.getElementById("check0").checked)
		{
			if(lx0.text == "0")
			{
				lx0.visible = false;
			}
			else
			{
				lx0.visible = true;
			}
			
			if(ly0.text == "0")
			{
				ly0.visible = false;
			}
			else
			{
				ly0.visible = true;
			}
			
			dotLine.visible = true;
		}
		else
		{
			lx0.visible = false;
			ly0.visible = false;
			
			dotLine.visible = false;
		}
		
		//軸
		if(document.getElementById("gCheck0").checked && document.getElementById("check1").checked)
		{
			axis.visible = true;
		}
		else
		{
			axis.visible = false;
		}
		
		
		//式表示
		if(document.getElementById("gCheck0").checked && document.getElementById("check2").checked)
		{
			form0.visible = true;
		}
		else
		{
			form0.visible = false;
		}
		
		//最大値
		if(document.getElementById("gCheck1").checked && document.getElementById("check3").checked)
		{
			maxY.visible = true;
		}
		else
		{
			maxY.visible = false;
		}
		
		//最小値
		if(document.getElementById("gCheck1").checked && document.getElementById("check4").checked)
		{
			minY.visible = true;
		}
		else
		{
			minY.visible = false;
		}
		
		//
		if(document.getElementById("gCheck0").checked)
		{
			line0.visible = true;
			line1.visible = true;
		}
		else
		{
			line0.visible = false;
			line1.visible = false;
		}
		
		
		//定義域の表示
		if(document.getElementById("gCheck1").checked == true)
		{
			area.visible = true;
			minA.visible = true;
			maxA.visible = true;
			lineA.visible = true;
			
			lineY.visible = true;
		}
		else
		{
			area.visible = false;
			minA.visible = false;
			maxA.visible = false;
			lineA.visible = false;
			
			lineY.visible = false;
		}
		
		grid.visible = document.getElementById("check5").checked;
	}
	catch(e)
	{
		alert("changePartsHandler:" + e.toString());
	}
}

//頂点の描画
function drawPeakHandler()
{
	try
	{
		dotLine.graphics.clear();
		
		dotLine.graphics.setStrokeStyle(1);
		dotLine.graphics.beginStroke("#000000");
		dotLine.graphics.setStrokeDash([5, 5], 0);
		
		//line0のx
		dotLine.graphics.moveTo(cW/2 + peakX * span, cH/2);
		dotLine.graphics.lineTo(cW/2 + peakX * span, cH/2 - (prevA * (peakX * peakX) + prevB * peakX + prevC)*span);
		dotLine.graphics.lineTo(cW/2, cH/2 - (prevA * (peakX * peakX) + prevB * peakX + prevC)*span);
		
		dotLine.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawPeakHandler:" + e.toString());
	}
}

function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(axisX.x-2, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, axisY.y+2);
		base.graphics.lineTo(cW/2, cH);
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}


function changeTextPositionHandler()
{
	try
	{
		lx0.text = Math.round(peakX*10)/10;
		ly0.text = Math.round(peakY*10)/10;
		
		if(document.getElementById("gCheck0").checked)
		{
			if(lx0.text == "0")
			{
				lx0.visible = false;
			}
			else
			{
				lx0.visible = true;
			}
			
			if(ly0.text == "0")
			{
				ly0.visible = false;
			}
			else
			{
				ly0.visible = true;
			}
		}
		
		lx0.x = cW/2 + peakX * span - lx0.getBounds().width/2;
		lx0.y = cH/2+5;
		
		if(lx0.x >= cW/2)
		{
			ly0.x = cW/2-5 - ly0.getBounds().width;
		}
		else
		{
			ly0.x = cW/2+5;
		}
		
		ly0.y = cH/2 - (prevA * (peakX * peakX) + prevB * peakX + prevC) * span - ly0.getBounds().height/2;
	}
	catch(e)
	{
		alert("changeTextPositionHandler:" + e.toString());
	}
}


function changeFormulaPositionHandler()
{
	try
	{
		changeParabolaFormulaPosition(form0, prevA, prevB, prevC);
	}
	catch(e)
	{
		alert("changeFormulaPositionHandler:" + e.toString());
	}
}

//数式の位置
function changeParabolaFormulaPosition(form, cA, cB, cC)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		var bounds = form.getBounds();
		
		//表示されている実グラフの座標の最大・最小
		var sX = (-p.left/cScale) / span - cW/2/span;
		var sY = -((-p.top/cScale) / span + (bH/cScale)/span - cH/2/span);
		var lX = (-p.left/cScale) / span  + (bW/cScale)/span - cW/2/span;
		var lY = -((-p.top/cScale) / span - cH/2/span);
		
		var aX;
		var aY;
		
		//数式が表示領域の中に出るかの判定
		var f = 0;
		
		//右端のグラフの座標
		var n = cA * lX * lX + cB * lX + cC;
		
		//右端にグラフの交点がある場合
		if(n >= sY && n <= lY)
		{
			aX = cW/2 + lX * span - bounds.width - 5;
			aY = cH/2 - n * span;
			
			f = 1;
		}
		
		//右端に頂点がない場合，上の限界に交点がある場合
		if(f == 0 && cB * cB - 4 * cA * (cC - lY) >= 0)
		{
			//解の公式(+)
			aX = (-cB + Math.sqrt(cB * cB - 4 * cA * (cC - lY)))/(2 * cA);
			
			if(aX < lX && aX > sX)
			{
				aY = cH/2 - lY * span + 5;
				
				if(cW/2 + aX * span + bounds.width > cW/2 + lX * span)
				{
					aX = cW/2 + aX * span - bounds.width - 5;
				}
				else
				{
					aX = cW/2 + aX * span;
				}
				
				f = 2;
			}
			
			if(f == false)
			{
				//解の公式(-)
				aX = (-cB - Math.sqrt(cB * cB - 4 * cA * (cC - lY)))/(2 * cA);
				
				if(aX<lX && aX > sX)
				{
					aY = cH/2 - lY * span + 5;
					
					if(cW/2 + aX * span + bounds.width > cW/2 + lX * span)
					{
						aX = cW/2 + aX * span - bounds.width - 5;
					}
					else
					{
						aX = cW/2 + aX * span;
					}
					
					f = 3;
				}
			}
		}
		
		//右端，上の限界に交点がない場合で，下の限界に交点がある場合
		if(f == 0 && cB * cB - 4 * cA * (cC - sY) >= 0)
		{
			aX = (-cB + Math.sqrt(cB * cB - 4 * cA * (cC - sY)))/(2 * cA);
			
			if(aX < lX && aX > sX)
			{
				aY = cH/2 - sY * span - bounds.height - 5;
				
				if(cW/2 + aX * span + bounds.width > cW/2 + lX * span)
				{
					aX = cW/2 + aX * span - bounds.width;
				}
				else
				{
					aX = cW/2 + aX * span;
				}
				
				f = 4;
			}
			
			if(f == false)
			{
				aX = (-cB - Math.sqrt(cB * cB - 4 * cA * (cC - sY)))/(2 * cA);
				
				if(aX<lX && aX > sX)
				{
					aY = cH/2 - sY * span - bounds.height - 5 ;
					
					if(cW/2 + aX * span + bounds.width > cW/2 + lX * span)
					{
						aX = cW/2 + aX * span - bounds.width;
					}
					else
					{
						aX = cW/2 + aX * span;
					}
					
					f = 5;
				}
			}
		}
		
		if(f == 0)
		{
			form.visible = false;
		}
		else
		{
			form.x = aX;
			form.y = aY;
			
			//重なっている場合はずらす
			if(form.name == "form1" && cA > 0 && checkHit(form0, form1))
			{
				form.y = aY + form0.getBounds().height;
			}
			else if(form.name == "form1" && cA < 0 && checkHit(form0, form1))
			{
				form.y = aY - form0.getBounds().height;	
			}
			
			if(form.name == "form0" && document.getElementById("gCheck0").checked)
			{
				form.visible = true;
			}
			else if(form.name == "form1" && document.getElementById("gCheck3").checked)
			{
				form.visible = true;
			}
		}
		
		cs.update();
	}
	catch(e)
	{
		alert('changeParabolaFormulaPosition:' + e.toString());
	}
}

function checkHit(obj0, obj1)
{
	try
	{
		var x0 = obj0.x;
		var y0 = obj0.y;
		var w0 = obj0.getBounds().width;
		var h0 = obj0.getBounds().height;
		var x1 = obj1.x;
		var y1 = obj1.y;
		var w1 = obj1.getBounds().width;
		var h1 = obj1.getBounds().height;
		
		if((x0 <= x1 && x0 + w0 >= x1) || (x1 <= x0 && x1 + w1 >= x0) || (x0 >= x1 && x0 + w0 <= x1 + w1) || (x1 >= x0 && x1 + w1 <= x0 + w0) )
		{
			if((y0 <= y1 && y0 + h0 >= y1) || (y1 <= y0 && y1 + h1 >= y0) || (y0 >= y1 && y0 + h0 <= y1 + h1) || (y1 >= y0 && y1 + h1 <= y0 + h0) )
			{
				return true;
			}
		}
		
		
		return false;
	}
	catch(e)
	{
		alert('checkHit:' + e.toString());
	}
}


function pointDragStart(e)
{
	try
	{
		dFlag = false;
		
		dPnt = e.target;
		
		dPnt.x = e.stageX;
		
		dPnt.addEventListener("pressmove", pointDragMove);
		
		if(browse)
		{
			document.addEventListener("touchend", pointDragStop);
		}
		else
		{
			document.addEventListener("mouseup", pointDragStop);
			document.addEventListener("mouseout", pointDragStop);
		}
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}


function pointDragMove(e)
{
	try
	{
		var pX;
		
		var f = false;
		
		var dSpan = span * span0_0;
		
		//最小値の操作の場合
		if(dPnt.name == "minA")
		{
			if(e.stageX >= maxA.x - dSpan)
			{
				dPnt.x = maxA.x - dSpan;
			}
			else
			{
				dPnt.x = e.stageX;
			}
			
			 pX = Math.round((dPnt.x - cW/2)/dSpan) * span0_0;
			
			if(document.getElementById("text0_0").value != pX)
			{
				document.getElementById("text0_0").value = pX;
				minNum = pX;
				f = true;
			}
		}
		//最大値の操作の場合
		else
		{
			if(e.stageX <= minA.x + dSpan)
			{
				dPnt.x = minA.x + dSpan;
			}
			else
			{
				dPnt.x = e.stageX;
			}
			
			pX = Math.round((dPnt.x - cW/2)/dSpan) * span0_0;
			
			if(document.getElementById("text0_1").value != pX)
			{
				document.getElementById("text0_1").value = pX;
				maxNum = pX;
				f = true;
			}
		}
		
		drawAreaLineHandler();
		drawAreaHandler();
		
		//範囲の描画が変わったとき
		if(f)
		{
			
			drawLine();
			drawPointHandler();
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}


function pointDragStop(e)
{
	try
	{
		dFlag = true;
		
		dPnt.removeEventListener("pressmove", pointDragMove);
		
		if(browse)
		{
			document.removeEventListener("touchend", pointDragStop);
		}
		else
		{
			document.removeEventListener("mouseup", pointDragStop);
			document.removeEventListener("mouseout", pointDragStop);
		}
		
		var dSpan = span * span0_0;
		
		//spanの位置に吸着
		dPnt.x = Math.round(dPnt.x/dSpan) * dSpan;
		
		var pX = Math.round((dPnt.x - cW/2)/dSpan) * span0_0;
		
		var f = false;
		
		if(dPnt.name == "minA" && document.getElementById("text0_0").value != pX)
		{
			minNum = pX;
			f = true;	
		}
		else if(dPnt.name == "maxA" && document.getElementById("text0_1").value != pX)
		{
			maxNum = pX;
			f = true;
		}
		
		if(dPnt.name == "minA")
		{
			minA.x = cW/2 + minNum * span;
		}
		else
		{
			maxA.x = cW/2 + maxNum * span;
		}
		
		drawAreaLineHandler();
		drawAreaHandler();
		
		if(f)
		{
			
			drawLine();
			drawPointHandler();
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}


var prevX;
var prevY;

function canvasDragStart(e)
{
	if(dFlag)
	{
		prevX = e.stageX;
		prevY = e.stageY;
		
		if(ictMode)
		{
			$(window).on("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchend', dragStop);
		}
		else
		{
			document.addEventListener('mouseup', dragStop);
		}
		
		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

function canvasDragMove(e)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		var sX = e.stageX - prevX;
		var sY = e.stageY - prevY;
		
		var limitX = cW * 1/3 - cW * cScale;
		var limitY = cH * 1/3 - cH * cScale;
		
		//Xの差分移動
		if(p.left + sX >= 0)
		{
			document.getElementById("graphCanvas").style.left = "0px";
			
			prevX = e.stageX;
		}
		else if(p.left + sX <= limitX)
		{
			document.getElementById("graphCanvas").style.left = limitX + "px";
			
			prevX = e.stageX;
		}
		else
		{
			document.getElementById("graphCanvas").style.left = (p.left + sX) + "px";
		}
		
		//Yの差分移動
		if(p.top + sY >= 0)
		{
			document.getElementById("graphCanvas").style.top = "0px";
			
			prevY = e.stageY;
		}
		else if(p.top + sY <= limitY)
		{
			document.getElementById("graphCanvas").style.top = limitY + "px";
			
			prevY = e.stageY;
		}
		else
		{
			document.getElementById("graphCanvas").style.top = (p.top + sY) + "px";
		}
		
		changeAxisPositionHandler();
		cs.update();
	}
	catch(e)
	{
		alert("canvasDragMove:" + e.toString());
	}
		
}

function canvasDragStop(e)
{
	e.currentTarget.removeEventListener("pressmove", canvasDragMove);
	e.currentTarget.removeEventListener("pressup", canvasDragStop);
}

function dragStop(e)
{
	try
	{
		//式の位置を移動
		changeFormulaPositionHandler();
		
		if(ictMode)
		{
			$(winodw).off("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchend', dragStop);
		}
		else
		{
			document.removeEventListener('mouseup', dragStop);
		}
	}
	catch(e)
	{
		alert(e.toString());	
	}
}


function drawAreaHandler()
{
	try
	{
		area.graphics.clear();
		area.graphics.beginFill("#FDE9BC");
		
		//area.graphics.drawRect(cW/2 + minNum * span, 0, (maxNum - minNum) * span, cH);
		area.graphics.drawRect(minA.x, 0, maxA.x - minA.x, cH);
		
		area.graphics.endFill();
	}
	catch(e)
	{
		alert("drawAreaHandler:" + e.toString());
	}
}

function drawYLineHandler(y0, y1, t)
{
	try
	{
		lineY.graphics.clear();
		
		lineY.graphics.beginStroke("rgba(255, 119, 0, 1)");
		lineY.graphics.setStrokeStyle(4);
		lineY.graphics.moveTo(cW/2, y0);
		lineY.graphics.lineTo(cW/2, y1);
		lineY.graphics.endStroke();
		
		
		lineY.graphics.beginStroke("rgba(255, 119, 0, 1)");
		lineY.graphics.setStrokeStyle(2);
		
		var centerX = cW/2;
		
		var cStr;
		
		if(t == 2)
		{
			cStr = "rgba(255, 119, 0, 1)";
			
		}
		else if(t == 3)
		{
			cStr = "rgba(255, 255, 255, 1)";
		}
		
		var pX = cW/2 + span * (-prevB/2) * prevA;
		var dSpan = span * span0_0;
		var minX;
		var maxX;
		
		if(dFlag)
		{
			minX = minA.x;
			maxX = maxA.x;
		}
		//ドラッグ中
		else
		{
			if(dPnt.name == "minA")
			{
				minX = cW/2 + Math.round((minA.x - centerX)/dSpan) * dSpan;
				maxX = maxA.x;
			}
			else
			{
				minX = minA.x;
				maxX = cW/2 + Math.round((maxA.x - centerX)/dSpan) * dSpan;
			}
		}
		
		//頂点が範囲に含まれる場合
		if(t==3　&& pX > minX && pX < maxX)
		{
			//下に凸
			if(prevA > 0)
			{
				lineY.graphics.beginFill("rgba(255, 119, 0, 1)");
				lineY.graphics.drawCircle(cW/2, y0, 4);
				lineY.graphics.endFill();

				lineY.graphics.beginFill("rgba(255, 255, 255, 1)");
				lineY.graphics.drawCircle(cW/2, y1, 4);
				lineY.graphics.endFill();
			}
			//上に凸
			else
			{
				lineY.graphics.beginFill("rgba(255, 119, 0, 1)");
				lineY.graphics.drawCircle(cW/2, y1, 4);
				lineY.graphics.endFill();

				lineY.graphics.beginFill("rgba(255, 255, 255, 1)");
				lineY.graphics.drawCircle(cW/2, y0, 4);
				lineY.graphics.endFill();
			}
		}
		else
		{
			lineY.graphics.beginFill(cStr);
			lineY.graphics.drawCircle(cW/2, y0, 4);
			lineY.graphics.endFill();

			lineY.graphics.beginFill(cStr);
			lineY.graphics.drawCircle(cW/2, y1, 4);
			lineY.graphics.endFill();
		}
		
		lineY.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawYLineHandler:" + e.toString());
	}
}

function drawAreaLineHandler()
{
	try
	{
		lineA.graphics.clear();
		lineA.graphics.setStrokeStyle(4);
		lineA.graphics.beginStroke("rgba(0, 159, 232, 1)");
		lineA.graphics.moveTo(minA.x, cH/2);
		lineA.graphics.lineTo(maxA.x, cH/2);
		lineA.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawAreaLineHandler:" + e.toString());
	}
}

function drawAreaPointHandler()
{
	try
	{
		minA.graphics.clear();
		maxA.graphics.clear();
		
		if(document.getElementById("onBtn0_0").style.display == "inline-block")
		{
			minA.graphics.beginFill("rgba(255, 255, 255, 0.05)");
			minA.graphics.drawCircle(0, 0, 15);
			minA.graphics.endFill();
			
			minA.graphics.setStrokeStyle(2);
			minA.graphics.beginStroke("rgba(0, 159, 232, 1)");
			minA.graphics.beginFill("rgba(0, 159, 232, 1)");
			minA.graphics.drawCircle(0, 0, 4);
			minA.graphics.endFill();
			
			maxA.graphics.beginFill("rgba(255, 255, 255, 0.05)");
			maxA.graphics.drawCircle(0, 0, 15);
			maxA.graphics.endFill();
			
			maxA.graphics.setStrokeStyle(2);
			maxA.graphics.beginStroke("rgba(0, 159, 232, 1)");
			maxA.graphics.beginFill("rgba(0, 159, 232, 1)");
			maxA.graphics.drawCircle(0, 0, 4);
			maxA.graphics.endFill();
		}
		else
		{
			minA.graphics.beginFill("rgba(255, 255, 255, 0.05)");
			minA.graphics.drawCircle(0, 0, 15);
			minA.graphics.endFill();
			
			minA.graphics.setStrokeStyle(2);
			minA.graphics.beginStroke("rgba(0, 159, 232, 1)");
			minA.graphics.beginFill("rgba(255, 255, 255, 1)");
			minA.graphics.drawCircle(0, 0, 4);
			minA.graphics.endFill();
			minA.graphics.endStroke();
			
			maxA.graphics.beginFill("rgba(255, 255, 255, 0.05)");
			maxA.graphics.drawCircle(0, 0, 15);
			maxA.graphics.endFill();
			
			maxA.graphics.setStrokeStyle(2);
			maxA.graphics.beginStroke("rgba(0, 159, 232, 1)");
			maxA.graphics.beginFill("rgba(255, 255, 255, 1)");
			maxA.graphics.drawCircle(0, 0, 4);
			maxA.graphics.endFill();
		}
	}
	catch(e)
	{
		alert("drawAreaPointHandler:" + e.toString());
	}
}

function drawPointHandler()
{
	try
	{
		//定義域の最大値と最小値での座標
		var minX = cW/2 + minNum * span;
		var py0 = cH/2 - (prevA * minNum * minNum + prevB * minNum + prevC) * span; 
		
		var maxX = cW/2 + maxNum * span;
		var py1 = cH/2 - (prevA * maxNum * maxNum + prevB * maxNum + prevC) * span;
		
		//頂点座標
		var pX = cW/2 + peakX * span;
		var pY = cH/2 - (prevA * (peakX * peakX) + prevB * peakX + prevC) * span;
		
		//最小の値の座標
		var x0;
		var y0;
		//最大の値の座標
		var x1;
		var y1;
		
		var inFlag = false;
		var areaFlag = false;
		
		/*Y軸座標に注意*/
		
		//頂点を範囲に含む場合
		if(minX <= pX && maxX >= pX)
		{
			y1 = Math.min(py0, py1, pY);
			y0 = Math.max(py0, py1, pY);
			
			areaFlag = true;
		}
		else
		{
			if(py0 > py1)
			{
				y1 = py1;
				y0 = py0;
			}
			else
			{
				y1 = py0;
				y0 = py1;
			}
		}
		
		var sameFlag = 0;
		
		//最小値
		if(y0 == py0)
		{
			x0 = minX;
			
			if(areaFlag == true && y0 == py1)
			{
				sameFlag = 1;
			}
		}
		else if(y0 == py1)
		{
			x0 = maxX;
		}
		else
		{
			x0 = pX;
		}
		
		//最大値
		if(y1 == py0)
		{
			x1 = minX;
			
			if(areaFlag == true && y1 == py1)
			{
				sameFlag = 2;
			}
		}
		else if(y1 == py1)
		{
			x1 = maxX;
		}
		else
		{
			x1 = pX;
		}
		
		minY.text = Math.round((cH/2-y0)/span * 10) / 10;
		maxY.text = Math.round((cH/2-y1)/span * 10) / 10;
		
		if(x0 >= cW/2)
		{
			minY.x = cW/2 - 5 - minY.getBounds().width;
		}
		else
		{
			minY.x = cW/2 + 5;
		}
		
		if(x1 >= cW/2)
		{
			maxY.x = cW/2 - 5 - maxY.getBounds().width;
		}
		else
		{
			maxY.x = cW/2 + 5;
		}
		
		minY.y = y0 - minY.getBounds().height/2;
		maxY.y = y1 - maxY.getBounds().height/2;
		//テキストの設定ここまで
		
		pnt.graphics.clear();
		
		if(type == 2 || type == 3)
		{
			pnt.graphics.setStrokeStyle(1);
			pnt.graphics.beginStroke("#000000");
			pnt.graphics.setStrokeDash([5, 5], 0);
			
			if(sameFlag == 1)
			{
				pnt.graphics.moveTo(x0, cH/2);
				pnt.graphics.lineTo(x0, y0);
				pnt.graphics.lineTo(maxX, y0);
				pnt.graphics.lineTo(maxX, cH/2);
			}
			else if(sameFlag == 2)
			{
				pnt.graphics.moveTo(x1, cH/2);
				pnt.graphics.lineTo(x1, y1);
				pnt.graphics.lineTo(maxX, y1);
				pnt.graphics.lineTo(maxX, cH/2);
			}
			else
			{
				pnt.graphics.moveTo(x0, cH/2);
				pnt.graphics.lineTo(x0, y0);
				pnt.graphics.lineTo(cW/2, y0);
				
				pnt.graphics.moveTo(x1, cH/2);
				pnt.graphics.lineTo(x1, y1);
				pnt.graphics.lineTo(cW/2, y1);
			}
			
			pnt.graphics.setStrokeStyle(2);
			pnt.graphics.setStrokeDash(null);
			
			if(type == 2)
			{
				pnt.graphics.beginFill("#000000");
				pnt.graphics.drawCircle(minX, py0, 3);
				pnt.graphics.endFill();
				
				pnt.graphics.beginFill("#000000");
				pnt.graphics.drawCircle(maxX, py1, 3);
				pnt.graphics.endFill();
			}
			else if(type == 3)
			{
				pnt.graphics.beginFill("#FFFFFF");
				pnt.graphics.drawCircle(minX, py0, 3);
				pnt.graphics.endFill();
				
				pnt.graphics.beginFill("#FFFFFF");
				pnt.graphics.drawCircle(maxX, py1, 3);
				pnt.graphics.endFill();
			}
			
			drawYLineHandler(y0, y1, type);
		}
		
		pnt.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawPointHandler:" + e.toString());
	}
}


function saveContent()
{
	try
	{
		var array = [];
		
		if($("#windowBlock").css('display') == "block")
		{
			array[0] = true;
		}
		else
		{
			array[0] = false;
		}
		
		array[1] = [];
		array[1][0] = document.getElementById("gCheck0").checked;
		array[1][1] = document.getElementById("gCheck1").checked;
		
		array[2] = [];
		array[2][0] = minNum;
		array[2][1] = maxNum;
		
		array[3] = [];
		array[3][0] = prevA;
		array[3][1] = prevB;
		array[3][2] = prevC;
		
		array[4] = [];
		array[4][0] = document.getElementById("check0").checked;
		array[4][1] = document.getElementById("check1").checked;
		array[4][2] = document.getElementById("check2").checked;
		array[4][3] = document.getElementById("check3").checked;
		array[4][4] = document.getElementById("check4").checked;
		array[4][5] = document.getElementById("check5").checked;
		
		if(document.getElementById("onBtn0_0").style.display == "inline-block")
		{
			array[5] = true;
		}
		else
		{
			array[5] = false;
		}
		
		array[6] = [];
		array[6][0] = span0_0;
		array[6][1] = span1_0;
		
		if(document.getElementById("compSq0").style.color == 'rgb(255, 255, 255)')
		{
			array[7] = false;
		}
		else
		{
			array[7] = true;
		}
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		if(array[0])
		{
			document.getElementById("windowBlock").style.display = "block";
			//document.getElementById("formulaConfig").style.display = "none";
		}
		else
		{
			document.getElementById("windowBlock").style.display = "none";
			//document.getElementById("formulaConfig").style.display = "block";
		}
		
		document.getElementById("gCheck0").checked = array[1][0];
		document.getElementById("gCheck1").checked = array[1][1];
		
		minNum = array[2][0];
		maxNum = array[2][1];
		
		document.getElementById("text0_0").value = minNum;
		document.getElementById("text0_1").value = maxNum;
		
		prevA = array[3][0];
		prevB = array[3][1];
		prevC = array[3][2];
		
		document.getElementById("text1_0").value = prevA;
		document.getElementById("text1_1").value = prevB;
		document.getElementById("text1_2").value = prevC;
		
		document.getElementById("check0").checked = array[4][0];
		document.getElementById("check1").checked = array[4][1];
		document.getElementById("check2").checked = array[4][2];
		document.getElementById("check3").checked = array[4][3];
		document.getElementById("check4").checked = array[4][4];
		document.getElementById("check5").checked = array[4][5];
		
		if(array[5])
		{
			document.getElementById("onBtn0_0").style.display = "inline-block";
			document.getElementById("onBtn1_0").style.display = "inline-block";
			document.getElementById("onBtn0_1").style.display = "none";
			document.getElementById("onBtn1_1").style.display = "none";
		}
		else
		{
			document.getElementById("onBtn0_0").style.display = "none";
			document.getElementById("onBtn1_0").style.display = "none";
			document.getElementById("onBtn0_1").style.display = "inline-block";
			document.getElementById("onBtn1_1").style.display = "inline-block";
		}
		
		span0_0 = array[6][0];
		span1_0 = array[6][1];
		
		if(array[7])
		{
			document.getElementById("compSq0").style.color = 'rgb(0, 0, 0)';
		}
		else
		{
			document.getElementById("compSq0").style.color = 'rgb(255, 255, 255)';
		}
		
		document.getElementById("formula1").innerHTML = getFormulaString(true);
		changeFormulaContainer(form0, getFormulaString(false));
		
		changeCompletingSquare();
		
		//チェック項目ごとの要素の表示
		changePartsHandler();
		
		//グラフの描画
		drawGraphHandler();
		
		changeFormulaPositionHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		document.getElementById("gCheck0").checked = true;
		document.getElementById("gCheck1").checked = false;
		
		document.getElementById('check0').checked = true;
		document.getElementById('check1').checked = false;
		document.getElementById('check2').checked = true;
		document.getElementById('check3').checked = true;
		document.getElementById('check4').checked = true;
		document.getElementById('check5').checked = false;
		
		document.getElementById("onBtn0_0").style.display = "inline-block";
		document.getElementById("onBtn1_0").style.display = "inline-block";
		document.getElementById("onBtn0_1").style.display = "none";
		document.getElementById("onBtn1_1").style.display = "none";
		
		minNum = defMin;
		maxNum = defMax;
		
		document.getElementById("text0_0").value = minNum;
		document.getElementById("text0_1").value = maxNum;
		
		prevA = 1;
		prevB = -2;
		prevC = -2;
		
		document.getElementById("text1_0").value = prevA;
		document.getElementById("text1_1").value = prevB;
		document.getElementById("text1_2").value = prevC;
		
		document.getElementById("formula0").innerHTML = getFormulaString(true);
		changeFormulaContainer(form0, getFormulaString(false));
		
		span0_0 = 1;
		span1_0 = 1;
		
		document.getElementById('compSq0').style.color = 'rgb(255, 255, 255)';
		
		changeCompletingSquare();
		
		//チェック項目ごとの要素の表示
		changePartsHandler();
		
		//グラフの描画
		drawGraphHandler();
		
		changeFormulaPositionHandler();
		
		cs.update();
		
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}


