// JavaScript Document
/*
162_001のコードを流用
*/

var cc;
var cs;

var cW;
var cH;

var minSp;
var maxSp;
var centerSp;
var qSp1;
var qSp3;

var minBox;
var maxBox;
var centerBox;
var q1Box;
var q3Box;

var textArray;

var box;

var cont;

var base;

var span;

var widthArray;
var arrowArray;

var baseData;

var backData;

var textBlock;

var sampleType;

var sample1;
var sample2;
var sample3;
var sample4;

var ap0;
var ap1;
var ap2;
var ap3;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 680;
}

function loadContentHandler()
{
	try
	{
		cW = 900;
		cH = 400;
		
		span = 10;
		
		document.getElementById("contentCanvas").width = cW;
		document.getElementById("contentCanvas").height = cH;
		
		document.getElementById("content").style.marginLeft = "10px";
		
		
		document.getElementById("contentCanvas").style.border = "1px solid #000000";
		document.getElementById("contentCanvas").style.marginBottom = "10px";
		
		document.getElementById("check0").checked = true;
		document.getElementById("check1").checked = true;
		
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		
		//Ａ版162ページのデータ
		baseData =[3, 10, 7, 14, 5, 9, 15, 0, 13, 18, 0, 8, 11, 10, 15, 19, 6, 23, 9, 5];
		
		//S版166ページのデータ
		//baseData =[7, 3, 6, 4, 8, 7, 7, 5, 7, 6, "", "", "", "", "", "", "", "", "", ""];
		
		//O版132ページのデータ
		//baseData =[5, 3, 6, 5, 6, 7, 8, 7, 8, 10, "", "", "", "", "", "", "", "", "", ""];
		
		//サンプル
		sample1 = [0,1,3,3,4,6,7,7,8,9,9,9,10,11,12,12,12,13,13,14,15,15,16,17,18,19,20,22,23,24];
		
		sample2 = [0,4,4,5,5,5,5,6,6,6,7,7,7,7,8,8,9,9,9,10,10,11,12,13,14,15,16,18,21,24];
		
		sample3 = [0,5,7,8,9,10,12,13,14,16,16,17,17,17,18,18,18,19,19,20,20,20,20,21,21,22,22,22,23,24];
		
		sample4 = [0,0,0,0,1,1,2,2,4,4,5,5,6,7,10,13,18,19,20,21,22,22,23,24,24,24,24,24,24,24];
		
		var i;
		for(i=0; i<30; i++)
		{
			if(i<baseData.length)
			{
				document.getElementById("c"+i).value = baseData[i];
			}
			else
			{
				document.getElementById("c"+i).value = "";
			}
			
			document.getElementById("c"+i).addEventListener("input", inputChangeHandler);
		}
		
		backData = getDataHandler(false);
		
		base = new createjs.Shape();
		base.name = "base";
		cs.addChild(base);
		
		textBlock = new createjs.Container();
		
		//四分位などの背景
		minSp = new createjs.Shape();
		maxSp = new createjs.Shape();
		centerSp = new createjs.Shape();
		
		qSp1 = new createjs.Shape();
		qSp2 = new createjs.Shape();
		qSp3 = new createjs.Shape();
		
		textBlock.addChild(minSp);
		textBlock.addChild(maxSp);
		textBlock.addChild(centerSp);
		textBlock.addChild(qSp1);
		textBlock.addChild(qSp2);
		textBlock.addChild(qSp3);
		
		//箱ひげ図用の要素
		cont = new createjs.Container();
		cs.addChild(cont);
		
		box = new createjs.Shape();
		cont.addChild(box);
		
		minBox = new createjs.Text("", "20px Arial", "#000000");
		maxBox = new createjs.Text("", "20px Arial", "#000000");
		centerBox = new createjs.Text("", "20px Arial", "#000000");
		q1Box = new createjs.Text("", "20px Arial", "#000000");
		q3Box = new createjs.Text("", "20px Arial", "#000000");
		
		cont.addChild(minBox);
		cont.addChild(maxBox);
		cont.addChild(centerBox);
		cont.addChild(q1Box);
		cont.addChild(q3Box);
		
		cs.addChild(textBlock);
		
		//省略の記号
		ap0 = new createjs.Text("・・・・・", "20px Arial", "#000000");
		ap1 = new createjs.Text("・・・・・", "20px Arial", "#000000");
		ap2 = new createjs.Text("・・・・・", "20px Arial", "#000000");
		ap3 = new createjs.Text("・・・・・", "20px Arial", "#000000");
		ap0.y = 25;
		ap1.y = 25;
		ap2.y = 25;
		ap3.y = 25;
		textBlock.addChild(ap0);
		textBlock.addChild(ap1);
		textBlock.addChild(ap2);
		textBlock.addChild(ap3);
		
		ap0.visible = false;
		ap1.visible = false;
		ap2.visible = false;
		ap3.visible = false;
		
		textArray = [];
		for(i=0; i<30; i++)
		{
			textArray[i] = new createjs.Text("", "28px Arial", "#000000");
			textArray[i].name = "t"+ i;
			textBlock.addChild(textArray[i]);
		}
		
		widthArray = [];
		
		//ヒストグラム用の追加内容
		contH = new createjs.Container();
		cs.addChild(contH);
		
		hist = new createjs.Shape();
		contH.addChild(hist);
		
		document.getElementById("label0").style.fontSize = "1.2em";
		document.getElementById("label1").style.fontSize = "1.2em";
		
		document.getElementById('check0').checked = false;
		document.getElementById('check1').checked = false;
		
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		document.getElementById("sampleBtn1").addEventListener("click", changeSampleDataHandler);
		document.getElementById("sampleBtn2").addEventListener("click", changeSampleDataHandler);
		document.getElementById("sampleBtn3").addEventListener("click", changeSampleDataHandler);
		document.getElementById("sampleBtn4").addEventListener("click", changeSampleDataHandler);
		
		document.getElementById("sampleBtn4").style.marginRight = "40px";
		
		changeCanvasHandler();
		
		changePartsDisplayHandler();
		
		cs.update();
		
		checkVersionHandler("1.1.1");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function changeSampleDataHandler(e)
{
	try
	{
		sampleType = parseInt(e.target.id.substring(e.target.id.length-1, e.target.id.length));
		
		var i;
		if(sampleType == 1)
		{
			for(i=0; i<30; i++)
			{
				document.getElementById("c"+i).value = sample1[i];
			}
		}
		else if(sampleType == 2)
		{
			for(i=0; i<30; i++)
			{
				document.getElementById("c"+i).value = sample2[i];
			}
		}
		else if(sampleType == 3)
		{
			for(i=0; i<30; i++)
			{
				document.getElementById("c"+i).value = sample3[i];
			}
		}
		else if(sampleType == 4)
		{
			for(i=0; i<30; i++)
			{
				document.getElementById("c"+i).value = sample4[i];
			}
		}
		
		backData = getDataHandler(false);
		
		changeCanvasHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeSampleDataHandler:" + e.toString());
	}
}


function sortHandler()
{
	try
	{
		if(inputCheck())
		{
			alert("適切な数値を入力して下さい。");
			return false;
		}
		
		var i;
		
		backData = [];
		
		//並べ替える前
		for(i=0; i<30; i++)
		{
			backData[i] = document.getElementById("c"+i).value;
		}
		
		var cData = getDataHandler(true);
		
		/*
		for(i=0; i<cData.length; i++)
		{
			if(!isNaN(cData[i]))
			{
				document.getElementById("c"+i).value = cData[i];
			}
			else
			{
				document.getElementById("c"+i).value = "";
			}
		}
		*/
		
		return true;
	}
	catch(e)
	{
		alert("sortHandler:" + e.toString());
	}
}

function inputChangeHandler(e)
{
	try
	{
		displayHandler();
	}
	catch(e)
	{
		alert(e.toString());
	}
}

function inputCheck()
{
	var pattern = /^[-]?([1-9]\d*|0)(\.\d+)?$/;
	
	var f = false;
	
	//入力された値をチェック
	for(var i=0; i<30; i++)
	{
		var str = document.getElementById("c"+i).value;
		
		var r = pattern.test(str);
		
		if(str != "" && r == false)
		{
			f = true;
			break;
		}
	}
	
	return f;
}

function displayHandler()
{
	try
	{
		var sortFnc = sortHandler();
		
		if(!sortFnc)
		{
			return;
		}
		
		var cData = getDataHandler(false);
		
		var f = true;
		
		if(cData.length < 5)
		{
			alert("数値は5つ以上入力してください。");
			f = false;
			
			return;
		}
		else
		{
			backData = getDataHandler(false);
		}
		
		changeCanvasHandler();

		changePartsDisplayHandler();

		cs.update();
	}
	catch(e)
	{
		alert("displayHandler:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		changePartsDisplayHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

function changePartsDisplayHandler()
{
	try
	{
		var f0 = document.getElementById("check0").checked;
		var f1 = document.getElementById("check1").checked;
		
		if(!f0 && !f1)
		{
			textBlock.visible = false;
		}
		else
		{
			textBlock.visible = true;
		}
		
		cont.visible = f0;
		contH.visible = f1;
	}
	catch(e)
	{
		alert("changePartsDisplayHandler:" + e.toString());
	}
}

function getDataHandler(f)
{
	try
	{
		var cData = [];
		for(var i=0; i<30; i++)
		{
			var str = document.getElementById("c"+i).value;
			if(str != "" && str.match(/^[-]?([1-9]\d*|0)(\.\d+)?$/) != "")
			{
				cData.push(Number(str));
			}
			else if(f)
			{
				cData.push("");
			}
		}
		
		cData.sort(function(a,b)
		{
			if( a < b ) return -1;
			if( a > b ) return 1;
			return 0;
		});
		
		if(f)
		{
			var cnt = 0;
			while(cData.indexOf("") != -1)
			{
				cData.splice(cData.indexOf(""), 1);
				cnt++;
			}
			
			while(cnt > 0)
			{
				cData.push("");
				cnt--;
			}
		}
		
		return cData;
	}
	catch(e)
	{
		alert("getDataHandler:" + e.toString());
	}
}

function changeCanvasHandler()
{
	try
	{
		//
		var cData = backData.slice();
		
		var setText = [];
		
		//幅の合計
		var sumWidth = 0;
		for(var i=0; i<textArray.length; i++)
		{
			if(i < cData.length)
			{
				textArray[i].text = cData[i];
				sumWidth += textArray[i].getBounds().width;
				setText.push(textArray[i]);
			}
			else
			{
				textArray[i].text = "";
			}
		}
		
		sumWidth += span * cData.length-1;
		
		var startX;
		
		var num = Math.floor(cData.length/2);
		
		var f;
		
		if(setText.length%2 == 0)
		{
			f = true;
		}
		else
		{
			f = false;
		}
		
		var minData = cData[0];
		var maxData = cData[cData.length-1];
		var centerData;
		var quartData1;
		var quartData3;
			
		var quart;
		
		var f1;
		
		//偶数
		if(f)
		{
			centerData = (cData[num-1]+cData[num])/2;
			
			//データを半分で割ったものの数が偶数
			if(num%2 == 0)
			{
				quart = Math.floor(num/2)-1;
				f1 = true;
			}
			//データを半分に割ったものの数が奇数
			else
			{
				quart = Math.floor(num/2);
				f1 = false;
			}
		}
		//奇数
		else
		{
			centerData = cData[num];
			
			//データを半分で割ったものの数が偶数
			if(num%2 == 0)
			{
				quart = Math.floor(num/2)-1;
				f1 = true;
			}
			//データを半分に割ったものの数が奇数
			else
			{
				quart = Math.floor(num/2);
				f1 =false;
			}
		}
		
		var w0,w1,w2,w3,w4;
		
		//全項目が収まる場合
		if(sumWidth <= 840)
		{
			ap0.visible = false;
			ap1.visible = false;
			ap2.visible = false;
			ap3.visible = false;
			
			startX = (cW - sumWidth)/2;
			sumWidth = 0;
			
			for(i=0; i<setText.length; i++)
			{
				setText[i].x = startX + sumWidth;
				
				/*ヒストグラム用に変更*/
				setText[i].y = 20;
				
				sumWidth += setText[i].getBounds().width + span;
			}
			
			var cw;
			
			minSp.x = setText[0].x - span/2;
			minSp.y = setText[0].y;
			minSp.graphics.clear();
			minSp.graphics.beginFill("#F6AC54");
			minSp.graphics.drawRect(0, 0, setText[0].getBounds().width + span, setText[0].getBounds().height);
			minSp.graphics.endFill();
			widthArray[0] = setText[0].getBounds().width + span;
			
			maxSp.x = setText[setText.length-1].x - span/2;
			maxSp.y = setText[setText.length-1].y;
			maxSp.graphics.clear();
			maxSp.graphics.beginFill("#EA5509");
			maxSp.graphics.drawRect(0, 0, setText[setText.length-1].getBounds().width + span, setText[setText.length-1].getBounds().height);
			maxSp.graphics.endFill();
			widthArray[4] = setText[setText.length-1].getBounds().width + span;
			
			centerSp.graphics.clear();
			
			//データが偶数
			if(f)
			{
				centerSp.x = setText[num-1].x - span/2;
				centerSp.y = setText[num-1].y;
				centerSp.graphics.beginFill("#FBDAD8");
				centerSp.graphics.drawRect(0, 0, setText[num].x - setText[num-1].x + setText[num].getBounds().width + span, setText[num].getBounds().height);
				centerSp.graphics.endFill();
				
				cw = setText[num].x - setText[num-1].x + setText[num].getBounds().width + span;
			}
			//データが奇数
			else
			{
				centerSp.x = setText[num].x - span/2;
				centerSp.y = setText[num].y;
				centerSp.graphics.beginFill("#FBDAD8");
				centerSp.graphics.drawRect(0, 0, setText[num].getBounds().width + span, setText[num].getBounds().height);
				centerSp.graphics.endFill();
				
				cw = setText[num].getBounds().width + span;
			}
			
			widthArray[2] = cw;
			
			
			//偶数
			if(f)
			{
				centerData = (cData[num-1]+cData[num])/2;
				
				//データを半分で割ったものの数が偶数
				if(num%2 == 0)
				{
					quart = Math.floor(num/2)-1;
					f1 = true;
				}
				//データを半分に割ったものの数が奇数
				else
				{
					quart = Math.floor(num/2);
					f1 = false;
				}
			}
			//奇数
			else
			{
				centerData = cData[num];
				
				//データを半分で割ったものの数が偶数
				if(num%2 == 0)
				{
					quart = Math.floor(num/2)-1;
					f1 = true;
				}
				//データを半分に割ったものの数が奇数
				else
				{
					quart = Math.floor(num/2);
					f1 =false;
				}
			}
			
			qSp1.graphics.clear();
			qSp3.graphics.clear();
			
			if(f1)
			{
				qSp1.x = setText[quart].x - span/2;
				qSp1.y = setText[quart].y;
				qSp1.graphics.beginFill("#D2ECFB");
				qSp1.graphics.drawRect(0, 0, setText[quart+1].x + setText[quart+1].getBounds().width - setText[quart].x + span, setText[quart].getBounds().height);
				qSp1.graphics.endFill();
				
				w1 = setText[quart+1].x + setText[quart+1].getBounds().width - setText[quart].x + span;
				
				quartData1 = (cData[quart] + cData[quart+1])/2;
				
				qSp3.graphics.beginFill("#EBF1C3");
				
				//偶数
				if(f)
				{
					qSp3.x = setText[num+quart].x - span/2;
					qSp3.y = setText[num+quart].y;
					
					qSp3.graphics.drawRect(0, 0, setText[num+quart+1].x + setText[num+quart+1].getBounds().width - setText[num+quart].x + span, setText[num+quart].getBounds().height);
					qSp3.graphics.endFill();
					
					quartData3 = (cData[num+quart]+cData[num+quart+1])/2;
					
					w3 = setText[num+quart+1].x + setText[num+quart+1].getBounds().width - setText[num+quart].x + span;
				}
				//奇数
				else
				{
					
					qSp3.x = setText[num+quart+1].x - span/2;
					qSp3.y = setText[num+quart+1].y;
					
					qSp3.graphics.drawRect(0, 0, setText[num+quart+1].x + setText[num+quart+1].getBounds().width - setText[num+quart].x + span, setText[num+quart+1].getBounds().height);
					qSp3.graphics.endFill();
					
					quartData3 = cData[num+quart+1];
					
					w3 = setText[num+quart+1].x + setText[num+quart+1].getBounds().width - setText[num+quart].x + span;
				}
			}
			else
			{
				qSp1.x = setText[quart].x - span/2;
				qSp1.y = setText[quart].y;
				qSp1.graphics.beginFill("#D2ECFB");
				qSp1.graphics.drawRect(0, 0, setText[quart].getBounds().width + span, setText[quart].getBounds().height);
				qSp1.graphics.endFill();
				
				w1 = setText[quart].getBounds().width + span;
				
				quartData1 = cData[quart];
				
				qSp3.graphics.beginFill("#EBF1C3");
				
				//偶数
				if(f)
				{
					
					qSp3.x = setText[num+quart].x-span/2;
					qSp3.y = setText[num+quart].y;
					
					qSp3.graphics.drawRect(0, 0, setText[num+quart].getBounds().width+span, setText[num+quart].getBounds().height);
					qSp3.graphics.endFill();
					
					quartData3 = cData[num+quart];
					
					w3 = setText[num+quart].getBounds().width+span;
				}
				//奇数
				else
				{
					
					qSp3.x = setText[num+quart+1].x-span/2;
					qSp3.y = setText[num+quart+1].y;
					
					qSp3.graphics.drawRect(0, 0, setText[num+quart+1].getBounds().width+span, setText[num+quart+1].getBounds().height);
					qSp3.graphics.endFill();
					
					quartData3 = cData[num+quart+1];
					
					w3 = setText[num+quart+1].getBounds().width+span;
				}
			}
		}
		//項目が収まらない場合
		else
		{
			//表示・非表示の設定
			var disp = [];
			var i;
			for(i=0; i<setText.length; i++)
			{
				setText[i].y = 20;
				disp[i] = false;
			}
			
			disp[0] = true;
			disp[setText.length-1] = true;
			
			//最小値の位置
			setText[0].x = 30;
			//最大値の位置
			setText[setText.length-1].x = 870 - setText[setText.length-1].getBounds().width;
			
			//最小値の背景
			minSp.x = setText[0].x - span/2;
			minSp.y = setText[0].y;
			minSp.graphics.clear();
			minSp.graphics.beginFill("#F6AC54");
			w0 = setText[0].getBounds().width + span;
			minSp.graphics.drawRect(0, 0, w0, setText[0].getBounds().height);
			minSp.graphics.endFill();
			
			//最大値の背景
			maxSp.x = setText[setText.length-1].x - span/2;
			maxSp.y = setText[setText.length-1].y;
			maxSp.graphics.clear();
			maxSp.graphics.beginFill("#EA5509");
			w4 = setText[setText.length-1].getBounds().width + span;
			maxSp.graphics.drawRect(0, 0, w4, setText[setText.length-1].getBounds().height);
			maxSp.graphics.endFill();
			
			
			ap0.visible = true;
			ap1.visible = true;
			ap2.visible = true;
			ap3.visible = true;
			
			//第1四分位を入れる間隔の値
			var sw1;
			//第3四分位を入れる間隔の値
			var sw3;
			
			//データ数が偶数の場合
			if(f)
			{
				//中央値のテキスト
				setText[num-1].x = 450 - setText[num-1].getBounds().width - span/2;
				setText[num].x = 450 + span/2;
				
				//中央値の背景
				centerSp.x = setText[num-1].x - span/2;
				centerSp.y = setText[num-1].y;
				centerSp.graphics.clear();
				centerSp.graphics.beginFill("#FBDAD8");
				w2 = setText[num-1].getBounds().width + setText[num].getBounds().width + span * 2;
				centerSp.graphics.drawRect(0, 0, w2, setText[num].getBounds().height);
				centerSp.graphics.endFill();
				
				
				sw1 = setText[num-1].x - setText[0].x - setText[0].getBounds().width;
				sw3 = setText[setText.length-1].x - setText[num].x - setText[num].getBounds().width;
				
				disp[num-1] = true;
				disp[num] = true;
			}
			//データ数が奇数の場合
			else
			{
				//中央値のテキスト
				setText[num].x = 450 - setText[num].getBounds().width/2;
				
				//中央値の背景
				centerSp.x = setText[num].x - span/2;
				centerSp.y = setText[num].y;
				centerSp.graphics.clear();
				centerSp.graphics.beginFill("#FBDAD8");
				w2 = setText[num].getBounds().width + span;
				centerSp.graphics.drawRect(0, 0, w2, setText[num].getBounds().height);
				centerSp.graphics.endFill();
				
				
				sw1 = setText[num].x - setText[0].x - setText[0].getBounds().width;
				sw3 = setText[setText.length-1].x - setText[num].x - setText[num].getBounds().width;
				
				disp[num] = true;
			}
			
			if(f1)
			{
				sw1 = (sw1 - (setText[quart].getBounds().width + setText[quart+1].getBounds().width + span))/2;
				
				//第1四分位
				setText[quart].x = setText[0].x + setText[0].getBounds().width + sw1;
				setText[quart+1].x = setText[quart].x + setText[quart].getBounds().width + span;
				
				//第1四分位の背景
				qSp1.x = setText[quart].x - span/2;
				qSp1.y = setText[quart].y;
				qSp1.graphics.clear();
				qSp1.graphics.beginFill("#D2ECFB");
				w1 = setText[quart].getBounds().width + setText[quart+1].getBounds().width + span * 2;
				qSp1.graphics.drawRect(0, 0, w1, setText[quart].getBounds().height);
				qSp1.graphics.endFill();
				
				
				disp[quart] = true;
				disp[quart+1] = true;
				
				//第3四分位
				//偶数
				if(f)
				{
					sw3 = (sw3 - (setText[num+quart].getBounds().width + setText[num+quart+1].getBounds().width + span))/2;
					setText[num+quart].x = setText[num].x + setText[num].getBounds().width + sw3;
					setText[num+quart+1].x = setText[num+quart].x + setText[num+quart].getBounds().width + span;
					
					qSp3.x = setText[num+quart].x-span/2;
					qSp3.y = setText[num+quart].y;
					qSp3.graphics.clear();
					qSp3.graphics.beginFill("#EBF1C3");
					w3 = setText[num+quart].getBounds().width+setText[num+quart+1].getBounds().width+span*2;
					qSp3.graphics.drawRect(0, 0, w3, setText[num+quart+1].getBounds().height+5);
					qSp3.graphics.endFill();
					
					disp[num+quart] = true;
					disp[num+quart+1] = true;
				}
				else
				{
					sw3 = (sw3 - (setText[num+quart].getBounds().width + setText[num+quart+1].getBounds().width + span * 2))/2;
					setText[num+quart].x = setText[num].x + setText[num].getBounds().width + sw3;
					setText[num+quart+1].x = setText[num+quart].x + setText[num+quart].getBounds().width + span;
					
					qSp3.x = setText[num+quart].x-span/2;
					qSp3.y = setText[num+quart].y;
					qSp3.graphics.clear();
					qSp3.graphics.beginFill("#EBF1C3");
					w3 = setText[num+quart].getBounds().width+setText[num+quart+1].getBounds().width+span*2;
					qSp3.graphics.drawRect(0, 0, w3, setText[num+quart+1].getBounds().height);
					qSp3.graphics.endFill();
					
					disp[num+quart] = true;
					disp[num+quart+1] = true;
				}
			}
			else
			{
				sw1 = (sw1 - (setText[quart].getBounds().width + span))/2;
				
				//第1四分位
				setText[quart].x = setText[0].x + setText[0].getBounds().width + sw1;
				
				//第一四分位の背景
				qSp1.x = setText[quart].x - span/2;
				qSp1.y = setText[quart].y;
				qSp1.graphics.clear();
				qSp1.graphics.beginFill("#D2ECFB");
				w1 = setText[quart].getBounds().width + span;
				qSp1.graphics.drawRect(0, 0, w1, setText[quart].getBounds().height);
				qSp1.graphics.endFill();
				
				disp[quart] = true;
				
				//第3四分位
				//偶数
				if(f)
				{
					sw3 = (sw3 - (setText[num+quart].getBounds().width + span))/2;
					setText[num+quart].x = setText[num].x + setText[num].getBounds().width + sw3;
					
					qSp3.x = setText[num+quart].x-span/2;
					qSp3.y = setText[num+quart].y;
					qSp3.graphics.clear();
					qSp3.graphics.beginFill("#EBF1C3");
					w3 = setText[num+quart].getBounds().width+span;
					qSp3.graphics.drawRect(0, 0, w3, setText[num+quart].getBounds().height);
					qSp3.graphics.endFill();
					
					disp[num+quart] = true;
				}
				else
				{
					sw3 = (sw3 - (setText[num+quart+1].getBounds().width + span))/2;
					setText[num+quart+1].x = setText[num].x + setText[num].getBounds().width + sw3;
					
					qSp3.x = setText[num+quart+1].x-span/2;
					qSp3.y = setText[num+quart+1].y;
					qSp3.graphics.clear();
					qSp3.graphics.beginFill("#EBF1C3");
					w3 = setText[num+quart+1].getBounds().width+span;
					qSp3.graphics.drawRect(0, 0, w3, setText[num+quart+1].getBounds().height);
					qSp3.graphics.endFill();
					
					disp[num+quart+1] = true;
				}
			}
			
			//他のテキストを空に変える
			for(i=0; i<setText.length; i++)
			{
				if(disp[i] == false)
				{
					setText[i].text = "";
				}
			}
			
			ap0.x = (qSp1.x + (minSp.x + w0))/2 - ap0.getBounds().width/2;
			ap1.x = (centerSp.x + (qSp1.x + w1))/2 - ap1.getBounds().width/2;
			ap2.x = (qSp3.x + (centerSp.x + w2))/2 - ap2.getBounds().width/2;
			ap3.x = (maxSp.x + (qSp3.x + w3))/2 - ap3.getBounds().width/2;
		}
		
		if(f1)
		{
			quartData1 = (cData[quart] + cData[quart+1])/2;
			
			//偶数
			if(f)
			{
				quartData3 = (cData[num+quart]+cData[num+quart+1])/2;
			}
			//奇数
			else
			{
				quartData3 =  (cData[num+quart]+cData[num+quart+1])/2;
			}
		}
		else
		{
			quartData1 = cData[quart];
			
			//偶数
			if(f)
			{
				quartData3 = cData[num+quart];
			}
			//奇数
			else
			{
				quartData3 = cData[num+quart+1];
			}
		}
		
		/*ヒストグラム用に変更*/
		cont.y = cH-130;
		
		
		if(centerData.toString().length > 5)
		{
			centerData = Math.round(centerData * 10000)/10000;
		}
		
		if(quartData1.toString().length > 5)
		{
			quartData1 = Math.round(quartData1 * 10000)/10000;
		}
		
		if(quartData3.toString().length > 5)
		{
			quartData3 = Math.round(quartData1 * 10000)/10000;
		}
		
		/*必要なデータをヒストグラムに引き継ぐように修正*/
		var histoData = changeBox(cData, centerData, quartData1, quartData3);
		
		/*ヒストグラムの描画*/
		drawHistogram(cData, histoData);
		contH.y = 60;
		
		cs.update();
	}
	catch(e)
	{
		alert("changeCanvasHandler:" + e.toString());
	}
}

function changeBox(cData, cNum, qNum1, qNum3)
{
	try
	{
		//最小値
		var minNum = cData[0];
		//最大値
		var maxNum = cData[cData.length-1];
		
		//平均値
		var avNum = 0;
		for(var i=0; i<cData.length; i++)
		{
			avNum += cData[i];
		}
		
		avNum = avNum/cData.length;
		
		//幅
		var w = 800;
		
		cont.x = (cW-w)/2;
		
		//高さ
		var h = 100;
		
		//余白
		var span = 20;
		
		//箱ひげ図を入れる領域の設定
		var leng = w - span * 3;
		
		
		var limit;
		
		//箱ひげ図の初期化
		box.graphics.clear();
		
		//矢印
		box.graphics.beginStroke("#000000");
		box.graphics.setStrokeStyle(1);
		box.graphics.moveTo(0, h-5);
		box.graphics.lineTo(w-span, h-5);
		box.graphics.endStroke();
		
		box.graphics.setStrokeStyle(1);
		box.graphics.beginFill("#000000");
		box.graphics.lineTo(w-span, h-10);
		box.graphics.lineTo(w-2, h-5);
		box.graphics.lineTo(w-span, h);
		box.graphics.lineTo(w-span, h-5);
		box.graphics.endFill();
		box.graphics.endStroke();
		
		
		//箱ひげ図描画のための値
		var minX;
		var maxX;
		var q1X;
		var q3X;
		var qW;
		var centX;
		
		//領域の最大を最大値より大きい10の倍数に設定する
		if(minNum >= 0)
		{
			if(maxNum%10 != 0)
			{
				limit = Math.ceil(maxNum/10) * 10;
			}
			else
			{
				limit = maxNum + 10;
			}
			
			//値を設定
			minX = span + leng * minNum/limit;
			maxX = span + leng * maxNum/limit;
			q1X = span + leng * qNum1/limit;
			q3X = span + leng * qNum3/limit;
			qW = q3X-q1X;
			centX = span+leng * cNum/limit;
		}
		//最小値がマイナスの場合は範囲を最小値より小さい10の倍数と最大値より大きい10の倍数で範囲を設定する
		else
		{
			var minBase = -Math.ceil(-minNum/10) * 10;
			var maxBase = Math.ceil(maxNum/10) * 10;
			
			var rate = leng / (maxBase - minBase);
			
			minX = span + rate * (minNum - minBase);
			maxX = span + rate * (maxNum - minBase);
			q1X = span + rate * (qNum1 - minBase);
			q3X = span + rate * (qNum3 - minBase);
			qW = q3X - q1X;
			centX = span + rate * (cNum - minBase);
		}
		
		//以降箱ひげ図部分の描画
		box.graphics.setStrokeStyle(1);
		box.graphics.beginStroke("#000000");
		
		//最小値
		box.graphics.moveTo(minX, h/8);
		box.graphics.lineTo(minX, h*3/8);
		
		//最大値
		box.graphics.moveTo(maxX, h/8);
		box.graphics.lineTo(maxX, h*3/8);
		
		//最小と最大をつなぐ
		box.graphics.moveTo(minX, h/4);
		box.graphics.lineTo(maxX, h/4);
		
		//箱の部分
		box.graphics.beginFill("#FFFFFF");
		box.graphics.drawRect(q1X, 0, qW, h/2);
		box.graphics.endFill();
		
		//中央値の部分
		box.graphics.moveTo(centX, 0);
		box.graphics.lineTo(centX, h/2);
		
		//破線の描画
		//最小
		box.graphics.setStrokeDash([5, 5], 0);
		box.graphics.moveTo(minX, h*3/8);
		box.graphics.lineTo(minX, h-5);
		//第１四分位数
		box.graphics.moveTo(q1X, h/2);
		box.graphics.lineTo(q1X, h-5);
		//中央値
		box.graphics.moveTo(centX, h/2);
		box.graphics.lineTo(centX, h-5);
		//第３四分位数
		box.graphics.moveTo(q3X, h/2);
		box.graphics.lineTo(q3X, h-5);
		//最大値
		box.graphics.moveTo(maxX, h*3/8);
		box.graphics.lineTo(maxX, h-5);
		
		minBox.text = minNum;
		centerBox.text = cNum;
		maxBox.text = maxNum;
		q1Box.text = qNum1;
		q3Box.text = qNum3;
		
		minBox.x = minX - minBox.getBounds().width/2;
		minBox.y = h;
		maxBox.x = maxX - maxBox.getBounds().width/2;
		maxBox.y = h;
		centerBox.x = centX - centerBox.getBounds().width/2;
		centerBox.y = h;
		q1Box.x = q1X - q1Box.getBounds().width/2;
		q1Box.y = h;
		q3Box.x = q3X - q3Box.getBounds().width/2;
		q3Box.y = h;
		
		//変形などで使用した値をヒストグラム用に格納して渡す
		var histoData = [w, h, span, leng];
		
		return histoData;
	}
	catch(e)
	{
		alert("changeBox:" + e.toString());
	}
}

function drawArrow(s, ax, sy, ey)
{
	try
	{
		s.graphics.clear();
		s.graphics.setStrokeStyle(1);
		s.graphics.beginStroke("#000000");
		s.graphics.moveTo(ax, sy);
		
		if(sy < ey)
		{
			s.graphics.lineTo(ax, ey-5);
			s.graphics.endStroke();
			
			s.graphics.setStrokeStyle(0);
			s.graphics.beginFill("#000000");
			s.graphics.moveTo(ax-2, ey-5);
			s.graphics.lineTo(ax, ey);
			s.graphics.lineTo(ax+2, ey-5);
			s.graphics.lineTo(ax, ey-5);
		}
		else
		{
			s.graphics.lineTo(ax, ey+5);
			s.graphics.endStroke();
			
			s.graphics.setStrokeStyle(0);
			s.graphics.beginFill("#000000");
			s.graphics.moveTo(ax-2, ey+5);
			s.graphics.lineTo(ax, ey);
			s.graphics.lineTo(ax+2, ey+5);
			s.graphics.lineTo(ax, ey+5);
		}
		
		s.graphics.endFill();
		s.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawArrow:" + e.toString());
	}
}

//以下ヒストグラムの描画用追加プログラム
var contH;
var hist;

function drawHistogram(cData, config)
{
	try
	{
		//幅
		var w = config[0];
		
		contH.x = (cW-w)/2;
		
		//高さ
		var h = 180;
		
		//余白
		var span = config[2];
		
		//箱ひげ図を入れる領域の設定
		var leng = config[3];
		
		/*最大値より大きい10の倍数を設定（最大が10の倍数ならその値）し，
		10分割して範囲内の値をカウントする*/
		var maxNum;
		var m;
		var s;
		if(cData[0] >= 0)
		{
			if(cData[cData.length-1]%10 != 0)
			{
				maxNum = Math.ceil(cData[cData.length-1]/10) * 10;
			}
			else
			{
				maxNum = cData[cData.length-1]+10;
			}
			
			m = maxNum/10;
			s = 0;
		}
		else
		{
			var minNum;
			
			if(cData[0]%10 != 0)
			{
				minNum = -Math.ceil(-cData[0]/10) * 10;
			}
			else
			{
				minNum = cData[0] -10;
			}
			
			if(cData[cData.length-1]%10 != 0)
			{
				maxNum = Math.ceil(cData[cData.length-1]/10) * 10;
			}
			else
			{
				maxNum = cData[cData.length-1]+10;
			}
			
			m = (maxNum-minNum)/10;
			
			s = minNum;
			
		}
		
		
		var countArray = [];
		
		var i;
		var k = 0;
		
		for(i=s; i<maxNum; i=i+m)
		{
			countArray[k] = 0;
			
			for(var j=0; j<cData.length; j++)
			{
				if(cData[j] >= i && cData[j] < i+m)
				{
					countArray[k] = countArray[k]+1;
				}
				else if(cData[j] >= i+m)
				{
					break;
				}
			}
			
			k++;
		}
		
		hist.graphics.clear();
		
		//最大の高さをカウントの最大値以上の5の倍数の値で設定
		maxNum = 0;
		
		for(i=0; i<countArray.length; i++)
		{
			if(maxNum < Math.ceil(countArray[i]))
			{
				maxNum = Math.ceil(countArray[i]);
			}
		}
		
		hist.graphics.clear();
		
		hist.graphics.setStrokeStyle("#000000");
		hist.graphics.beginStroke(1);
		
		var dW = leng/10;
		var dH = h - 5;
		
		for(i=0; i<countArray.length; i++)
		{
			hist.graphics.beginFill("#FFFFFF");
			hist.graphics.drawRect(span + dW * i, dH - dH * countArray[i]/maxNum, dW, dH * countArray[i]/maxNum);
			hist.graphics.endFill();
		}
		
		//下の線
		hist.graphics.moveTo(0, h-5);
		hist.graphics.lineTo(span*2+leng, h-5);
		hist.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawHistogram"+e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = "new";
		
		array[1] = [];
		
		//表の値
		for(var i=0; i<30; i++)
		{
			array[1][i] = document.getElementById('c'+i).value;
		}
		
		array[2] = [document.getElementById("check0").checked, document.getElementById("check1").checked];
		
		array[3] = backData.slice();
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		if(array[0] != "new")
		{
			alert("コンテンツの内容が変更されたため，読み込まれたコンテンツデータを再現できません。");
			
			return;
		}
	
		//値を設定
		for(var i=0; i<30; i++)
		{
			document.getElementById('c'+i).value = array[1][i];
		}
		
		document.getElementById("check0").checked = array[2][0];
		document.getElementById("check1").checked = array[2][1];
		
		backData = array[3].slice();
		
		changeCanvasHandler();
			
		//パーツの表示変更
		changePartsDisplayHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		for(var i=0; i<30; i++)
		{
			if(i < baseData.length)
			{
				document.getElementById('c'+i).value = baseData[i];
			}
			else
			{
				document.getElementById('c'+i).value = "";
			}
		}
		
		document.getElementById('check0').checked = false;
		document.getElementById('check1').checked = false;
		
		backData = getDataHandler(false);
		
		
		changeCanvasHandler();
			
		//パーツの表示変更
		changePartsDisplayHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}
