// JavaScript Document
var cc;
var cs;

var cW;
var cH;

var sizeArr;

var contArray;
var shapeArray;
var tArray;

var cf;

var browse;

var zoomFlag;


var selectId;
var selectParts;

var dFlag;

//色
var fcArray;
//テキスト
var tArray;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

function loadContentHandler()
{
	try
	{
		zoomFlag = false;
		
		cW = 540;
		cH = 500;
		
		sizeArr = [
			[
				[0,		0,		300,	300], 
				[0,		300,	300,	100], 
				[300,	0,		100,	300], 
				[300,	300, 	100,	100]
			],
			[
				[0,		0,		400,	400],
				[0,		300,	400,	100],
				[300,	0,		100,	400],
				[300,	300,	100,	100]
			],
			[
				[0,		0,		300,	300],
				[0,		300,	300,	100],
				[200,	0,		100,	300],
				[200,	300,	100,	100]
			],
			[
				[0,		0,		300,	300],
				[0,		300,	300,	100],
				[300,	0,		50,		300],
				[300,	300,	50,		100]
			], 
			[
				[0,		0,		300,	250],
				[300,	0,		100,	250],
				[0,		250,	300,	50],
				[300,	250,	100,	50]
			]
		];
		
		document.getElementById("canvas").width = cW;
		document.getElementById("canvas").height = cH;
		
		
		document.getElementById("windowBlock").style.width = "360px";
		document.getElementById("windowBlock").style.marginRight = "20px";
		document.getElementById("windowBlock").style.textAlign = "left";
		
		$(".formLeft").css("display", "inline-block");
		$(".formLeft").css("vertical-align", "top");
		
		$(".formRight").css("display", "inline-block");
		$(".formRight").css("vertical-align", "top");
		
		document.getElementById("content").style.marginLeft = "10px";
		
		document.getElementById("guideText").style.lineHeight = "1em";
		
		cc = document.getElementById("canvas");
		cs = new createjs.Stage(cc);
		
		createjs.Touch.enable(cs);
		
		//スマートフォン
		var ua = navigator.userAgent;
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			browse = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			browse = true;
		}
		else
		{
			browse = false;
		}
		
		tcArray = ["rgb(0, 0, 0)", "rgb(255, 0, 0)", "rgb(128, 0, 128)"];
		fcArray = ["#FFFFCC", "#EBFFC3", "#D2ECFB", "#FBDAD8", "rgb(192, 64, 192)"];
		
		var i,j;
		
		//オブジェクトの設定
		contArray = [];
		shapeArray = [];
		
		for(i=0; i<=4; i++)
		{
			contArray[i] = [];
			contArray[i][0] = new createjs.Container();
			contArray[i][0].name = "c"+i;
			
			shapeArray[i] = [];
			for(j=0; j<=3; j++)
			{
				shapeArray[i][j] = new createjs.Shape();
				drawSquare(shapeArray[i][j], sizeArr[i][j][2], sizeArr[i][j][3], "#FFFFFF");
				
				contArray[i][j+1] = new createjs.Container();
				contArray[i][j+1].x = sizeArr[i][j][0];
				contArray[i][j+1].y = sizeArr[i][j][1];
				contArray[i][j+1].addChild(shapeArray[i][j]);
				contArray[i][0].addChild(contArray[i][j+1]);
			}
			
			cs.addChild(contArray[i][0]);
			
			contArray[i][0].x = 80;
			contArray[i][0].y = 80;
		}
		
		//テキスト作成
		setTextContainer();
		
		//各設定
		for(i=0; i<=4; i++)
		{
			//途中式のパーツの設定
			for(j=0; j<=4; j++)
			{
				document.getElementById("p"+i+"_"+j).style.color = fcArray[0];
				
				document.getElementById("p"+i+"_"+j).style.cursor = "pointer";
				
				document.getElementById("p"+i+"_"+j).addEventListener("click", selectPartsHandler);
			}
			
			//まとめた式の表示
			document.getElementById("form"+i+"_1_1").style.display = "none";
			
			document.getElementById("gCheck"+i).addEventListener("change", changeCheckHandler);
		}
		
		changeModeHandler(0);
		
		document.getElementById("resetBtn").style.marginTop = "20px";
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		cs.update();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function setTextContainer()
{
	try
	{
		//四角内のテキスト
		tArray = [];
		
		tArray[0] = [];
		tArray[1] = [];
		tArray[2] = [];
		tArray[3] = [];
		tArray[4] = [];
		
		tArray[0][0] = createTextObject("a²", true, true);
		tArray[0][1] = createTextObject("ab", true, true);
		tArray[0][2] = createTextObject("ab", true, true);
		tArray[0][3] = createTextObject("b²", true, true);
		
		tArray[1][0] = createTextObject("a²", true, true);
		tArray[1][1] = createTextObject("-ab", true, true);
		tArray[1][2] = createTextObject("-ab", true, true);
		tArray[1][3] = createTextObject("b²", true, true);
		
		tArray[2][0] = createTextObject("a²", true, true);
		tArray[2][1] = createTextObject("ab", true, true);
		tArray[2][2] = createTextObject("-ab", true, true);
		tArray[2][3] = createTextObject("-b²", true, true);
		
		tArray[3][0] = createTextObject("x²", true, true);
		tArray[3][1] = createTextObject("ax", true, true);
		tArray[3][2] = createTextObject("bx", true, true);
		tArray[3][3] = createTextObject("ab", true, true);
		
		tArray[4][0] = createTextObject("acx²", true, true);
		tArray[4][1] = createTextObject("adx", true, true);
		tArray[4][2] = createTextObject("bcx", true, true);
		tArray[4][3] = createTextObject("bd", true, true);
		
		//テキストを各四角コンテナに入れる
		for(var i=0; i<=4; i++)
		{
			for(var j=0; j<=3; j++)
			{
				contArray[i][j+1].addChild(tArray[i][j]);
				
				tArray[i][j].x = (sizeArr[i][j][2] - tArray[i][j].getBounds().width)/2;
				tArray[i][j].y = (sizeArr[i][j][3] - tArray[i][j].getBounds().height)/2;
			}
		}
		
		//
		var h0_0 = createTextObject("a", false, true);
		var h0_1 = createTextObject("b", false, true);
		var w0_0 = createTextObject("a", false, true);
		var w0_1 = createTextObject("b", false, true);
		
		contArray[0][0].addChild(h0_1);
		contArray[0][0].addChild(w0_0);
		contArray[0][0].addChild(w0_1);
		contArray[0][0].addChild(h0_0);
		
		h0_0.x = -h0_0.getBounds().width-5;
		h0_0.y = (sizeArr[0][0][3]-h0_0.getBounds().height)/2;
		h0_1.x = -h0_1.getBounds().width-5;
		h0_1.y = sizeArr[0][1][1]+(sizeArr[0][1][3]-h0_1.getBounds().height)/2;
		w0_0.x = (sizeArr[0][0][2]-w0_0.getBounds().width)/2;
		w0_0.y = -w0_0.getBounds().height;
		w0_1.x = sizeArr[0][2][0]+(sizeArr[0][2][2]-w0_1.getBounds().width)/2;
		w0_1.y = -w0_1.getBounds().height;
		
		//
		var h1_0 = createTextObject("a-b", false, true);
		var h1_1 = createTextObject("b", false, true);
		var w1_0 = createTextObject("a-b", false, true);
		var w1_1 = createTextObject("b", false, true);
		
		contArray[1][0].addChild(h1_1);
		contArray[1][0].addChild(w1_0);
		contArray[1][0].addChild(w1_1);
		contArray[1][0].addChild(h1_0);
		
		h1_0.x = -h1_0.getBounds().width-5;
		h1_0.y = (sizeArr[1][1][1]-h1_0.getBounds().height)/2;
		h1_1.x = -h1_1.getBounds().width-5;
		h1_1.y = sizeArr[1][1][1]+(sizeArr[1][1][3]-h1_1.getBounds().height)/2;
		w1_0.x = (sizeArr[1][2][0]-w1_0.getBounds().width)/2;
		w1_0.y = -w1_0.getBounds().height;
		w1_1.x = sizeArr[1][2][0]+(sizeArr[1][2][2]-w1_1.getBounds().width)/2;
		w1_1.y = -w1_1.getBounds().height;
		
		//
		var h2_0 = createTextObject("a", false, true);
		var h2_1 = createTextObject("b", false, true);
		var w2_0 = createTextObject("a-b", false, true);
		var w2_1 = createTextObject("b", false, true);
		
		contArray[2][0].addChild(h2_1);
		contArray[2][0].addChild(w2_0);
		contArray[2][0].addChild(w2_1);
		contArray[2][0].addChild(h2_0);
		
		h2_0.x = -h2_0.getBounds().width-5;
		h2_0.y = (sizeArr[2][0][3]-h2_0.getBounds().height)/2;
		h2_1.x = -h2_1.getBounds().width-5;
		h2_1.y = sizeArr[2][1][1]+(sizeArr[2][1][3]-h2_1.getBounds().height)/2;
		w2_0.x = (sizeArr[2][2][0]-w2_0.getBounds().width)/2;
		w2_0.y = -w2_0.getBounds().height;
		w2_1.x = sizeArr[2][2][0]+(sizeArr[1][2][2]-w1_1.getBounds().width)/2;
		w2_1.y = -w2_1.getBounds().height;
		
		//
		var h3_0 = createTextObject("x", false, true);
		var h3_1 = createTextObject("a", false, true);
		var w3_0 = createTextObject("x", false, true);
		var w3_1 = createTextObject("b", false, true);
		
		contArray[3][0].addChild(h3_1);
		contArray[3][0].addChild(w3_0);
		contArray[3][0].addChild(w3_1);
		contArray[3][0].addChild(h3_0);
		
		h3_0.x = -h3_0.getBounds().width-5;
		h3_0.y = (sizeArr[3][0][3]-h3_0.getBounds().height)/2;
		h3_1.x = -h3_1.getBounds().width-5;
		h3_1.y = sizeArr[3][1][1]+(sizeArr[3][1][3]-h3_1.getBounds().height)/2;
		w3_0.x = (sizeArr[3][0][2]-w3_0.getBounds().width)/2;
		w3_0.y = -w3_0.getBounds().height;
		w3_1.x = sizeArr[3][2][0]+(sizeArr[3][2][2]-w3_1.getBounds().width)/2;
		w3_1.y = -w3_1.getBounds().height;
		
		//
		var h4_0 = createTextObject("ax", false, true);
		var h4_1 = createTextObject("b", false, true);
		var w4_0 = createTextObject("cx", false, true);
		var w4_1 = createTextObject("d", false, true);
		
		contArray[4][0].addChild(h4_1);
		contArray[4][0].addChild(w4_0);
		contArray[4][0].addChild(w4_1);
		contArray[4][0].addChild(h4_0);
		
		h4_0.x = -h4_0.getBounds().width-5;
		h4_0.y = (sizeArr[4][0][3]-h4_0.getBounds().height)/2;
		
		h4_1.x = -h4_1.getBounds().width-5;
		h4_1.y = sizeArr[4][2][1]+(sizeArr[4][2][3]-h4_1.getBounds().height)/2;
		
		w4_0.x = (sizeArr[4][0][2]-w4_0.getBounds().width)/2;
		w4_0.y = -w4_0.getBounds().height;
		
		w4_1.x = sizeArr[4][1][0]+(sizeArr[4][1][2]-w4_1.getBounds().width)/2;
		w4_1.y = -w4_1.getBounds().height;
	}
	catch(e)
	{
		alert("setTextContainer:" + e.toString());
	}
}


function createTextObject(str, f0, f1)
{
	try
	{
		var fc;
		
		if(f0)
		{
			fc = "#FF0000";
		}
		else
		{
			fc = "#000000";
		}
		
		var aT;
		var tT;
		
		if(f1)
		{
			aT = "32px Arial";
			tT = "italic 32px Times New Roman"
		}
		else
		{
			aT = "20px Arial";
			tT = "italic 20px Times New Roman"
		}
		
		
		var c = new createjs.Container();
		
		var subStr = str;
		
		var f = false;
		
		if(str.indexOf("-") == 0)
		{
			subStr = subStr.substring(1, subStr.length);
		
			var t0 = new createjs.Text("-", aT, fc);
			c.addChild(t0);
			f = true;
		}
		
		var t1;
		
		//
		if(str.indexOf("²") != -1)
		{
			subStr = subStr.substring(0, subStr.length-1);
			
			t1 = new createjs.Text(subStr, tT, fc);
			
			if(f)
			{
				t1.x = c.getBounds().width;
			}
			
			c.addChild(t1);
			
			var t2 = new createjs.Text("²", aT, fc);
			t2.x = c.getBounds().width;
			c.addChild(t2);
		}
		//辺のテキスト
		else if(str.indexOf("+") != -1 && str.indexOf("-") != -1)
		{
			var i;
			
			if(str.indexOf("+") != -1)
			{
				i = str.indexOf("+");
			}
			else
			{
				i = str.indexOf("-");
			}
			
			t1 = new createjs.Text(subStr(0, i), tT, fc);
			c.addChild(t1);
			
			var t2 = new createjs.Text(subStr(i, i+1), aT, fc);
			t2.x = c.getBounds().width;
			c.addChild(t2);
			
			var t3 = new createjs.Text(subStr(i+1, subStr.length), tT, fc);
			t3.x = c.getBounds().width;
			c.addChild(t3);
		}
		//それ以外
		else
		{
			t1 = new createjs.Text(subStr, tT, fc);
			
			if(f)
			{
				t1.x = c.getBounds().width;
			}
			
			c.addChild(t1);
		}
		
		return c;
	}
	catch(e)
	{
		alert("createTextObject:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		var id;
		
		if(e.target.checked)
		{
			id = parseInt(e.target.id.substring(6, 7));
		}
		else
		{
			id = -1;
		}
		
		changeModeHandler(id);
		
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

function changeModeHandler(id)
{
	try
	{
		selectId = id;
		selectParts = 0;
		
		changeFigureHandler(id, 0);
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}

function selectPartsHandler(e)
{
	try
	{
		var p;
		
		if(e.currentTarget.style.color != fcArray[1])
		{
			p = parseInt(e.currentTarget.id.substring(e.currentTarget.id.length-1, e.currentTarget.id.length));
		}
		else
		{
			p = parseInt(e.currentTarget.id.substring(e.currentTarget.id.length-1, e.currentTarget.id.length))-1;
		}
		
		//値と図を変更
		selectParts = p;
		
		changeFigureHandler(selectId, p);
		
		cs.update();
	}
	catch(e)
	{
		alert("selectPartsHandler:" + e.toString());
	}
}

function changeFigureHandler(id, p)
{
	try
	{
		var i;
		
		//チェックの切り替え
		for(var i=0; i<=4; i++)
		{
			if(i == id)
			{
				document.getElementById("gCheck"+i).checked = true;
				document.getElementById("form"+i).style.display = "block";
			}
			else
			{
				document.getElementById("gCheck"+i).checked = false;
				document.getElementById("form"+i).style.display = "none";
			}
			
			//四角形の表示
			if(i == id)
			{
				contArray[i][0].visible = true;
			}
			else
			{
				contArray[i][0].visible = false;
			}
		}
		
		//式の部分表示
		if(id == -1)
		{
			document.getElementById("guideText").style.display = "inline";
		}
		else
		{
			document.getElementById("guideText").style.display = "none";
			
			//式のパーツの色変更
			for(i=0; i<=4; i++)
			{
				if(i<p)
				{
					document.getElementById("p"+id+"_"+i).style.color = tcArray[2];
				}
				else if(i==p)
				{
					document.getElementById("p"+id+"_"+i).style.color = tcArray[1];
				}
				else
				{
					document.getElementById("p"+id+"_"+i).style.color = tcArray[0];
				}
			}
			
			if(p == 3 || p == 4)
			{
				document.getElementById("form"+id+"_1_1").style.display = "inline";
			}
			else
			{
				document.getElementById("form"+id+"_1_1").style.display = "none";
			}
			
			//四角形の描画変更
			changeSquare(id, p);
		}
	}
	catch(e)
	{
		alert("changeFigureHandler:" + e.toString());
	}
}

function changeSquare(id, p)
{
	try
	{
		var array = [];
		
		if(id == 0)
		{
			if(p == 0)
			{
				drawSquare(shapeArray[0][0], sizeArr[0][0][2], sizeArr[0][0][3], fcArray[0]);
				drawSquare(shapeArray[0][1], sizeArr[0][1][2], sizeArr[0][1][3], "#FFFFFF");
				drawSquare(shapeArray[0][2], sizeArr[0][2][2], sizeArr[0][2][3], "#FFFFFF");
				drawSquare(shapeArray[0][3], sizeArr[0][3][2], sizeArr[0][3][3], "#FFFFFF");
				
				tArray[0][0].visible = true;
				tArray[0][1].visible = false;
				tArray[0][2].visible = false;
				tArray[0][3].visible = false;
			}
			else if(p == 1)
			{
				drawSquare(shapeArray[0][0], sizeArr[0][0][2], sizeArr[0][0][3], fcArray[0]);
				drawSquare(shapeArray[0][1], sizeArr[0][1][2], sizeArr[0][1][3], fcArray[1]);
				drawSquare(shapeArray[0][2], sizeArr[0][2][2], sizeArr[0][2][3], "#FFFFFF");
				drawSquare(shapeArray[0][3], sizeArr[0][3][2], sizeArr[0][3][3], "#FFFFFF");
				
				tArray[0][0].visible = false;
				tArray[0][1].visible = true;
				tArray[0][2].visible = false;
				tArray[0][3].visible = false;
			}
			else if(p == 2)
			{
				drawSquare(shapeArray[0][0], sizeArr[0][0][2], sizeArr[0][0][3], fcArray[0]);
				drawSquare(shapeArray[0][1], sizeArr[0][1][2], sizeArr[0][1][3], fcArray[1]);
				drawSquare(shapeArray[0][2], sizeArr[0][2][2], sizeArr[0][2][3], fcArray[2]);
				drawSquare(shapeArray[0][3], sizeArr[0][3][2], sizeArr[0][3][3], "#FFFFFF");
				
				tArray[0][0].visible = false;
				tArray[0][1].visible = false;
				tArray[0][2].visible = true;
				tArray[0][3].visible = false;
			}
			else if(p == 3)
			{
				drawSquare(shapeArray[0][0], sizeArr[0][0][2], sizeArr[0][0][3], fcArray[0]);
				drawSquare(shapeArray[0][1], sizeArr[0][1][2], sizeArr[0][1][3], fcArray[1]);
				drawSquare(shapeArray[0][2], sizeArr[0][2][2], sizeArr[0][2][3], fcArray[2]);
				drawSquare(shapeArray[0][3], sizeArr[0][3][2], sizeArr[0][3][3], fcArray[3]);
				
				tArray[0][0].visible = false;
				tArray[0][1].visible = false;
				tArray[0][2].visible = false;
				tArray[0][3].visible = true;
			}
			else if(p == 4)
			{
				drawSquare(shapeArray[0][0], sizeArr[0][0][2], sizeArr[0][0][3], fcArray[4]);
				drawSquare(shapeArray[0][1], sizeArr[0][1][2], sizeArr[0][1][3], fcArray[4]);
				drawSquare(shapeArray[0][2], sizeArr[0][2][2], sizeArr[0][2][3], fcArray[4]);
				drawSquare(shapeArray[0][3], sizeArr[0][3][2], sizeArr[0][3][3], fcArray[4]);
				
				tArray[0][0].visible = false;
				tArray[0][1].visible = false;
				tArray[0][2].visible = false;
				tArray[0][3].visible = false;
			}
		}
		else if(id == 1)
		{
			if(p == 0)
			{
				drawSquare(shapeArray[1][0], sizeArr[1][0][2], sizeArr[1][0][3], fcArray[0]);
				drawSquare(shapeArray[1][1], sizeArr[1][1][2], sizeArr[1][1][3], "rgba(0,0,0,0)");
				drawSquare(shapeArray[1][2], sizeArr[1][2][2], sizeArr[1][2][3], "rgba(0,0,0,0)");
				drawSquare(shapeArray[1][3], sizeArr[1][3][2], sizeArr[1][3][3], "rgba(0,0,0,0)");
				
				tArray[1][0].visible = true;
				tArray[1][1].visible = false;
				tArray[1][2].visible = false;
				tArray[1][3].visible = false;
			}
			else if(p == 1)
			{
				drawSquare(shapeArray[1][0], sizeArr[1][0][2], sizeArr[1][0][3], fcArray[0]);
				drawSquare(shapeArray[1][1], sizeArr[1][1][2], sizeArr[1][1][3], fcArray[1]);
				drawSquare(shapeArray[1][2], sizeArr[1][2][2], sizeArr[1][2][3], "rgba(0,0,0,0)");
				drawSquare(shapeArray[1][3], sizeArr[1][3][2], sizeArr[1][3][3], "rgba(0,0,0,0)");
				
				tArray[1][0].visible = false;
				tArray[1][1].visible = true;
				tArray[1][2].visible = false;
				tArray[1][3].visible = false;
			}
			else if(p == 2)
			{
				drawSquare(shapeArray[1][0], sizeArr[1][0][2], sizeArr[1][0][3], fcArray[0]);
				drawSquare(shapeArray[1][1], sizeArr[1][1][2], sizeArr[1][1][3], "#FFFFFF");
				drawSquare(shapeArray[1][2], sizeArr[1][2][2], sizeArr[1][2][3], fcArray[2]);
				drawSquare(shapeArray[1][3], sizeArr[1][3][2], sizeArr[1][3][3], "rgba(0,0,0,0)");
				
				tArray[1][0].visible = false;
				tArray[1][1].visible = false;
				tArray[1][2].visible = true;
				tArray[1][3].visible = false;
			}
			else if(p == 3)
			{
				drawSquare(shapeArray[1][0], sizeArr[1][0][2], sizeArr[1][0][3], fcArray[0]);
				drawSquare(shapeArray[1][1], sizeArr[1][1][2], sizeArr[1][1][3], "#FFFFFF");
				drawSquare(shapeArray[1][2], sizeArr[1][2][2], sizeArr[1][2][3], "#FFFFFF");
				drawSquare(shapeArray[1][3], sizeArr[1][3][2], sizeArr[1][3][3], fcArray[3]);
				
				tArray[1][0].visible = false;
				tArray[1][1].visible = false;
				tArray[1][2].visible = false;
				tArray[1][3].visible = true;
			}
			else
			{
				drawSquare(shapeArray[1][0], sizeArr[1][0][2], sizeArr[1][0][3], fcArray[4]);
				drawSquare(shapeArray[1][1], sizeArr[1][1][2], sizeArr[1][1][3], "#FFFFFF");
				drawSquare(shapeArray[1][2], sizeArr[1][2][2], sizeArr[1][2][3], "#FFFFFF");
				drawSquare(shapeArray[1][3], sizeArr[1][3][2], sizeArr[1][3][3], "#FFFFFF");
				
				tArray[1][0].visible = false;
				tArray[1][1].visible = false;
				tArray[1][2].visible = false;
				tArray[1][3].visible = false;
			}
		}
		else if(id == 2)
		{
			if(p == 0)
			{
				drawSquare(shapeArray[2][0], sizeArr[2][0][2], sizeArr[2][0][3], fcArray[0]);
				drawSquare(shapeArray[2][1], sizeArr[2][1][2], sizeArr[2][1][3], "rgba(0,0,0,0)");
				drawSquare(shapeArray[2][2], sizeArr[2][2][2], sizeArr[2][2][3], "rgba(0,0,0,0)");
				drawSquare(shapeArray[2][3], sizeArr[2][3][2], sizeArr[2][3][3], "rgba(0,0,0,0)");
				
				tArray[2][0].visible = true;
				tArray[2][1].visible = false;
				tArray[2][2].visible = false;
				tArray[2][3].visible = false;
			}
			else if(p == 1)
			{
				drawSquare(shapeArray[2][0], sizeArr[2][0][2], sizeArr[2][0][3], fcArray[0]);
				drawSquare(shapeArray[2][1], sizeArr[2][1][2], sizeArr[2][1][3], fcArray[1]);
				drawSquare(shapeArray[2][2], sizeArr[2][2][2], sizeArr[2][2][3], "rgba(0,0,0,0)");
				drawSquare(shapeArray[2][3], sizeArr[2][3][2], sizeArr[2][3][3], "rgba(0,0,0,0)");
				
				tArray[2][0].visible = false;
				tArray[2][1].visible = true;
				tArray[2][2].visible = false;
				tArray[2][3].visible = false;
			}
			else if(p == 2)
			{
				drawSquare(shapeArray[2][0], sizeArr[2][0][2], sizeArr[2][0][3], fcArray[0]);
				drawSquare(shapeArray[2][1], sizeArr[2][1][2], sizeArr[2][1][3], fcArray[1]);
				drawSquare(shapeArray[2][2], sizeArr[2][2][2], sizeArr[2][2][3], fcArray[2]);
				drawSquare(shapeArray[2][3], sizeArr[2][3][2], sizeArr[2][3][3], "rgba(0,0,0,0)");
				
				tArray[2][0].visible = false;
				tArray[2][1].visible = false;
				tArray[2][2].visible = true;
				tArray[2][3].visible = false;
			}
			else if(p == 3)
			{
				drawSquare(shapeArray[2][0], sizeArr[2][0][2], sizeArr[2][0][3], fcArray[0]);
				drawSquare(shapeArray[2][1], sizeArr[2][1][2], sizeArr[2][1][3], fcArray[1]);
				drawSquare(shapeArray[2][2], sizeArr[2][2][2], sizeArr[2][2][3], "#FFFFFF");
				drawSquare(shapeArray[2][3], sizeArr[2][3][2], sizeArr[2][3][3], fcArray[3]);
				
				tArray[2][0].visible = false;
				tArray[2][1].visible = false;
				tArray[2][2].visible = false;
				tArray[2][3].visible = true;
			}
			else if(p == 4)
			{
				drawSquare(shapeArray[2][0], sizeArr[2][0][2], sizeArr[2][0][3], fcArray[4]);
				drawSquare(shapeArray[2][1], sizeArr[2][1][2], sizeArr[2][1][3], fcArray[4]);
				drawSquare(shapeArray[2][2], sizeArr[2][2][2], sizeArr[2][2][3], "#FFFFFF");
				drawSquare(shapeArray[2][3], sizeArr[2][3][2], sizeArr[2][3][3], "#FFFFFF");
				
				tArray[2][0].visible = false;
				tArray[2][1].visible = false;
				tArray[2][2].visible = false;
				tArray[2][3].visible = false;
			}
			
		}
		else if(id == 3)
		{
			if(p == 0)
			{
				drawSquare(shapeArray[3][0], sizeArr[3][0][2], sizeArr[3][0][3], fcArray[0]);
				drawSquare(shapeArray[3][1], sizeArr[3][1][2], sizeArr[3][1][3], "#FFFFFF");
				drawSquare(shapeArray[3][2], sizeArr[3][2][2], sizeArr[3][2][3], "#FFFFFF");
				drawSquare(shapeArray[3][3], sizeArr[3][3][2], sizeArr[3][3][3], "#FFFFFF");
				
				tArray[3][0].visible = true;
				tArray[3][1].visible = false;
				tArray[3][2].visible = false;
				tArray[3][3].visible = false;
			}
			else if(p == 1)
			{
				drawSquare(shapeArray[3][0], sizeArr[3][0][2], sizeArr[3][0][3], fcArray[0]);
				drawSquare(shapeArray[3][1], sizeArr[3][1][2], sizeArr[3][1][3], fcArray[1]);
				drawSquare(shapeArray[3][2], sizeArr[3][2][2], sizeArr[3][2][3], "#FFFFFF");
				drawSquare(shapeArray[3][3], sizeArr[3][3][2], sizeArr[3][3][3], "#FFFFFF");
				
				tArray[3][0].visible = false;
				tArray[3][1].visible = true;
				tArray[3][2].visible = false;
				tArray[3][3].visible = false;
			}
			else if(p == 2)
			{
				drawSquare(shapeArray[3][0], sizeArr[3][0][2], sizeArr[3][0][3], fcArray[0]);
				drawSquare(shapeArray[3][1], sizeArr[3][1][2], sizeArr[3][1][3], fcArray[1]);
				drawSquare(shapeArray[3][2], sizeArr[3][2][2], sizeArr[3][2][3], fcArray[2]);
				drawSquare(shapeArray[3][3], sizeArr[3][3][2], sizeArr[3][3][3], "#FFFFFF");
				
				tArray[3][0].visible = false;
				tArray[3][1].visible = false;
				tArray[3][2].visible = true;
				tArray[3][3].visible = false;
			}
			else if(p == 3)
			{
				drawSquare(shapeArray[3][0], sizeArr[3][0][2], sizeArr[3][0][3], fcArray[0]);
				drawSquare(shapeArray[3][1], sizeArr[3][1][2], sizeArr[3][1][3], fcArray[1]);
				drawSquare(shapeArray[3][2], sizeArr[3][2][2], sizeArr[3][2][3], fcArray[2]);
				drawSquare(shapeArray[3][3], sizeArr[3][3][2], sizeArr[3][3][3], fcArray[3]);
				
				tArray[3][0].visible = false;
				tArray[3][1].visible = false;
				tArray[3][2].visible = false;
				tArray[3][3].visible = true;
			}
			else if(p == 4)
			{
				drawSquare(shapeArray[3][0], sizeArr[3][0][2], sizeArr[3][0][3], fcArray[4]);
				drawSquare(shapeArray[3][1], sizeArr[3][1][2], sizeArr[3][1][3], fcArray[4]);
				drawSquare(shapeArray[3][2], sizeArr[3][2][2], sizeArr[3][2][3], fcArray[4]);
				drawSquare(shapeArray[3][3], sizeArr[3][3][2], sizeArr[3][3][3], fcArray[4]);
				
				tArray[3][0].visible = false;
				tArray[3][1].visible = false;
				tArray[3][2].visible = false;
				tArray[3][3].visible = false;
			}
		}
		else if(id == 4)
		{
			if(p == 0)
			{
				drawSquare(shapeArray[4][0], sizeArr[4][0][2], sizeArr[4][0][3], fcArray[0]);
				drawSquare(shapeArray[4][1], sizeArr[4][1][2], sizeArr[4][1][3], "#FFFFFF");
				drawSquare(shapeArray[4][2], sizeArr[4][2][2], sizeArr[4][2][3], "#FFFFFF");
				drawSquare(shapeArray[4][3], sizeArr[4][3][2], sizeArr[4][3][3], "#FFFFFF");
				
				tArray[4][0].visible = true;
				tArray[4][1].visible = false;
				tArray[4][2].visible = false;
				tArray[4][3].visible = false;
			}
			else if(p == 1)
			{
				drawSquare(shapeArray[4][0], sizeArr[4][0][2], sizeArr[4][0][3], fcArray[0]);
				drawSquare(shapeArray[4][1], sizeArr[4][1][2], sizeArr[4][1][3], fcArray[1]);
				drawSquare(shapeArray[4][2], sizeArr[4][2][2], sizeArr[4][2][3], "#FFFFFF");
				drawSquare(shapeArray[4][3], sizeArr[4][3][2], sizeArr[4][3][3], "#FFFFFF");
				
				tArray[4][0].visible = false;
				tArray[4][1].visible = true;
				tArray[4][2].visible = false;
				tArray[4][3].visible = false;
			}
			else if(p == 2)
			{
				drawSquare(shapeArray[4][0], sizeArr[4][0][2], sizeArr[4][0][3], fcArray[0]);
				drawSquare(shapeArray[4][1], sizeArr[4][1][2], sizeArr[4][1][3], fcArray[1]);
				drawSquare(shapeArray[4][2], sizeArr[4][2][2], sizeArr[4][2][3], fcArray[2]);
				drawSquare(shapeArray[4][3], sizeArr[4][3][2], sizeArr[4][3][3], "#FFFFFF");
				
				tArray[4][0].visible = false;
				tArray[4][1].visible = false;
				tArray[4][2].visible = true;
				tArray[4][3].visible = false;
			}
			else if(p == 3)
			{
				drawSquare(shapeArray[4][0], sizeArr[4][0][2], sizeArr[4][0][3], fcArray[0]);
				drawSquare(shapeArray[4][1], sizeArr[4][1][2], sizeArr[4][1][3], fcArray[1]);
				drawSquare(shapeArray[4][2], sizeArr[4][2][2], sizeArr[4][2][3], fcArray[2]);
				drawSquare(shapeArray[4][3], sizeArr[4][3][2], sizeArr[4][3][3], fcArray[3]);
				
				tArray[4][0].visible = false;
				tArray[4][1].visible = false;
				tArray[4][2].visible = false;
				tArray[4][3].visible = true;
			}
			else if(p == 4)
			{
				drawSquare(shapeArray[4][0], sizeArr[4][0][2], sizeArr[4][0][3], fcArray[4]);
				drawSquare(shapeArray[4][1], sizeArr[4][1][2], sizeArr[4][1][3], fcArray[4]);
				drawSquare(shapeArray[4][2], sizeArr[4][2][2], sizeArr[4][2][3], fcArray[4]);
				drawSquare(shapeArray[4][3], sizeArr[4][3][2], sizeArr[4][3][3], fcArray[4]);
				
				tArray[4][0].visible = false;
				tArray[4][1].visible = false;
				tArray[4][2].visible = false;
				tArray[4][3].visible = false;
			}
		}
	}
	catch(e)
	{
		alert("changeSquare:" + e.toString());
	}
}

function drawSquare(sp, w, h, c)
{
	try
	{
		sp.graphics.clear();
		sp.graphics.beginStroke("#000000");
		sp.graphics.setStrokeStyle(2);
		sp.graphics.beginFill(c);
		sp.graphics.drawRect(0, 0, w, h);
		sp.graphics.endFill();
	}
	catch(e)
	{
		alert("drawSquare" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = selectId;
		array[1] = selectParts;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		selectId = array[0];
		selectParts = array[1];
		
		changeFigureHandler(selectId, selectParts);
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		changeModeHandler(0);
		
		cs.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}