// JavaScript Document
var cs;
var cc;

var cW;
var cH;

var dataU;
var dataA;
var dataB;

var checkNum;

var pattern;

//図の数値
var arc;
var fill;

//式
var canvas;
var stage;

//塗りの色
var fColor;

//縁
var arcU;
var arcA;
var arcB;

var ctU;
var ctA;
var ctB;


//各記号
var tA;
var tB;

var s0;
var s1;

//記号の当たり判定および否定のバー
var sA;
var sB;
var sS;
var bA;
var bB;
var bC;


//数値のテキスト
var numArray;

//図の設定用の値
var cAX;
var cAY;
var cAL;
var cBX;
var cBY;
var cBL;

var pAX;
var pAY;
var pBX;
var pBY;
var pSX;
var pSY;
var pSX;
var pSY;

var rX;
var rY;
var rW;
var rH;

var rA0;
var rA1;
var rB0;
var rB1;

var sImg0;
var sImg1;
var loadFlag;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 650;
}

var baseX;
var baseY;

function loadContentHandler()
{
	try
	{
		//スマートフォン
		var ua = navigator.userAgent;
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			browse = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			browse = true;
		}
		else
		{
			browse = false;
		}
		
		
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		fColor = "rgba(246,244,229,1)";
		
		cW = 500;
		cH = 380;
		
		document.getElementById("windowBlock").style.textAlign="left";
		document.getElementById("windowBlock").style.marginRight = "10px";
		document.getElementById("windowBlock").style.width = "430px";
		
		document.getElementById("content").style.marginLeft = "10px";
		
		document.getElementById("optionBlock").style.width = "600px";
		document.getElementById("optionU").addEventListener("click", openOptionHandler);
		document.getElementById("optionA").addEventListener("click", openOptionHandler);
		document.getElementById("optionB").addEventListener("click", openOptionHandler);
		document.getElementById('optionClose').addEventListener('click', closeModalHandler);
		
		document.getElementById('gCheck0').checked = true;
		document.getElementById('gCheck1').checked = true;
		document.getElementById('gCheck2').checked = true;
		document.getElementById('gCheck3').checked = false;
		document.getElementById('gCheck4').checked = false;
		
		document.getElementById('gCheck0').addEventListener("change", changeModeHandler);
		document.getElementById('gCheck1').addEventListener("change", changeModeHandler);
		document.getElementById('gCheck2').addEventListener("change", changeModeHandler);
		document.getElementById('gCheck3').addEventListener("change", changeModeHandler);
		document.getElementById('gCheck4').addEventListener("change", changeModeHandler);
		
		for(var i=1; i<=12; i++)
		{
			document.getElementById("num"+i).style.cursor = "pointer";
			document.getElementById("num"+i).addEventListener("click", selectNumberHandler);
		}
		
		pattern = [true, true, true, false];
		
		//データの設定
		var d = 0;
		
		//教科書データ
		if(d == 0)
		{
			setData([1,2,3,4,5,6,7,8,9], 0);
			setData([1,2,3,6], 1);
			setData([2,4,6,8], 2);
		}
		/*以下テスト用データ*/
		/*3つ空集合*/
		else if(d==1)
		{
			setData([], 0);
			setData([], 1);
			setData([], 2);
		}
		/*3つ同じ集合*/
		else if(d==2)
		{
			setData([1,2,3,6], 0);
			setData([1,2,3,6], 1);
			setData([1,2,3,6], 2);
		}
		/*UとAが同じ*/
		else if(d==3)
		{
			setData([1,2,3,6], 0);
			setData([1,2,3,6], 1);
			setData([1,2], 2);
		}
		/*UとAが同じ　Bが空集合*/
		else if(d==4)
		{
			setData([1,2,3,6], 0);
			setData([1,2,3,6], 1);
			setData([], 2);
		}
		/*UとBが同じ*/
		else if(d==5)
		{
			setData([1,2,3,6], 0);
			setData([1,2], 1);
			setData([1,2,3,6], 2);
		}
		/*UとBが同じ　Aが空集合*/
		else if(d==6)
		{
			setData([1,2,3,6], 0);
			setData([], 1);
			setData([1,2,3,6], 2);
		}
		/*AとBが空集合*/
		else if(d==7)
		{
			setData([1,2,3,6], 0);
			setData([], 1);
			setData([], 2);
		}
		/*AとBが同じ*/
		else if(d==8)
		{
			/*UとAが同じ*/
			setData([1,2,3,6], 0);
			setData([2,4,6,8], 1);
			setData([2,4,6,8], 2);
		}
		else if(d == 9)
		{
			/*UとAが同じ*/
			setData([1,2,3,4,5,6,7,8,9], 0);
			setData([], 1);
			setData([2,4,6,8], 2);
		}
		else if(d == 10)
		{
			/*UとAが同じ*/
			setData([1,2,3,4,5,6,7,8,9], 0);
			setData([1,2,3,4], 1);
			setData([], 2);
		}
		
		
		document.getElementById("changeDataBtn").style.marginTop = "20px";
		document.getElementById("changeDataBtn").addEventListener("click", setDataHandler);
		
		document.getElementById("resetBtn").style.marginTop = "20px";
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		document.getElementById("formCanvas").style.display = "inline";
		document.getElementById("formCanvas").style.verticalAlign = "middle";
		
		document.getElementById('gCheck0').style.display = "none";
		document.getElementById('gCheck1').style.display = "none";
		document.getElementById('gCheck2').style.display = "none";
		
		setModal("optionBlock");
		
		//図の設定
		//値の設定
		//基準の位置からのずれ
		baseX = 45;
		baseY = 25;
		
		//集合Ａ
		cAX = 150 + baseX;
		cAY = 150 + baseY;
		cAL = 150;
		
		//集合Ｂ
		cBX = 280 + baseX;
		cBY = 150 + baseY;
		cBL = 135;
		
		//集合Ａの値の位置
		pAX = 70 + baseX;
		pAY = 70 + baseY;
		
		//集合Ｂの値の位置
		pBX = 310 + baseX;
		pBY = 70 + baseY;
		
		//集合Ａ，Ｂの共通の位置
		pSX = 205 + baseX;
		pSY = 70 + baseY;
		
		//Ａ，Ｂの集合外
		pUX = baseX;
		pUY = 310 + baseY;
		
		//交点の座標
		cX = 231 + baseX;
		cY0 = 24 + baseY;
		cY1 = 276 + baseY;
		
		rA0 = Math.atan2(cY0 - cAY, cX - cAX);
		rA1 = Math.atan2(cY1 - cAY, cX - cAX);
		
		rB0 = Math.atan2(cY0 - cBY, cX - cBX);
		rB1 = Math.atan2(cY1 - cBY, cX - cBX);
		
		//集合A
		//塗り
		fill = new createjs.Shape();
		cs.addChild(fill);
		
		//縁
		arcU = new createjs.Shape();
		arcA = new createjs.Shape();
		arcB = new createjs.Shape();
		cs.addChild(arcU);
		cs.addChild(arcA);
		cs.addChild(arcB);
		
		arcB.graphics.setStrokeStyle(2);
		arcB.graphics.beginStroke("rgba(0,0,0,1)");
		arcB.graphics.arc(cBX, cBY, cBL, -Math.PI*6.5/15, -Math.PI*8/15, false, "#000000");
		arcB.graphics.endStroke();
		
		rX = -20+baseX;
		rY = -15+baseY;
		rW = 460;
		rH = 360;
		
		//記号
		ctU = new createjs.Text("U", "italic 36px Times New Roman");
		ctU.x = 55 + baseX;
		ctU.y = -30 + baseY;
		
		ctA = new createjs.Text("A", "italic 36px Times New Roman");
		ctA.x = 50 + baseX;
		ctA.y = 5 + baseY;
		
		ctB = new createjs.Text("B", "italic 36px Times New Roman");
		ctB.x = 275 + baseX;
		ctB.y = 0 + baseY;
		
		cs.addChild(ctU);
		cs.addChild(ctA);
		cs.addChild(ctB);
		
		//式の設定
		canvas = document.getElementById("formCanvas");
		stage = new createjs.Stage(canvas);
		createjs.Touch.enable(canvas);
		//記号
		tA = new createjs.Text("A", "italic 42px Times New Roman", "#000000");
		stage.addChild(tA);
		tA.x = 10;
		tA.y = 35;
		
		tB = new createjs.Text("B", "italic 42px Times New Roman", "#000000");
		stage.addChild(tB);
		tB.x = 83;
		tB.y = 35;
		
		loadFlag = [false, false];
		
		sImg0 = new Image();
		sImg0.setAttribute("id", "sImg0");
		sImg1 = new Image();
		sImg1.setAttribute("id", "sImg1");
		
		var loadSymbolImageHandler = function(event)
		{
			if(event.target.id == "sImg0")
			{
				loadFlag[0] = true;
			}
			else
			{
				loadFlag[1] = true;
			}
			
			if(loadFlag[0] && loadFlag[1])
			{
				//和集合
				s0 = new createjs.Bitmap("./img/sym1.png");
				stage.addChild(s0);
				s0.x = 40;
				s0.scaleX = 36/48;
				s0.scaleY = 36/48;
				
				//共通部分
				s1 = new createjs.Bitmap("./img/sym0.png");
				stage.addChild(s1);
				s1.x = 40;
				s1.scaleX = 36/48;
				s1.scaleY = 36/48;
				
				if(window.navigator.userAgent.indexOf("Firefox") != -1)
				{
					s0.y = 37;
					s1.y = 37;
				}
				else
				{
					s0.y = 40;
					s1.y = 40;
				}
				
				s1.visible = false;
				
				stage.update();
			}
			
			event.target.onload = null;
		}
		
		sImg0.onload = loadSymbolImageHandler;
		sImg1.onload = loadSymbolImageHandler;
		
		sImg0.src = "./img/sym0.png";
		sImg1.src = "./img/sym1.png";
		
		s0 = new createjs.Bitmap();
		stage.addChild(s0);
		
		s1 = new createjs.Bitmap();
		stage.addChild(s1);
		
		
		//Ａの選択範囲
		sA = new createjs.Shape();
		stage.addChild(sA);
		sA.name = "sA";
		sA.x = 5;
		sA.y = 35;
		sA.graphics.setStrokeStyle(0);
		sA.graphics.beginFill("rgba(255, 255, 255, 0.1)");
		sA.graphics.drawRect(0, 0, 36, 36);
		sA.graphics.endFill();
		sA.addEventListener("mousedown", changeFormula);
		
		//Ｂの選択範囲
		sB = new createjs.Shape();
		stage.addChild(sB);
		sB.name = "sB";
		sB.x = 77;
		sB.y = 35;
		sB.graphics.setStrokeStyle(0);
		sB.graphics.beginFill("rgba(255, 255, 255, 0.1)");
		sB.graphics.drawRect(0, 0, 36, 36);
		sB.graphics.endFill();
		sB.addEventListener("mousedown", changeFormula);
		
		//記号の選択範囲
		sS = new createjs.Shape();
		stage.addChild(sS);
		sS.name = "sS";
		sS.x = 40;
		sS.y = 37;
		sS.graphics.setStrokeStyle(0);
		sS.graphics.beginFill("rgba(255, 255, 255, 0.1)");
		sS.graphics.drawRect(0, 0, 36, 36);
		sS.graphics.endFill();
		sS.addEventListener("mousedown", changeFormula);
		
		//Ａの否定
		bA = new createjs.Shape();
		stage.addChild(bA);
		bA.name = "bA";
		bA.x = 5;
		bA.y = 20;
		bA.graphics.setStrokeStyle(0);
		bA.graphics.beginFill("rgba(255, 255, 255, 0.1)");
		bA.graphics.drawRect(0, 0, 36, 20);
		bA.graphics.endFill();
		bA.graphics.beginFill("rgba(0, 0, 0, 1)");
		bA.graphics.drawRect(0, 7, 36, 4);
		bA.graphics.endFill();
		bA.addEventListener("mousedown", changeFormula);
		
		//Ｂの否定
		bB = new createjs.Shape();
		stage.addChild(bB);
		bB.name = "bB";
		bB.x = 77;
		bB.y = 20;
		bB.graphics.setStrokeStyle(0);
		bB.graphics.beginFill("rgba(255, 255, 255, 0.1)");
		bB.graphics.drawRect(0, 0, 36, 20);
		bB.graphics.endFill();
		bB.graphics.beginFill("rgba(0, 0, 0, 1)");
		bB.graphics.drawRect(0, 7, 36, 4);
		bB.graphics.endFill();
		bB.addEventListener("mousedown", changeFormula);
		
		//全体の否定
		bC = new createjs.Shape();
		stage.addChild(bC);
		bC.name = "bC";
		bC.x = 5;
		bC.y = 0;
		bC.graphics.setStrokeStyle(0);
		bC.graphics.beginFill("rgba(255, 255, 255, 0.1)");
		bC.graphics.drawRect(0, 0, 108, 20);
		bC.graphics.endFill();
		bC.graphics.beginFill("rgba(0, 0, 0, 1)");
		bC.graphics.drawRect(0, 10, 108, 4);
		bC.graphics.endFill();
		bC.addEventListener("mousedown", changeFormula);
		
		//初期設定
		
		bA.alpha = 0.2;
		bB.alpha = 0.2;
		
		s0.alpha = 1;
		s1.alpha = 0.2;
		
		bC.alpha = 0.2;
		
		//数値
		numArray = [];
		for(i=1; i<=12; i++)
		{
			numArray[i] = new createjs.Text(i, "24px Arial");
			cs.addChild(numArray[i]);
		}
		
		checkFormula();
		
		cs.update();
		stage.update();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function changeModeHandler(e)
{
	try
	{
		var index = parseInt(e.currentTarget.id.substring(6, 7));
		
		if(!e.currentTarget.checked)
		{
			index--;
		}
		
		for(var i=0; i<=3; i++)
		{
			if(i<=index)
			{
				document.getElementById("gCheck"+i).checked = true;
			}
			else
			{
				document.getElementById("gCheck"+i).checked = false;
			}
		}
		
		checkFormula();
		
		cs.update();
		stage.update();
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}

function openOptionHandler(e)
{
	try
	{
		var array;
		
		var f;
		
		if(e.target.id == "optionU")
		{
			f = true;
			document.getElementById('selectData').innerHTML = "U";
			array = dataU.slice();
		}
		else if(e.target.id == "optionA")
		{
			f = false;
			document.getElementById('selectData').innerHTML = "A";
			array = dataA.slice();
		}
		else
		{
			f = false;
			document.getElementById('selectData').innerHTML = "B";
			array = dataB.slice();
		}
		
		for(var i=1; i<=12; i++)
		{
			//全体
			if(f)
			{
				if(dataA.indexOf(i) != -1 || dataB.indexOf(i) != -1)
				{
					document.getElementById("num"+i).style.color = "#000099";
				}
				else if(array.indexOf(i) != -1)
				{
					document.getElementById("num"+i).style.color = "rgb(255, 0, 0)";
				}
				else
				{
					document.getElementById("num"+i).style.color = "rgb(128, 128, 128)";
				}
			}
			//個別の集合
			else
			{
				if(dataU.indexOf(i) == -1)
				{
					document.getElementById("num"+i).style.color = "#000099";
				}
				else if(array.indexOf(i) != -1)
				{
					document.getElementById("num"+i).style.color = "rgb(255, 0, 0)";
				}
				else
				{
					document.getElementById("num"+i).style.color = "rgb(128, 128, 128)";
				}
			}
		}
		
		document.getElementById("alertText").innerHTML = " ";
		
		//式の値を設定
		showModal('optionBlock');
	}
	catch(e)
	{
		alert("openOptionHandler:" + e.toString());
	}
}

function closeModalHandler(e)
{
	try
	{
		//オプションを閉じる
		closeModal();

	}
	catch(e)
	{
		alert('closeModalHandler:' + e.toString());
	}
}

function selectNumberHandler(e)
{
	try
	{
		var id = e.currentTarget.id;
		var num = parseInt(id.substring(3, id.length));
		
		//全体
		if(document.getElementById('selectData').innerHTML == "U")
		{
			if(dataA.indexOf(num) == -1 && dataB.indexOf(num) == -1)
			{
				if(e.target.style.color == "rgb(255, 0, 0)")
				{
					e.target.style.color = "rgb(128, 128, 128)";
				}
				else
				{
					e.target.style.color = "rgb(255, 0, 0)";
				}
				
				document.getElementById("alertText").innerHTML = ' ';
			}
			else
			{
				document.getElementById("alertText").innerHTML = '<span class="times">A</span>,<span class="times">B</span>に含まれる値は解除できません。';
			}
		}
		//各集合
		else
		{
			if(dataU.indexOf(num) != -1)
			{
				if(e.target.style.color == "rgb(255, 0, 0)")
				{
					e.target.style.color = "rgb(128, 128, 128)";
				}
				else
				{
					e.target.style.color = "rgb(255, 0, 0)";
				}
				
				document.getElementById("alertText").innerHTML = ' ';
			}
			else
			{
				document.getElementById("alertText").innerHTML = '<span class="times">U</span>に含まれていない値です。';
			}
		}
	}
	catch(e)
	{
		alert("selectNumberHandler:" + e.toString());
	}
}


function setDataHandler(e)
{
	try
	{
		var array = [];
		
		for(var i=1; i<=12; i++)
		{
			if(document.getElementById("selectData").innerHTML == "U")
			{
				if(document.getElementById('num'+i).style.color != "rgb(128, 128, 128)")
				{
					array.push(i);
				}
			}
			else
			{
				if(document.getElementById('num'+i).style.color == "rgb(255, 0, 0)")
				{
					array.push(i);
				}
			}
		}
		
		if(document.getElementById("selectData").innerHTML == "U")
		{
			setData(array, 0);
		}
		else if(document.getElementById("selectData").innerHTML == "A")
		{
			setData(array, 1);
		}
		else
		{
			setData(array, 2);
		}
		
		//オプションを閉じる
		closeModal();
		
		checkFormula();
		//オブジェクトの表示データを更新
		setParts();
		
		cs.update();
		stage.update();
	}
	catch(e)
	{
		alert("setDataHandler:" + e.toString());
	}
}

function setData(array, f)
{
	try
	{
		var elm;
		
		if(f == 0)
		{
			dataU = array.slice();
			elm = document.getElementById("dataU");
			
			if(array.length != 0)
			{
				document.getElementById("dSpanU0").style.display = "inline";
				document.getElementById("dSpanU1").style.display = "none";
			}
			else
			{
				document.getElementById("dSpanU0").style.display = "none";
				document.getElementById("dSpanU1").style.display = "inline";
			}
		}
		else if(f == 1)
		{
			dataA = array.slice();
			elm = document.getElementById("dataA");
			
			if(array.length != 0)
			{
				document.getElementById("dSpanA0").style.display = "inline";
				document.getElementById("dSpanA1").style.display = "none";
			}
			else
			{
				document.getElementById("dSpanA0").style.display = "none";
				document.getElementById("dSpanA1").style.display = "inline";
			}
		}
		else
		{
			dataB = array.slice();
			elm = document.getElementById("dataB");
			
			if(array.length != 0)
			{
				document.getElementById("dSpanB0").style.display = "inline";
				document.getElementById("dSpanB1").style.display = "none";
			}
			else
			{
				document.getElementById("dSpanB0").style.display = "none";
				document.getElementById("dSpanB1").style.display = "inline";
			}
		}
		
		var str = "";
		
		for(var i=0; i<array.length; i++)
		{
			str += array[i];
			
			if(i != array.length-1)
			{
				str += ", ";
			}
		}
		
		elm.innerHTML = str;
	}
	catch(e)
	{
		alert("setData:" + e.toString());
	}
}

function changeFormula(e)
{
	try
	{
		//Ａの操作
		if(e.target.name == "sA")
		{
			if(tA.alpha != 1)
			{
				tA.alpha = 1;
				bA.visible = true;
				bA.alpha = 0.2;
				
				if(tB.alpha == 1)
				{
					bC.visible = true;
					bC.alpha = 0.2;
					
					if(s0.visible == true)
					{
						s0.alpha = 1;
					}
					else
					{
						s1.alpha = 1;
					}
				}
			}
			else if((bC.alpha == 0.2 && bC.visible == true) || bC.visible == false)
			{
				tA.alpha = 0.2;
				bA.visible = false;
				bA.alpha = 0.2;
				
				bC.visible = false;
				
				if(s0.visible == true)
				{
					s0.alpha = 0.2;
				}
				else
				{
					s1.alpha = 0.2;
				}
				
				if(tB.alpha != 1)
				{
					bC.visible = false;
					bC.alpha = 0.2;
				}
				
				if(s0.visible == true)
				{
					s0.alpha = 0.2;
				}
				else
				{
					s1.alpha = 0.2;
				}
			}
		}
		//Ａの否定の操作
		else if(e.target.name == "bA")
		{
			if(bA.alpha != 1)
			{
				bA.alpha = 1;
			}
			else
			{
				bA.alpha = 0.2;
			}
		}
		//Ｂの操作
		else if(e.target.name == "sB")
		{
			//Bの表示
			if(tB.alpha != 1)
			{
				tB.alpha = 1;
				bB.visible = true;
				bB.alpha = 0.2;
				
				if(tA.alpha == 1)
				{
					bC.visible = true;
					bC.alpha = 0.2;
					
					if(s0.visible == true)
					{
						s0.alpha = 1;
					}
					else
					{
						s1.alpha = 1;
					}
				}
			}
			//Bの非表示
			else if((bC.alpha == 0.2 && bC.visible == true) || bC.visible == false)
			{
				tB.alpha = 0.2;
				bB.visible = false;
				bB.alpha = 0.2;
				
				bC.visible = false;
				
				if(s0.visible == true)
				{
					s0.alpha = 0.2;
				}
				else
				{
					s1.alpha = 0.2;
				}
				
				if(tA.alpha != 1)
				{
					bC.visible = false;
					bC.alpha = 0.2;
				}
				
				if(s0.visible == true)
				{
					s0.alpha = 0.2;
				}
				else
				{
					s1.alpha = 0.2;
				}
			}
		}
		//Ｂの否定の操作
		else if(e.target.name == "bB")
		{
			if(bB.alpha != 1)
			{
				bB.alpha = 1;
			}
			else
			{
				bB.alpha = 0.2;
			}
		}
		//記号の操作
		else if(e.target.name == "sS")
		{
			if(tA.alpha != 1)
			{
				tA.alpha = 1;
				bA.visible = true;
				bA.alpha = 0.2;
			}
			
			if(tB.alpha != 1)
			{
				tB.alpha = 1;
				bB.visible = true;
				bB.alpha = 0.2;
			}
			
			if(bC.visible == false)
			{
				bC.visible = true;
				bC.alpha = 0.2;
			}
			
			if((s0.visible == true && s0.alpha != 1) || (s1.visible == true && s1.alpha == 1))
			{
				s0.visible = true;
				s0.alpha = 1;
				s1.visible = false;
				s1.alpha = 0.2;
			}
			else
			{
				s0.visible = false;
				s0.alpha = 0.2;
				s1.visible = true;
				s1.alpha = 1;
			}
		}
		//全体の否定の操作
		else if(e.target.name == "bC")
		{
			if(bC.alpha != 1)
			{
				bC.alpha = 1;
			}
			else
			{
				bC.alpha = 0.2;
			}
		}
		
		checkFormula();
		
		//オブジェクトの表示データを更新
		setParts();
		
		stage.update();
		cs.update();
	}
	catch(e)
	{
		alert("changeFormula:" + e.toString());
	}
}

function setParts()
{
	try
	{
		parts = [];
		parts[0] = [tA.visible, tA.alpha];
		parts[1] = [tB.visible, tB.alpha];
		parts[2] = [s0.visible, s0.alpha];
		parts[3] = [s1.visible, s1.alpha];
		parts[4] = [bA.visible, bA.alpha];
		parts[5] = [bB.visible, bB.alpha];
		parts[6] = [bC.visible, bC.alpha];
	}
	catch(e)
	{
		alert("setParts:" + e.toString());
	}
}

//キャンバスの状態を見て描画のパターンを判別
function checkFormula()
{
	try
	{
		var p;
		
		var q;
		
		if(dataU.toString() == dataA.toString() && dataU.toString() == dataB.toString())
		{
			if(dataU.length == 0)
			{
				p = 0;
			}
			else
			{
				p = checkPattern(-3);
			}
		}
		else if(dataU.toString() == dataA.toString())
		{
			p = checkPattern(-2);
		}
		else if(dataU.toString() == dataB.toString())
		{
			p = checkPattern(-1);
		}
		//数値が同じ場合
		else if(dataA.toString() == dataB.toString())
		{
			//どちらも空集合
			if(dataA.length == 0)
			{
				p = checkPattern(0);
			}
			//どちらもデータがある
			else
			{
				p = checkPattern(1);
			}
		}
		//Aが空集合
		else if(dataA.length == 0)
		{
			p = checkPattern(2);
		}
		//Bが空集合
		else if(dataB.length == 0)
		{
			p = checkPattern(3);
		}
		else
		{
			//Ａのみ
			if(tA.alpha == 1 && bA.alpha != 1 && tB.alpha != 1)
			{
				p = 1;
			}
			//Ａの否定
			else if(tA.alpha == 1 && bA.alpha == 1 && tB.alpha != 1)
			{
				p = 2;
			}
			//Ｂのみ
			else if(tB.alpha == 1 && bB.alpha != 1 && tA.alpha != 1)
			{
				p = 3;
			}
			//Ｂの否定
			else if(tB.alpha == 1 && bB.alpha == 1 && tA.alpha != 1)
			{
				p = 4;
			}
			//ＡとＢの組み合わせの場合
			else if(tA.alpha == 1 && tB.alpha == 1)
			{
				//Ａ，Ｂの和集合
				if(s0.alpha == 1 && bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					p = 5;
				}
				//Ａの否定とＢの否定の共通部分の否定
				else if(s1.alpha == 1 && bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					p = 5;
				}
				//Ａ，Ｂの和集合の否定
				else if(s0.alpha == 1 && bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					p = 6;
				}
				//Ａの否定とＢの否定の共通部分
				else if(s1.alpha == 1 && bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					p = 6;
				}
				//Ａ，Ｂの共通部分
				else if(s1.alpha == 1 && bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					p = 7;
				}
				//Ａの否定とＢの否定の和集合の否定
				else if(s0.alpha == 1 && bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					p = 7;
				}
				//Ａ，Ｂの共通部分の否定
				else if(s1.alpha == 1 && bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					p = 8;
				}
				//Ａの否定とＢの否定の和集合
				else if(s0.alpha == 1 && bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					p = 8;
				}
				//Ａの否定とＢの和集合
				else if(s0.alpha == 1 && bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					p = 9;
				}
				//ＡとＢの否定の共通部分の否定
				else if(s1.alpha == 1 && bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					p = 9;
				}
				//ＡとＢの否定の和集合
				else if(s0.alpha == 1 && bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					p = 10;
				}
				//Ａの否定とＢの共通部分の否定
				else if(s1.alpha == 1 && bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					p = 10;
				}
				//Ａの否定とＢの和集合の否定
				else if(s0.alpha == 1 && bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					p = 11;
				}
				//ＡとＢの否定の共通部分
				else if(s1.alpha == 1 && bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					p = 11;
				}
				//ＡとＢの否定の和集合の否定
				else if(s0.alpha == 1 && bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					p = 12;
				}
				//Ａの否定とＢの共通部分
				else if(s1.alpha == 1 && bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					p = 12;
				}
				else
				{
					p = 0;
				}
			}
			//塗りなし
			else
			{
				p = 0;
			}
		}
		
		//図のチェックがない場合
		if(!document.getElementById("gCheck3").checked)
		{
			p = -1;
		}
		
		changeCanvas(p);
	}
	catch(e)
	{
		alert("checkFormula:" + e.toString());
	}
}

function checkPattern(t)
{
	try
	{
		var p;
		
		//U, A, Bが同じ場合
		if(t == -3)
		{
			if(tA.alpha == 1 && bA.alpha != 1 && tB.alpha != 1)
			{
				p = 13;
			}
			else  if(tA.alpha == 1 && bA.alpha == 1 && tB.alpha != 1)
			{
				p = 0;
			}
			else if(tB.alpha == 1 && bB.alpha != 1 && tA.alpha != 1)
			{
				p = 13;
			}
			else if(tB.alpha == 1 && bB.alpha == 1 && tA.alpha != 1)
			{
				p = 0;
			}
			else if(tA.alpha == 1 && tB.alpha == 1)
			{
				//和集合
				if(s0.alpha == 1)
				{
					//A　と　B　の和集合
					if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						p = 13;
					}
					//Aの否定　と　B　の和集合
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						p = 13;
					}
					//A　と　Bの否定　の和集合
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						p = 13;
					}
					//Aの否定　と　Bの否定　の和集合
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						p = 0;
					}
					//A　と　B　の和集合の否定
					else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						p = 0;
					}
					//Aの否定　と　B　の和集合の否定
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						p = 0;
					}
					//A　と　Bの否定　の和集合の否定
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						p = 0;
					}
					//Aの否定　と　Bの否定　の和集合の否定
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						p = 13;
					}
				}
				//共通部分
				else
				{
					//A　と　B　の共通部分
					if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						p = 13;
					}
					//Aの否定　と　B　の共通部分
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						p = 0;
					}
					//A　と　Bの否定　の共通部分
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						p = 0;
					}
					//Aの否定　と　Bの否定　の共通部分
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						p = 0;
					}
					//A　と　B　の共通部分の否定
					else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						p = 0;
					}
					//Aの否定　と　B　の共通部分の否定
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						p = 13;
					}
					//A　と　Bの否定　の共通部分の否定
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						p = 13;
					}
					//Aの否定　と　Bの否定　の共通部分の否定
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						p = 13;
					}
				}
			}
			else
			{
				p = 0;
			}
		}
		
		//UとAが同じ場合
		else if(t == -2)
		{
			if(tA.alpha == 1 && bA.alpha != 1 && tB.alpha != 1)
			{
				p = 13;
			}
			else  if(tA.alpha == 1 && bA.alpha == 1 && tB.alpha != 1)
			{
				p = 0;
			}
			else if(tB.alpha == 1 && bB.alpha != 1 && tA.alpha != 1)
			{
				if(dataB.length == 0)
				{
					p = 0;
				}
				else
				{
					p = 3;
				}
			}
			else if(tB.alpha == 1 && bB.alpha == 1 && tA.alpha != 1)
			{
				if(dataB.length == 0)
				{
					p = 13;
				}
				else
				{
					p = 4;
				}
			}
			else if(tA.alpha == 1 && tB.alpha == 1)
			{
				//和集合
				if(s0.alpha == 1)
				{
					//A　と　B　の和集合
					if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
					//Aの否定　と　B　の和集合
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 3;
						}
					}
					//A　と　Bの否定　の和集合
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
					//Aの否定　と　Bの否定　の和集合
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 4;
						}
					}
					//A　と　B　の和集合の否定
					else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//Aの否定　と　B　の和集合の否定
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 4;
						}
					}
					//A　と　Bの否定　の和集合の否定
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//Aの否定　と　Bの否定　の和集合の否定
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 3;
						}
					}
				}
				//共通部分
				else
				{
					//A　と　B　の共通部分
					if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 3;
						}
					}
					//Aの否定　と　B　の共通部分
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//A　と　Bの否定　の共通部分
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 4;
						}
					}
					//Aの否定　と　Bの否定　の共通部分
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//A　と　B　の共通部分の否定
					else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 4;
						}
					}
					//Aの否定　と　B　の共通部分の否定
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
					//A　と　Bの否定　の共通部分の否定
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 3;
						}
					}
					//Aの否定　と　Bの否定　の共通部分の否定
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataB.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
				}
			}
			else
			{
				p = 0;
			}
		}
		
		//UとBが同じ場合
		else if(t == -1)
		{
			if(tA.alpha == 1 && bA.alpha != 1 && tB.alpha != 1)
			{
				if(dataA.length == 0)
				{
					p = 0;
				}
				else
				{
					p = 1;
				}
			}
			else  if(tA.alpha == 1 && bA.alpha == 1 && tB.alpha != 1)
			{
				if(dataA.length == 0)
				{
					p = 13;
				}
				else
				{
					p = 2;
				}
			}
			else if(tB.alpha == 1 && bB.alpha != 1 && tA.alpha != 1)
			{
				p = 13;
			}
			else if(tB.alpha == 1 && bB.alpha == 1 && tA.alpha != 1)
			{
				p = 0;
			}
			else if(tA.alpha == 1 && tB.alpha == 1)
			{
				//和集合
				if(s0.alpha == 1)
				{
					//A　と　B　の和集合
					if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
					//Aの否定　と　B　の和集合
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
					//A　と　Bの否定　の和集合
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 13;
						}
					}
					//Aの否定　と　Bの否定　の和集合
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 2;
						}
					}
					//A　と　B　の和集合の否定
					else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//Aの否定　と　B　の和集合の否定
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//A　と　Bの否定　の和集合の否定
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 0;
						}
					}
					//Aの否定　と　Bの否定　の和集合の否定
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 1;
						}
					}
				}
				//共通部分
				else
				{
					//A　と　B　の共通部分
					if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 1;
						}
					}
					//Aの否定　と　B　の共通部分
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 2;
						}
					}
					//A　と　Bの否定　の共通部分
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//Aの否定　と　Bの否定　の共通部分
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 0;
						}
					}
					//A　と　B　の共通部分の否定
					else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 2;
						}
					}
					//Aの否定　と　B　の共通部分の否定
					else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 0;
						}
						else
						{
							p = 1;
						}
					}
					//A　と　Bの否定　の共通部分の否定
					else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
					//Aの否定　と　Bの否定　の共通部分の否定
					else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
					{
						if(dataA.length == 0)
						{
							p = 13;
						}
						else
						{
							p = 13;
						}
					}
				}
			}
			else
			{
				p = 0;
			}
		}
		
		//Ａのみ
		else if(tA.alpha == 1 && bA.alpha != 1 && tB.alpha != 1)
		{
			switch(t)
			{
				//A,Bが空集合
				case 0:
					p=0;
					break;
				
				//A,Bがデータのある同じ集合
				case 1:
					p=1;
					break;
				
				//Aが空集合
				case 2:
					p=0;
					break;
				
				//Bが空集合
				case 3:
					p=1;
					break;
			}
		}
		//Ａの否定
		else if(tA.alpha == 1 && bA.alpha == 1 && tB.alpha != 1)
		{
			switch(t)
			{
				//A,Bが空集合
				case 0:
					p=13;
					break;
				
				//A,Bがデータのある同じ集合
				case 1:
					p=2;
					break;
				
				//Aが空集合
				case 2:
					p=13;
					break;
				
				//Bが空集合
				case 3:
					p=2;
					break;
			}
		}
		//Ｂのみ
		else if(tB.alpha == 1 && bB.alpha != 1 && tA.alpha != 1)
		{
			switch(t)
			{
				//A,Bが空集合
				case 0:
					p=0;
					break;
				
				//A,Bがデータのある同じ集合
				case 1:
					p=1;
					break;
				
				//Aが空集合
				case 2:
					p=3;
					break;
				
				//Bが空集合
				case 3:
					p=0;
					break;
			}
		}
		//Ｂの否定
		else if(tB.alpha == 1 && bB.alpha == 1 && tA.alpha != 1)
		{
			switch(t)
			{
				//A,Bが空集合
				case 0:
					p=13;
					break;
				
				//A,Bがデータのある同じ集合
				case 1:
					p=2;
					break;
				
				//Aが空集合
				case 2:
					p=4;
					break;
				
				//Bが空集合
				case 3:
					p=13;
					break;
			}
		}
		//ＡとＢの組み合わせの場合
		else if(tA.alpha == 1 && tB.alpha == 1)
		{
			//和集合
			if(s0.alpha == 1)
			{
				//A　と　B　の和集合
				if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=1;
							break;

						//Aが空集合
						case 2:
							p=3;
							break;

						//Bが空集合
						case 3:
							p=1;
							break;
					}
				}
				//Aの否定　と　B　の和集合
				else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=13;
							break;

						//Aが空集合
						case 2:
							p=13;
							break;

						//Bが空集合
						case 3:
							p=2;
							break;
					}
				}
				//A　と　Bの否定　の和集合
				else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=13;
							break;

						//Aが空集合
						case 2:
							p=4;
							break;

						//Bが空集合
						case 3:
							p=13;
							break;
					}
				}
				//Aの否定　と　Bの否定　の和集合
				else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					switch(t)
					{
						case 0:
							p=13;
							break;
						case 1:
							p=2;
							break;
						case 2:
							p=13;
							break;
						case 3:
							p=13;
							break;
					}
				}
				//A　と　B　の和集合の否定
				else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=2;
							break;

						//Aが空集合
						case 2:
							p=4;
							break;

						//Bが空集合
						case 3:
							p=2;
							break;
					}
				}
				//Aの否定　と　B　の和集合の否定
				else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=0;
							break;

						//Aが空集合
						case 2:
							p=0;
							break;

						//Bが空集合
						case 3:
							p=1;
							break;
					}
				}
				//A　と　Bの否定　の和集合の否定
				else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					switch(t)
					{
						case 0:
							p=0;
							break;
						case 1:
							p=0;
							break;
						case 2:
							p=3;
							break;
						case 3:
							p=0;
							break;
					}
				}
				//Aの否定　と　Bの否定　の和集合の否定
				else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=1;
							break;

						//Aが空集合
						case 2:
							p=0;
							break;

						//Bが空集合
						case 3:
							p=0;
							break;
					}
				}
			}
			//共通部分
			else
			{
				//A　と　B　の共通部分
				if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=1;
							break;

						//Aが空集合
						case 2:
							p=0;
							break;

						//Bが空集合
						case 3:
							p=0;
							break;
					}
				}
				//Aの否定　と　B　の共通部分
				else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=0;
							break;

						//Aが空集合
						case 2:
							p=3;
							break;

						//Bが空集合
						case 3:
							p=0;
							break;
					}
				}
				//A　と　Bの否定　の共通部分
				else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=0;
							break;

						//Aが空集合
						case 2:
							p=0;
							break;

						//Bが空集合
						case 3:
							p=1;
							break;
					}
				}
				//Aの否定　と　Bの否定　の共通部分
				else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha != 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=2;
							break;

						//Aが空集合
						case 2:
							p=4;
							break;

						//Bが空集合
						case 3:
							p=2;
							break;
					}
				}
				//A　と　B　の共通部分の否定
				else if(bA.alpha != 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=2;
							break;

						//Aが空集合
						case 2:
							p=13;
							break;

						//Bが空集合
						case 3:
							p=13;
							break;
					}
				}
				//Aの否定　と　B　の共通部分の否定
				else if(bA.alpha == 1 && bB.alpha != 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=13;
							break;

						//Aが空集合
						case 2:
							p=4;
							break;

						//Bが空集合
						case 3:
							p=13;
							break;
					}
				}
				//A　と　Bの否定　の共通部分の否定
				else if(bA.alpha != 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=13;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=13;
							break;

						//Aが空集合
						case 2:
							p=13;
							break;

						//Bが空集合
						case 3:
							p=2;
							break;
					}
				}
				//Aの否定　と　Bの否定　の共通部分の否定
				else if(bA.alpha == 1 && bB.alpha == 1 && bC.alpha == 1)
				{
					switch(t)
					{
						//A,Bが空集合
						case 0:
							p=0;
							break;

						//A,Bがデータのある同じ集合
						case 1:
							p=1;
							break;

						//Aが空集合
						case 2:
							p=3;
							break;

						//Bが空集合
						case 3:
							p=1;
							break;
					}
				}
			}
		}
		else
		{
			p = 0;
		}
		
		return p;
	}
	catch(e)
	{
		alert("checkPattern:" + e.toString());
	}
}

function changeCanvas(p)
{
	try
	{
		fill.graphics.clear();
		
		//縁の表示切替
		//図の基本表示
		if(!document.getElementById("gCheck3").checked)
		{
			ctU.text = "U";
			ctA.text = "A";
			ctB.text = "B";
			
			ctU.alpha = 1;
			ctA.alpha = 1;
			ctB.alpha = 1;
			
			arcU.alpha = 1;
			
			ctU.x = 55 + baseX;
			
			arcU.graphics.clear();
			arcU.graphics.beginStroke("rgba(0,0,0,1)");
			arcU.graphics.moveTo(50+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, -15+baseY);
			arcU.graphics.lineTo(90+baseX, -15+baseY);
			arcU.graphics.endStroke();
			
			ctA.x = 50 + baseX;
			ctA.y = 5 + baseY;

			arcA.graphics.clear();
			arcA.graphics.setStrokeStyle(2);
			arcA.graphics.beginStroke("rgba(0,0,0,1)");
			arcA.graphics.arc(cAX, cAY, cAL, -Math.PI*10/15, -Math.PI*11/15, false, "#000000");
			arcA.graphics.endStroke();

			ctB.x = 275 + baseX;
			ctB.y = 0 + baseY;

			arcB.graphics.clear();
			arcB.graphics.setStrokeStyle(2);
			arcB.graphics.beginStroke("rgba(0,0,0,1)");
			arcB.graphics.arc(cBX, cBY, cBL, -Math.PI*6.5/15, -Math.PI*8/15, false, "#000000");
			arcB.graphics.endStroke();
			
			
			arcA.alpha = 1;
			arcB.alpha = 1;
		}
		//A,B,Uのデータが同じ場合
		else if(dataU.toString() == dataA.toString() && dataU.toString() == dataB.toString())
		{
			ctU.text = "U, A, B";
			ctA.text = "";
			ctB.text = "";
			
			if(dataU.length == 0)
			{
				ctU.alpha = 0.2;
				ctA.alpha = 0.2;
				ctB.alpha = 0.2;
				
				
				arcU.alpha = 0.2;
				arcA.alpha = 1;
				arcB.alpha = 0;
			}
			else
			{
				ctU.alpha = 1;
				ctA.alpha = 1;
				ctB.alpha = 1;
				
				arcU.alpha = 1;
				arcA.alpha = 1;
				arcB.alpha = 0;
			}
			
			arcU.graphics.clear();
			arcU.graphics.beginStroke("rgba(0,0,0,1)");
			arcU.graphics.moveTo(50+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, -15+baseY);
			arcU.graphics.lineTo(170+baseX, -15+baseY);
			arcU.graphics.endStroke();
			
			arcA.graphics.clear();
		}
		else if(dataU.toString() == dataA.toString())
		{
			ctU.text = "U, A";
			ctA.text = "";
			ctB.text = "B";
			
			ctU.alpha = 1;
			ctA.alpha = 1;
			
			arcU.alpha = 1;
			
			arcU.graphics.clear();
			arcU.graphics.beginStroke("rgba(0,0,0,1)");
			arcU.graphics.moveTo(50+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, -15+baseY);
			arcU.graphics.lineTo(130+baseX, -15+baseY);
			
			arcA.alpha = 1;
			arcA.graphics.clear();
			
			if(dataB.length == 0)
			{
				ctB.alpha = 0.2;
				arcB.alpha = 0.2;
			}
			else
			{
				ctB.alpha = 1;
				arcB.alpha = 1;
			}
		}
		else if(dataU.toString() == dataB.toString())
		{
			ctU.text = "U, B";
			ctA.text = "A";
			ctB.text = "";
			
			ctU.alpha = 1;
			ctB.alpha = 1;
			
			arcU.alpha = 1;
			
			arcU.graphics.clear();
			arcU.graphics.beginStroke("rgba(0,0,0,1)");
			arcU.graphics.moveTo(50+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, -15+baseY);
			arcU.graphics.lineTo(130+baseX, -15+baseY);
			
			arcA.graphics.clear();
			arcA.graphics.setStrokeStyle(2);
			arcA.graphics.beginStroke("rgba(0,0,0,1)");
			arcA.graphics.arc(cAX, cAY, cAL, -Math.PI*10/15, -Math.PI*11/15, false, "#000000");
			arcA.graphics.endStroke();
			
			arcB.alpha = 0;
			
			if(dataA.length == 0)
			{
				ctA.alpha = 0.2;
				arcA.alpha = 0.2;
			}
			else
			{
				ctA.alpha = 1;
				arcA.alpha = 1;
			}
		}
		//A,Bのデータが同じ場合
		else if(dataA.toString() == dataB.toString())
		{
			ctU.text = "U";
			ctA.text = "A, B";
			ctB.text = "";
			
			ctU.alpha = 1;
			
			arcU.alpha = 1;
			arcU.graphics.clear();
			arcU.graphics.beginStroke("rgba(0,0,0,1)");
			arcU.graphics.moveTo(50+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, -15+baseY);
			arcU.graphics.lineTo(90+baseX, -15+baseY);
			arcU.graphics.endStroke();
			
			arcA.graphics.clear();
			arcA.graphics.setStrokeStyle(2);
			arcA.graphics.beginStroke("rgba(0,0,0,1)");
			arcA.graphics.arc(cAX, cAY, cAL, -Math.PI*9/15, -Math.PI*11/15, false, "#000000");
			arcA.graphics.endStroke();
			
			ctA.x = 40 + baseX;
			
			if(dataA.length == 0)
			{
				arcA.alpha = 0.2;
				ctA.alpha = 0.2;
			}
			else
			{
				arcA.alpha = 1;
				ctA.alpha = 1;
			}
			
			ctB.alpha = 1;
			arcB.alpha = 0;
		}
		//データが違う場合
		else
		{
			ctU.text = "U";
			ctA.text = "A";
			ctB.text = "B";
			
			ctU.alpha = 1;
			
			arcU.alpha = 1;
			arcU.graphics.clear();
			arcU.graphics.beginStroke("rgba(0,0,0,1)");
			arcU.graphics.moveTo(50+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, -15+baseY);
			arcU.graphics.lineTo(-20+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, 345+baseY);
			arcU.graphics.lineTo(440+baseX, -15+baseY);
			arcU.graphics.lineTo(90+baseX, -15+baseY);
			arcU.graphics.endStroke();
			
			if(!document.getElementById("gCheck3").checked || (document.getElementById("gCheck3").checked && dataA.length == 0))
			{
				ctA.x = baseX;
				ctA.y = 5 + baseY;

				arcA.graphics.clear();
				arcA.graphics.setStrokeStyle(2);
				arcA.graphics.beginStroke("rgba(0,0,0,1)");
				arcA.graphics.arc(cAX-90, cAY-70, cAL-80, -Math.PI*10/15, -Math.PI*12/15, false, "#000000");
				arcA.graphics.endStroke();
			}
			else
			{
				ctA.x = 50 + baseX;
				ctA.y = 5 + baseY;

				arcA.graphics.clear();
				arcA.graphics.setStrokeStyle(2);
				arcA.graphics.beginStroke("rgba(0,0,0,1)");
				arcA.graphics.arc(cAX, cAY, cAL, -Math.PI*10/15, -Math.PI*11/15, false, "#000000");
				arcA.graphics.endStroke();
			}
			
			if(!document.getElementById("gCheck3").checked || (document.getElementById("gCheck3").checked && dataB.length == 0))
			{
				ctB.x = 385 + baseX;
				ctB.y = 0 + baseY;
				
				arcB.graphics.clear();
				arcB.graphics.setStrokeStyle(2);
				arcB.graphics.beginStroke("rgba(0,0,0,1)");
				arcB.graphics.arc(cBX+90, cBY-80, cBL-80, -Math.PI*4/15, -Math.PI*6.5/15, false, "#000000");
				arcB.graphics.endStroke();
			}
			else
			{
				ctB.x = 275 + baseX;
				ctB.y = 0 + baseY;
				
				arcB.graphics.clear();
				arcB.graphics.setStrokeStyle(2);
				arcB.graphics.beginStroke("rgba(0,0,0,1)");
				arcB.graphics.arc(cBX, cBY, cBL, -Math.PI*6.5/15, -Math.PI*8/15, false, "#000000");
				arcB.graphics.endStroke();
			}
			
			//Aが空集合
			if(dataA.length == 0)
			{
				arcA.alpha = 0.2;
				arcB.alpha = 1;
				
				ctA.alpha = 0.2;
				ctB.alpha = 1;
			}
			//Bが空集合
			else if(dataB.length == 0)
			{
				arcA.alpha = 1;
				arcB.alpha = 0.2;
				
				ctA.alpha = 1;
				ctB.alpha = 0.2;
			}
			else
			{
				arcA.alpha = 1;
				arcB.alpha = 1;
				
				ctA.alpha = 1;
				ctB.alpha = 1;
			}
		}
		
		//Ａのみ
		if(p == 1)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.endFill();
		}
		//Ａの否定
		else if(p == 2)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.endFill();
		}
		//Ｂのみ
		else if(p == 3)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.endFill();
		}
		//Ｂの否定
		else if(p == 4)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.endFill();
		}
		//Ａ，Ｂの和集合
		//Ａの否定とＢの否定の共通部分の否定
		else if(p == 5)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.endFill();
		}
		//Ａ，Ｂの和集合の否定
		//Ａの否定とＢの否定の共通部分
		else if(p == 6)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.endFill();
		}
		//Ａ，Ｂの共通部分
		//Ａの否定とＢの否定の和集合の否定
		else if(p == 7)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.arc(cAX, cAY, cAL, rA0, rA1, false, fColor);
			fill.graphics.endFill();
			
			fill.graphics.beginFill(fColor);
			fill.graphics.arc(cBX, cBY, cBL, rB0, rB1, true, fColor);
			fill.graphics.endFill();
			
		}
		//Ａ，Ｂの共通部分の否定
		//Ａの否定とＢの否定の和集合
		else if(p == 8)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
			
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.arc(cAX, cAY, cAL, rA0, rA1, false, "rgba(255,255,255,1)");
			fill.graphics.endFill();
			
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.arc(cBX, cBY, cBL, rB0, rB1, true, "rgba(255,255,255,1)");
			fill.graphics.endFill();
		}
		//Ａの否定とＢの和集合
		//ＡとＢの否定の共通部分の否定
		else if(p == 9)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.endFill();
		}
		//ＡとＢの否定の和集合
		//Ａの否定とＢの共通部分の否定
		else if(p == 10)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.endFill();
		}
		//Ａの否定とＢの和集合の否定
		//ＡとＢの否定の共通部分
		else if(p == 11)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.endFill();
		}
		//ＡとＢの否定の和集合の否定
		//Ａの否定とＢの共通部分
		else if(p == 12)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawCircle(cBX, cBY, cBL);
			fill.graphics.beginFill("rgba(255,255,255,1)");
			fill.graphics.drawCircle(cAX, cAY, cAL);
			fill.graphics.endFill();
		}
		else if(p == 13)
		{
			fill.graphics.beginFill(fColor);
			fill.graphics.drawRect(rX, rY, rW, rH);
			fill.graphics.endFill();
		}
		
		var cntA = 0;
		var cntB = 0;
		var cntS = 0;
		var cntU = 0;
		
		for(var i=1; i<=12; i++)
		{
			if(!document.getElementById('gCheck4').checked || dataU.indexOf(i) == -1)
			{
				numArray[i].visible = false;
			}
			else
			{
				numArray[i].visible = true;
				
				if(dataA.indexOf(i) != -1 && dataB.indexOf(i) != -1)
				{
					numArray[i].x = pSX + 30 * (cntS%2);
					numArray[i].y = pSY + 30 * parseInt(cntS/2);
					
					cntS++;
				}
				else if(dataA.indexOf(i) != -1)
				{
					numArray[i].x = pAX + 30 * (cntA%2);
					numArray[i].y = pAY + 30 * parseInt(cntA/2);
					
					cntA++;
				}
				else if(dataB.indexOf(i) != -1)
				{
					numArray[i].x = pBX + 30 * (cntB%2);
					numArray[i].y = pBY + 30 * parseInt(cntB/2);
					
					cntB++;
				}
				else
				{
					var f = true;
					
					
					numArray[i].x = pUX + cntU;
					
					numArray[i].y = pUY;
					
					cntU += numArray[i].getBounds().width + 14;
				}
			}
		}
	}
	catch(e)
	{
		alert("changeCanvas:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = dataU.slice();
		array[1] = dataA.slice();
		array[2] = dataB.slice();
		
		if(document.getElementById("gCheck4").checked)
		{
			array[3] = 4;
		}
		else if(document.getElementById("gCheck3").checked)
		{
			array[3] = 3;
		}
		else if(document.getElementById("gCheck2").checked)
		{
			array[3] = 2;
		}
		else if(document.getElementById("gCheck1").checked)
		{
			array[3] = 1;
		}
		else if(document.getElementById("gCheck0").checked)
		{
			array[3] = 0;
		}
		else
		{
			array[3] = -1;
		}
		
		setParts();
		
		array[4] = parts.slice();
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		setData(array[0], 0);
		setData(array[1], 1);
		setData(array[2], 2);
		
		for(var i=0; i<=4; i++)
		{
			if(i <= array[3])
			{
				document.getElementById("gCheck"+i).checked = true;
			}
			else
			{
				document.getElementById("gCheck"+i).checked = false;
			}
		}
		
		parts = array[4].slice();
		
		tA.visible = parts[0][0];
		tA.alpha = parts[0][1];
		tB.visible = parts[1][0];
		tB.alpha = parts[1][1];
		s0.visible = parts[2][0];
		s0.alpha = parts[2][1];
		s1.visible = parts[3][0];
		s1.alpha = parts[3][1];
		bA.visible = parts[4][0];
		bA.alpha = parts[4][1];
		bB.visible = parts[5][0];
		bB.alpha = parts[5][1];
		bC.visible = parts[6][0];
		bC.alpha = parts[6][1];
		
		checkFormula();
		
		cs.update();
		stage.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}



function resetHandler(e)
{
	try
	{
		setData([1,2,3,4,5,6,7,8,9], 0);
		setData([2,4,6,8], 1);
		setData([1,2,3,6], 2);
		
		document.getElementById("gCheck0").checked = true;
		document.getElementById("gCheck1").checked = true;
		document.getElementById("gCheck2").checked = true;
		document.getElementById("gCheck3").checked = false;
		document.getElementById("gCheck4").checked = false;
		
		tA.alpha = 1;
		tA.visible = true;
		tB.alpha = 1;
		tB.visible = true;
		
		bA.alpha = 0.2;
		bA.visible = true;
		bB.alpha = 0.2;
		bB.visible = true;
		
		s0.alpha = 1;
		s0.visible = true;
		s1.alpha = 0.2;
		s1.visible = false;
		
		bC.alpha = 0.2;
		bC.visible = true;
		
		checkFormula();
		
		cs.update();
		stage.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}