// JavaScript Document
var cc;
var cs;

var cW;
var cH;

var grid;
var base;

var tx;
var ty;
var t0;

var formArray;
var graphArray;

var peakArray;

var span;

var dotLine;

//y=ax+b
var prev0A;
var prev0B;

//y=ax^2+bx+c
var prev1A;
var prev1B;
var prev1C;

//y=a(x-p)^2+q
var prev2A;
var prev2P;
var prev2Q;

//入力データの格納
var dataArray;

var gA;
var gB;
var gC;

var dX;
var dY;

var pX;
var pY;

var graphType;

var browse;

function loadContentHandler()
{
	try
	{
		span = 25;
		cW = 22 * span;
		cH = 22 * span;
		
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		
		document.getElementById("graphCanvas").style.border = "1px solid #000000";
		
		document.getElementById("windowBlock").style.width = "280px";
		
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		
		createjs.Touch.enable(cs);
		
		grid = new createjs.Shape();
		cs.addChild(grid);
		drawGridHandler();
		
		base = new createjs.Shape();
		cs.addChild(base);
		
		//矢印の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW-20, cH/2);
		base.graphics.beginFill("#000000");
		base.graphics.moveTo(cW-20, cH/2);
		base.graphics.lineTo(cW-20, cH/2-4);
		base.graphics.lineTo(cW-2, cH/2);
		base.graphics.lineTo(cW-20, cH/2+4);
		base.graphics.lineTo(cW-20, cH/2);
		base.graphics.endFill();
		
		base.graphics.moveTo(cW/2, 20);
		base.graphics.lineTo(cW/2, cH);
		base.graphics.beginFill("#000000");
		base.graphics.moveTo(cW/2, 20);
		base.graphics.lineTo(cW/2-4, 20);
		base.graphics.lineTo(cW/2, 2);
		base.graphics.lineTo(cW/2+4, 20);
		base.graphics.lineTo(cW/2, 20);
		base.graphics.endFill();
		base.graphics.endStroke();
		
		tx = new createjs.Text("x", "20px Arial", "#000000");
		tx.x = cW-tx.getBounds().width-5;
		tx.y = cH/2 + 5;
		
		ty = new createjs.Text("y", "20px Arial", "#000000");
		ty.x = cW/2+10;
		ty.y = 2;
		
		t0 = new createjs.Text("0", "20px Arial", "#000000");
		t0.x = cW/2+5;
		t0.y = cH/2+5;
		
		cs.addChild(tx);
		cs.addChild(ty);
		cs.addChild(t0);
		
		dotLine = new createjs.Shape();
		dotLine.name = "dotLine";
		cs.addChild(dotLine);
		
		formArray = [];
		graphArray = [];
		peakArray = [];
		dataArray = [];
		
		graphType = 0;
		
		prev0A = 1;
		prev0B = 1;
		
		prev1A = 1;
		prev1B = 2;
		prev1C = 1;
		
		prev2A = 1;
		prev2P = 1;
		prev2Q = 1;
		
		//テキストの設定
		document.getElementById("text0_0").value = prev0A;
		document.getElementById("text0_1").value = prev0B;
		
		document.getElementById("text1_0").value = prev1A;
		document.getElementById("text1_1").value = prev1B;
		document.getElementById("text1_2").value = prev1C;
		
		document.getElementById("text2_0").value = prev2A;
		document.getElementById("text2_1").value = prev2P;
		document.getElementById("text2_2").value = prev2Q;
		
		document.getElementById("select0A").style.margin = "10px auto 20px auto";
		document.getElementById("select0B").style.margin = "10px auto 20px auto";
		
		document.getElementById("select1A").style.margin = "10px auto 20px auto";
		document.getElementById("select1B").style.margin = "10px auto 20px auto";
		document.getElementById("select1C").style.margin = "10px auto 20px auto";
		
		document.getElementById("select2A").style.margin = "10px auto 20px auto";
		document.getElementById("select2P").style.margin = "10px auto 20px auto";
		document.getElementById("select2Q").style.margin = "10px auto 20px auto";
		
		//ボタンの設定
		document.getElementById("upBtn0_0").addEventListener("mousedown", changeDataHandler);
		document.getElementById("upBtn0_1").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn0_0").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn0_1").addEventListener("mousedown", changeDataHandler);
		
		document.getElementById("upBtn1_0").addEventListener("mousedown", changeDataHandler);
		document.getElementById("upBtn1_1").addEventListener("mousedown", changeDataHandler);
		document.getElementById("upBtn1_2").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn1_0").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn1_1").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn1_2").addEventListener("mousedown", changeDataHandler);
		
		document.getElementById("upBtn2_0").addEventListener("mousedown", changeDataHandler);
		document.getElementById("upBtn2_1").addEventListener("mousedown", changeDataHandler);
		document.getElementById("upBtn2_2").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn2_0").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn2_1").addEventListener("mousedown", changeDataHandler);
		document.getElementById("downBtn2_2").addEventListener("mousedown", changeDataHandler);
		
		
		document.getElementById("onBtn0").style.cursor = "auto";
		document.getElementById("onBtn1").style.cursor = "auto";
		document.getElementById("onBtn2").style.cursor = "auto";
		document.getElementById("onBtn3").style.cursor = "auto";
		
		document.getElementById("offBtn0").style.display = "none";
		document.getElementById("onBtn1").style.display = "none";
		
		document.getElementById("onBtn2").style.display = "none";
		document.getElementById("onBtn3").style.display = "none";
		
		document.getElementById("offBtn2").style.display = "none";
		document.getElementById("offBtn3").style.display = "none";
		
		
		document.getElementById("offBtn0").addEventListener('mousedown', changeTypeHandler);
		document.getElementById("offBtn1").addEventListener('mousedown', changeTypeHandler);
		document.getElementById("offBtn2").addEventListener('mousedown', changeTypeHandler);
		document.getElementById("offBtn3").addEventListener('mousedown', changeTypeHandler);
		
		//入力の設定
		document.getElementById("text0_0").addEventListener("input", inputHandler);
		document.getElementById("text0_1").addEventListener("input", inputHandler);
		
		document.getElementById("text1_0").addEventListener("input", inputHandler);
		document.getElementById("text1_1").addEventListener("input", inputHandler);
		document.getElementById("text1_2").addEventListener("input", inputHandler);
		
		document.getElementById("text2_0").addEventListener("input", inputHandler);
		document.getElementById("text2_1").addEventListener("input", inputHandler);
		document.getElementById("text2_2").addEventListener("input", inputHandler);
		
		document.getElementById("check0").checked = true;
		document.getElementById("check1").checked = true;
		document.getElementById("check2").checked = true;
		
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		
		document.getElementById("radio0_0").checked = true;
		document.getElementById("radio1_0").checked = true;
		document.getElementById("radio2_0").checked = true;
		document.getElementById("radio3_0").checked = true;
		
		document.getElementById("radio0_0").addEventListener("change", changeRadioHandler);
		document.getElementById("radio0_1").addEventListener("change", changeRadioHandler);
		document.getElementById("radio1_0").addEventListener("change", changeRadioHandler);
		document.getElementById("radio1_1").addEventListener("change", changeRadioHandler);
		document.getElementById("radio2_0").addEventListener("change", changeRadioHandler);
		document.getElementById("radio2_1").addEventListener("change", changeRadioHandler);
		document.getElementById("radio2_2").addEventListener("change", changeRadioHandler);
		document.getElementById("radio3_0").addEventListener("change", changeRadioHandler);
		
		document.getElementById("changeBtn").addEventListener("mousedown", setGraphHandler);
		document.getElementById("changeBtn").style.marginBottom = "0px";
		
		document.getElementById("clearBtn").addEventListener("mousedown", clearGraphHandler);
		document.getElementById("clearBtn").style.marginBottom="0px";
		
		document.getElementById("changeOffBtn").style.backgroundColor = "#999999";
		document.getElementById("changeOffBtn").style.cursor = "auto";
		document.getElementById("changeOffBtn").style.marginBottom = "0px";
		
		changeTypeConfigHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function drawGridHandler()
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		//横線
		for(i=cH/2; i>0; i-=span)
		{
			grid.graphics.moveTo(0, i);
			grid.graphics.lineTo(cW, i);
		}
		
		for(i=cH/2; i<cH; i+=span)
		{
			grid.graphics.moveTo(0, i);
			grid.graphics.lineTo(cW, i);
		}
		
		//縦線
		for(i=cW/2; i>0; i-=span)
		{
			grid.graphics.moveTo(i, 0);
			grid.graphics.lineTo(i, cH);
		}
		
		for(i=cW/2; i<cW; i+=span)
		{
			grid.graphics.moveTo(i, 0);
			grid.graphics.lineTo(i, cH);
		}
		
		grid.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawGridHandler:" + e.toString());
	}
}

function changeTypeHandler(e)
{
	try
	{
		graphType = parseInt(e.target.id.substring(e.target.id.length-1, e.target.id.length));
		
		for(var i=0; i<2; i++)
		{
			if(i == graphType)
			{
				document.getElementById("onBtn"+i).style.display = "inline-block";
				document.getElementById("offBtn"+i).style.display = "none";
			}
			else
			{
				document.getElementById("onBtn"+i).style.display = "none";
				document.getElementById("offBtn"+i).style.display = "inline-block";
			}
		}
		
		changeTypeConfigHandler();
	}
	catch(e)
	{
		alert("changeTypeHandler:" + e.toString());
	}
}

function changeTypeConfigHandler()
{
	try
	{
		for(var i=0; i<4; i++)
		{
			if(i == graphType)
			{
				document.getElementById("radioType"+i).style.display = "block";
			}
			else
			{
				document.getElementById("radioType"+i).style.display = "none";
			}
		}
		
		if((graphType == 0 && document.getElementById("radio0_0").checked)||(graphType == 1))
		{
			document.getElementById("changeBtn").style.display = "inline-block";
			document.getElementById("changeOffBtn").style.display = "none";
			
			if(graphType == 0 && document.getElementById("radio0_0").checked)
			{
				document.getElementById("select0_0").style.display = "block";
				document.getElementById("select1_0").style.display = "none";
				document.getElementById("select1_1").style.display = "none";
			}
			else if(graphType == 1 && document.getElementById("radio1_0").checked)
			{
				document.getElementById("select0_0").style.display = "none";
				document.getElementById("select1_0").style.display = "block";
				document.getElementById("select1_1").style.display = "none";
			}
			else if(graphType == 1 && document.getElementById("radio1_1").checked)
			{
				document.getElementById("select0_0").style.display = "none";
				document.getElementById("select1_0").style.display = "none";
				document.getElementById("select1_1").style.display = "block";
			}
		}
		else
		{
			document.getElementById("changeBtn").style.display = "none";
			document.getElementById("changeOffBtn").style.display = "inline-block";
			
			document.getElementById("select0_0").style.display = "none";
			document.getElementById("select1_0").style.display = "none";
			document.getElementById("select1_1").style.display = "none";
		}
	}
	catch(e)
	{
		alert("changeTypeConfigHandler:" + e.toString());
	}
}

//ボタンでの変更
function changeDataHandler(e)
{
	try
	{
		var id = e.target.id.substring(e.target.id.lastIndexOf("n")+1, e.target.id.length);
		
		var elm = document.getElementById("text"+id);
		
		
		//数字をあげる
		if(e.target.id.indexOf("upBtn") != -1)
		{
			var num0 = parseInt(elm.value);
			
			if(num0 < 9)
			{
				if((e.target.id == "upBtn1_0" || e.target.id == "upBtn2_0") && num0 == -1)
				{
					num0 = 1;
				}
				else
				{
					num0++;
				}
				
				if(e.target.id == "upBtn0_0")
				{
					prev0A = num0;
				}
				else if(e.target.id == "upBtn0_1")
				{
					prev0B = num0;
				}
				else if(e.target.id == "upBtn1_0")
				{
					prev1A = num0;
				}
				else if(e.target.id == "upBtn1_1")
				{
					prev1B = num0;
				}
				else if(e.target.id == "upBtn1_2")
				{
					prev1C = num0;
				}
				else if(e.target.id == "upBtn2_0")
				{
					prev2A = num0;
				}
				else if(e.target.id == "upBtn2_1")
				{
					prev2P = num0;
				}
				else
				{
					prev2Q = num0;
				}
				
				elm.value = num0;
			}
		}
		//下げる
		else
		{
			var num1 = parseInt(elm.value);
			
			if(num1 > -9)
			{
				if((e.target.id == "downBtn1_0" || e.target.id == "downBtn2_0") && num1 == 1)
				{
					num1 = -1;
				}
				else
				{
					num1--;
				}
				
				if(e.target.id == "downBtn0_0")
				{
					prev0A = num1;
				}
				else if(e.target.id == "downBtn0_1")
				{
					prev0B = num1;
				}
				else if(e.target.id == "downBtn1_0")
				{
					prev1A = num1;
				}
				else if(e.target.id == "downBtn1_1")
				{
					prev1B = num1;
				}
				else if(e.target.id == "downBtn1_2")
				{
					prev1C = num1;
				}
				else if(e.target.id == "downBtn2_0")
				{
					prev2A = num1;
				}
				else if(e.target.id == "downBtn2_1")
				{
					prev2P = num1;
				}
				else
				{
					prev2Q = num1;
				}
				
				elm.value = num1;
			}
		}
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

//入力
function inputHandler(e)
{
	try
	{
		var str = e.target.value;
			
		if(str != "")
		{
			var num = parseInt(str);
			
			if(str.match(/^[-]?[0-9]?$/) != "" && num >= -9 && num <= 9)
			{
				if((e.target.id == "text1_0" || e.target.id == "text2_0") && num == 0)
				{
					if(e.target.id == "text1_0")
					{
						e.target.value = prev1A;
					}
					else if(e.target.id == "text2_0")
					{
						e.target.value = prev2A;
					}
					
					alert("aは0以外の-9～9の値を入力してください。");
				}
				else
				{
					switch(e.target.id)
					{
						case "text0_0":
							prev0A = num;
							break;
						case "text0_1":
							prev0B = num;
							break;
						case "text1_0":
							prev1A = num;
							break;
						case "text1_1":
							prev1B = num;
							break;
						case "text1_2":
							prev1C = num;
							break;
						case "text2_0":
							prev2A = num;
							break;
						case "text2_1":
							prev2P = num;
							break;
						case "text2_2":
							prev2Q = num;
							break;
					}
				}
			}
			//数値をもとに戻す
			else
			{
				switch(e.target.id)
				{
					case "text0_0":
						e.target.value = prev0A;
						break;
					case "text0_1":
						e.target.value = prev0B;
						break;
					case "text1_0":
						e.target.value = prev1A;
						break;
					case "text1_1":
						e.target.value = prev1B;
						break;
					case "text1_2":
						e.target.value = prev1C;
						break;
					case "text2_0":
						e.target.value = prev2A;
						break;
					case "text2_1":
						e.target.value = prev2P;
						break;
					case "text2_2":
						e.target.value = prev2Q;
						break;
				}
				
				alert("-9～9の数値を入力してください。");
			}
		}
	}
	catch(e)
	{
		alert("inputHandler:" + e.toString());
	}
}

function setGraphHandler(e)
{
	try
	{
		if(checkInput())
		{
			var data;
			var line = new createjs.Shape();
			line.name = "l"+dataArray.length;
			var form;
			var fStr;
			
			if(graphType == 0 && document.getElementById("radio0_0").checked == true)
			{
				drawLine(line, prev0A, prev0B);
				cs.addChild(line);
				graphArray.push(line);
				
				fStr = getFormulaHandler(prev0A, prev0B, 0, 0);
				form = new createjs.Text(fStr, "20px Arial", "#000000");
				form.name = "f"+dataArray.length;
				cs.addChild(form);
				formArray.push(form);
				
				var dX = cW/2 + (cH/2 - prev0B * span)/prev0A;
				
				if(prev0A == 0)
				{
					form.x = 5;
					
					if(prev0B >= 0)
					{
						form.y = cH/2 - prev0B * span + 2;
					}
					else
					{
						form.y = cH/2 - prev0B * span - form.getBounds().height;
					}
				}
				else if(dX > 0 && dX < cW)
				{
					if(dX + form.getBounds().width > cW/2)
					{
						form.x = dX - form.getBounds().width - span;
					}
					else
					{
						form.x = dX + span;
					}
				}
				else
				{
					var dY = cH - prev0A * cW - prev0B * span;
					
					if(prev0A > 0)
					{
						form.x = cW - form.getBounds().width - span;
						form.y = cH - prev0A * cW - prev0B * span;
					}
					else
					{
						form.x = span;
						form.y = cH + prev0A * cW - prev0B * span;
					}
				}
				
				data = [0, [prev0A, prev0B], form.x, form.y];
			}
			else if(graphType == 1 && document.getElementById("radio1_0").checked == true)
			{
				drawParabola(line, prev1A, prev1B, prev1C, true);
				cs.addChild(line);
				graphArray.push(line);
				
				fStr = getFormulaHandler(prev1A, prev1B, prev1C, 1);
				form = new createjs.Text(fStr, "20px Arial", "#000000");
				form.name = "f"+dataArray.length;
				cs.addChild(form);
				formArray.push(form);
				
				var p1 = createPeakTextHandler(prev1A, prev1B, prev1C, true);
				
				peakArray.push(p1);
				
				var px1 = Math.round(prev1B/(2*prev1A) * 10)/10;
				var py1 = Math.round(prev1C-(prev1B/2 * prev1B/2)*prev1A * 10)/10;
				
				if(prev1A > 0)
				{
					form.x = line.x + span/prev1A;
					form.y = line.y - span/prev1A;
				}
				else
				{
					form.x = line.x + span/(-prev1A);
					form.y = line.y + span/(-prev1A) - form.getBounds().height;
				}
				
				data = [1, [prev1A, prev1B, prev1C], form.x, form.y];
			}
			else if(graphType == 1 && document.getElementById("radio1_1").checked == true)
			{
				drawParabola(line, prev2A, prev2P, prev2Q, false);
				cs.addChild(line);
				graphArray.push(line);
				
				fStr = getFormulaHandler(prev2A, prev2P, prev2Q, 2);
				form = new createjs.Text(fStr, "20px Arial", "#000000");
				form.name = "f"+dataArray.length;
				cs.addChild(form);
				formArray.push(form);
				
				var p2 = createPeakTextHandler(prev2A, prev2P, prev2Q, false);
				
				peakArray.push(p2);
				
				if(prev2A > 0)
				{
					form.x = line.x + span/prev2A;
					form.y = line.y - span/prev2A;
				}
				else
				{
					form.x = line.x + span/(-prev2A);
					form.y = line.y + span/(-prev2A) - form.getBounds().height;
				}
				
				data = [2, [prev2A, prev2P, prev2Q], form.x, form.y];
			}
			
			dataArray.push(data);
			
			drawPeakLineHandler();
			
			cs.update();
		}
		else
		{
			alert("-9～9の値を入力してください。");
		}
	}
	catch(e)
	{
		alert("setGraphHandler:" + e.toString());
	}
}

function drawLine(line, pA, pB)
{
	try
	{
		line.graphics.clear();
		line.graphics.setStrokeStyle(2);
		line.graphics.beginStroke("rgba(0,0,0,1)");
		
		if(pA == 0)
		{
			line.graphics.moveTo(0, cH/2 - pB * span);
			line.graphics.lineTo(cW, cH/2 - pB * span);
		}
		else
		{
			line.graphics.moveTo(cW / pA, -cH);
			line.graphics.lineTo(-cW / pA, cH);
			
			line.x = cW/2;
			line.y = cH/2 - pB * span;
		}
		
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawLine:" + e.toString());
	}
}

function drawParabola(line, pA, pB, pC, f)
{
	try
	{
		line.graphics.clear();
		line.graphics.setStrokeStyle(2);
		line.graphics.beginStroke("rgba(0,0,0,1)");
		
		for(var i=0; i<cH; i++)
		{
			line.graphics.moveTo(i, -pA/span * i * i);
			line.graphics.lineTo(i+1, -pA/span * (i+1) * (i+1));
			line.graphics.moveTo(-i, -pA/span * i * i);
			line.graphics.lineTo(-i-1, -pA/span * (i+1) * (i+1));
		}
		
		var px;
		var py;
		
		//頂点の座標
		if(f)
		{
			px = pB/(2*pA);
			py = pC-(pB/2 * pB/2)*pA;
		}
		else
		{
			px = -pB;
			py = pC;
		}
		
		line.x = cW/2 - px * span;
		line.y = cH/2 - py * span;
	}
	catch(e)
	{
		alert("drawParabola:" + e.toString());
	}
}


function getFormulaHandler(pA, pB, pC, t)
{
	try
	{
		//式の設定
		var strA;
		var strB;
		var strC;
		
		//一次関数
		if(t == 0)
		{
			strA = "y=";
			if(pA != 0)
			{
				if(pA == 1)
				{
					strA = strA + "x";
				}
				else if(pA == -1)
				{
					strA = strA + "-x";
				}
				else
				{
					strA = strA + pA + "x";
				}
			}
			
			
			if(pB > 0)
			{
				if(pA != 0)
				{
					strB = "+" + pB;
				}
				else
				{
					strB = pB;
				}
			}
			else if(pB < 0)
			{
				strB = pB.toString();
			}
			else
			{
				strB = "";
			}
			
			strA = strA + strB;
		}
		//y=ax~2+bx+c
		else if(t == 1)
		{
			strA = "y=";
			
			if(pA == -1)
			{
				strA = strA + "-x²";
			}
			else if(pA == 1)
			{
				strA = strA + "x²";
			}
			else
			{
				strA = strA + pA.toString() + "x²";
			}
			
			if(pB == 0)
			{
				strB = "";
			}
			else if(pB > 0)
			{
				if(pB == 1)
				{
					strB = "+x";
				}
				else
				{
					strB = "+" + pB.toString() + "x";
				}
			}
			else
			{
				if(pB == -1)
				{
					strB = "-x";
				}
				else
				{
					strB = pB.toString() + "x";
				}
			}
			
			if(pC == 0)
			{
				strC = "";
			}
			else if(pC > 0)
			{
				strC = "+" + pC.toString();
			}
			else
			{
				strC = pC.toString();
			}
			
			strA = strA + strB + strC;
		}
		//y=a(x-p)^2+q
		else
		{
			strA = "y=";
			
			if(pA == -1)
			{
				strA = strA + "-";
			}
			else if(pA > 1 || pA < 0)
			{
				strA = strA + pA.toString();
			}
			
			if(pB == 0)
			{
				strB = "x²";
			}
			else if(pB > 0)
			{
				strB = "(x-"+pB+")²";
			}
			else
			{
				strB = "(x+"+(-pB).toString()+")²";
			}
			
			if(pC == 0)
			{
				strC = "";
			}
			else if(pC > 0)
			{
				strC = "+" + pC.toString();
			}
			else
			{
				strC = pC.toString();
			}
			
			strA = strA + strB + strC;
		}
		
		return strA;
	}
	catch(e)
	{
		alert("getFormulaHandler:" + e.toString());
	}
}

function checkInput()
{
	try
	{
		var f = true;
		
		var str0;
		var str1;
		var str2;
		
		var t;
		
		if(graphType == 0 && document.getElementById("radio0_0").checked == true)
		{
			t = 0;
			str0 = document.getElementById("text0_0").value;
			str1 = document.getElementById("text1_1").value;
			str2 = "";
		}
		else if(graphType == 1 && document.getElementById("radio1_0").checked == true)
		{
			t = 1;
			str0 = document.getElementById("text1_0").value;
			str1 = document.getElementById("text1_1").value;
			str2 = document.getElementById("text1_2").value;
		}
		else if(graphType == 1 && document.getElementById("radio1_1").checked == true)
		{
			t = 2;
			str0 = document.getElementById("text2_0").value;
			str1 = document.getElementById("text2_1").value;
			str2 = document.getElementById("text2_2").value;
		}
		
		//入力内容が正しくない場合
		//直線
		if(t == 0)
		{
			if(str0 != "" && str0.match(/^[-]?[0-9]?$/) == "")
			{
				f = false;
				return f;
			}
			
			if(str1 != "" && str1.match(/^[-]?[0-9]?$/) == "")
			{
				f = false;
				return f;
			}
			
			if(str0 == "" && str1 == "")
			{
				f = false;
				return f;
			}
		}
		//放物線
		else
		{
			if(document.getElementById("text"+t+"_0").value == "" || document.getElementById("text"+t+"_0").value == "0")
			{
				f = false;
				return f;
			}
			
			if(str0.match(/^[-]?[0-9]?$/) == "" || str1.match(/^[-]?[0-9]?$/) == "" || str2.match(/^[-]?[0-9]?$/) == "")
			{
				f = false;
				return f;
			}
		}
		
		return f;
	}
	catch(e)
	{
		alert("checkInput:" + e.toString());
	}
}

function changeRadioHandler(e)
{
	try
	{
		changeTypeConfigHandler();
	}
	catch(e)
	{
		alert("changeRadioHandler:" + e.toString());
	}
}

function changeCheckHandler(e)
{
	try
	{
		//頂点座標
		if(e.target.id == "check0")
		{
			for(i=0; i<peakArray.length; i++)
			{
				if(peakArray[i] != null)
				{
					peakArray[i][0].visible = e.target.checked;
					peakArray[i][1].visible = e.target.checked;
				}
			}
			
			dotLine.visible = e.target.checked;
		}
		//式表示
		else if(e.target.id == "check1")
		{
			for(i=0; i < formArray.length; i++)
			{
				formArray[i].visible = e.target.checked;
			}
		}
		//方眼
		else
		{
			grid.visible = e.target.checked;
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("checkChangeHandler:" + e.toString());
	}
}

function createPeakTextHandler(pA, pB, pC, f)
{
	try
	{
		var array = [];
		
		//頂点の座標
		var px;
		var py;
		
		if(f)
		{
			px = pB/(2*pA);
			py = pC-(pB/2 * pB/2)*pA;
		}
		else
		{
			px = -pB;
			py = pC;
		}
		
		//四捨五入
		var nx = Math.round(-px * 100)/100;
		var ny = Math.round(py * 100)/100;
		
		var tx = new createjs.Text(nx, "20px Arial","#000000");
		var ty = new createjs.Text(ny, "20px Arial","#000000");
		
		cs.addChild(tx);
		cs.addChild(ty);
		
		tx.x = cW/2 - px * span - tx.getBounds().width/2;
		tx.y = cH/2 + 5;
		
		if(px <= 0)
		{
			ty.x = cW/2 - ty.getBounds().width -5;
		}
		else
		{
			ty.x = cW/2 + 5;
		}
		
		ty.y = cH/2 - py * span - ty.getBounds().height/2;
		
		
		array[0] = tx;
		array[1] = ty;
		
		return array;
	}
	catch(e)
	{
		alert("createPeakTextHandler:" + e.toString());
	}
}

function drawPeakLineHandler()
{
	try
	{
		dotLine.graphics.clear();
		
		dotLine.graphics.setStrokeStyle(1);
		dotLine.graphics.beginStroke("#000000");
		dotLine.graphics.setStrokeDash([5, 5], 0);
		
		for(var i=0; i<dataArray.length; i++)
		{
			if(dataArray[i][0] == 1 || dataArray[i][0] == 2)
			{
				//line0のx
				dotLine.graphics.moveTo(cW/2, cs.getChildByName("l"+i).y);
				dotLine.graphics.lineTo(cs.getChildByName("l"+i).x, cs.getChildByName("l"+i).y);
				//line0のy
				dotLine.graphics.moveTo(cs.getChildByName("l"+i).x, cH/2);
				dotLine.graphics.lineTo(cs.getChildByName("l"+i).x, cs.getChildByName("l"+i).y);
				
				//line1のx
				dotLine.graphics.moveTo(cW/2, cs.getChildByName("l"+i).y);
				dotLine.graphics.lineTo(cs.getChildByName("l"+i).x, cs.getChildByName("l"+i).y);
				//line1のy
				dotLine.graphics.moveTo(cs.getChildByName("l"+i).x, cH/2);
				dotLine.graphics.lineTo(cs.getChildByName("l"+i).x, cs.getChildByName("l"+i).y);
			}
		}
		
		dotLine.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawPeakLineHandler:" + e.toString());
	}
}

function clearGraphHandler(e)
{
	try
	{
		var i;
		
		for(i=0; i<graphArray.length; i++)
		{
			cs.removeChild(graphArray[i]);
		}
		
		for(i=0; i<formArray.length; i++)
		{
			cs.removeChild(formArray[i]);
		}
		
		for(i=0; i<peakArray.length; i++)
		{
			if(peakArray[i] != null)
			{
				cs.removeChild(peakArray[i][0]);
				cs.removeChild(peakArray[i][1]);
			}
		}
		
		dotLine.graphics.clear();
		
		cs.update();
		
		graphArray = [];
		formArray = [];
		peakArray = [];
		dataArray = [];
	}
	catch(e)
	{
		alert("clearGraphHandler:" + e.toString());
	}
}