var selectedTab;

// JavaScript Document
function init()
{
	try
	{
		
		document.getElementById("exp0").checked = true;
		
		document.getElementById("box0").style.display = "block";
		document.getElementById("box1").style.display = "none";
		document.getElementById("box2").style.display = "none";
		document.getElementById("box3").style.display = "none";
		document.getElementById("box4").style.display = "none";
		
		/*ax^2*/
		document.getElementById("aInput00").value = 1;
		
		/*ax^2+q*/
		document.getElementById("aInput10").value = 1;
		
		document.getElementById("qInput10").value = 1;
		
		/*a(x-p)^2*/
		document.getElementById("aInput20").value = 1;
		
		document.getElementById("pInput20").value = 1;
		
		/* a(x+p)^2+q */
		document.getElementById("aInput30").value = 1;
		
		document.getElementById("pInput30").value = 1;
		
		document.getElementById("qInput30").value = 1;
		
		/* ax^2+bx+c */
		document.getElementById("aInput40").value = 1;
		
		document.getElementById("bInput40").value = 2;
		
		document.getElementById("cInput40").value = 1;
		
		document.getElementById("gridCheck").checked = false;
		
		selectedTab = "exp0";
		
		/*イベント設定*/
		var eventStr;
		
		var ua = navigator.userAgent;
		//スマートフォン
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			eventStr = "touchstart";
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			eventStr = "touchstart";
		}
		else
		{
			eventStr = "mousedown";
		}
		
		document.getElementById("exp0").addEventListener(eventStr, tabChange);
		document.getElementById("exp1").addEventListener(eventStr, tabChange);
		document.getElementById("exp2").addEventListener(eventStr, tabChange);
		document.getElementById("exp3").addEventListener(eventStr, tabChange);
		document.getElementById("exp4").addEventListener(eventStr, tabChange);
		
		document.getElementById("changeBtn").addEventListener(eventStr, changeLine);
		
		document.getElementById("configBtn").addEventListener(eventStr, showConfigBlock);
		
		//グラフの設定
		initGraph(0, 60, 1, 50, 1, false);
		
		expA = 1;
		expB = 0;
		expC = 0;
		
		
		//グラフ背景の設定
		drawGraphBase(0, 0, true, false);
		
		drawLine(false);
		
		//式の作成
		changeExpression(1, 0, 0, 0);
	}
	catch(e)
	{
		alert("init:" + e.toString());
	}
}

init();

function tabChange(e)
{
	try
	{
		if(e.currentTarget.id != selectedTab && e.currentTarget.id != "")
		{
			var num = selectedTab.substring(3,4);
			
			document.getElementById("box"+num).style.display="none";
			
			document.getElementById(selectedTab).className = "tab-default";
			e.currentTarget.className = "tab-selected";
			selectedTab = e.currentTarget.id;
			
			num = selectedTab.substring(3,4);
			
			document.getElementById("box"+num).style.display="block";
			
			document.getElementById("alert").style.display = "none";
		}
	}
	catch(e)
	{
		alert("tabChange:" + e.toString());
	}
}

function changeLine()
{
	try
	{
		var f=true;
		
		var a;
		var b;
		var c;
		
		/* ax^2 */
		if(selectedTab == "exp0")
		{
			//入力に問題がある場合(視認性をあげるためにあえて分岐を多様)
			//aの値
			
			//整数の入力
			if(document.getElementById("aInput00").value === "" || isFinite(document.getElementById("aInput00").value) === false)
			{
				f=false;
			}
			
			
			if(f)
			{
				a = Number(document.getElementById("aInput00").value);
				
				b = 0;
				c = 0;
			}
		}
		/* ax^2+q */
		else if(selectedTab == "exp1")
		{
			//入力に問題がある場合(視認性をあげるためにあえて分岐を多様)
			
			//aの値
			//整数の入力
			if(document.getElementById("aInput10").value === "" || isFinite(document.getElementById("aInput10").value) === false)
			{
				f=false;
			}
			
			//qの値
			//整数の入力
			if(document.getElementById("qInput10").value === "" || isFinite(document.getElementById("aInput10").value) === false)
			{
				f=false;
			}
			
			
			if(f)
			{
				a = Number(document.getElementById("aInput10").value);
				
				b = 0;
				
				c = Number(document.getElementById("qInput10").value);
			}
		}
		/* a(x-p)^2 */
		else if(selectedTab == "exp2")
		{
			//入力に問題がある場合(視認性をあげるためにあえて分岐を多様)
			
			//aの値
			//整数の入力
			if(document.getElementById("aInput20").value === "" || isFinite(document.getElementById("aInput20").value) === false)
			{
				f=false;
			}
			
			//pの値
			//整数の入力
			if(document.getElementById("pInput20").value === "" || isFinite(document.getElementById("pInput20").value) === false)
			{
				f=false;
			}
			
			
			if(f)
			{
				a = Number(document.getElementById("aInput20").value);
				
				b = Number(document.getElementById("pInput20").value);
				
				c = a * Math.pow(b, 2);
				
				b = -2 * b * a;
			}
		}
		/* a(x-p)^2+q */
		else if(selectedTab == "exp3")
		{
			//入力に問題がある場合(視認性をあげるためにあえて分岐を多様)
			//aの値
			//整数の入力
			if(document.getElementById("aInput30").value === "" || isFinite(document.getElementById("aInput30").value) === false)
			{
				f=false;
			}
			
			//pの値
			//整数の入力
			if(document.getElementById("pInput30").value === "" || isFinite(document.getElementById("pInput30").value) === false)
			{
				f=false;
			}
			
			//qの値
			//整数の入力
			if(document.getElementById("qInput30").value === "" || isFinite(document.getElementById("qInput30").value) === false)
			{
				f=false;
			}
			
			if(f)
			{
				a = Number(document.getElementById("aInput30").value);
				
				b = Number(document.getElementById("pInput30").value);
				
				c = Number(document.getElementById("qInput30").value);
				
				c = a * Math.pow(b, 2) + c;
				
				b = -2 * b * a;
			}
		}
		else
		{
			//入力に問題がある場合(視認性をあげるためにあえて分岐を多様)
			
			//aの値
			//整数の入力
			if(document.getElementById("aInput40").value === "" || isFinite(document.getElementById("aInput40").value) === false)
			{
				f=false;
			}
			
			//bの値
			//整数の入力
			if(document.getElementById("bInput40").value === "" || isFinite(document.getElementById("bInput40").value) === false)
			{
				f=false;
			}
			
			//cの値
			//整数の入力
			if(document.getElementById("cInput40").value === "" || isFinite(document.getElementById("cInput40").value) === false)
			{
				f=false;
			}
			
			if(f)
			{
				a = Number(document.getElementById("aInput40").value);
				
				b = Number(document.getElementById("bInput40").value);
				
				c = Number(document.getElementById("cInput40").value);
			}
		}
		
		//グラフの再描画
		if(f && a != 0)
		{
			document.getElementById("alert").style.display = "none";
			document.getElementById("configBlock").style.display = "none";
			
			expA = a;
			expB = b;
			expC = c;
			
			var mX = -b/(2 * a);
			var mY = c - ((b * b) / (4 * a));
			
			var flag;
			
			if(a > 0)
			{
				flag = true;
			}
			else
			{
				flag = false;
			}
			
			drawGraphBase(mX, mY, flag, document.getElementById("gridCheck").checked);
			
			drawLine(document.getElementById("gridCheck").checked);
			
			//式の文字列変更
			if(selectedTab == "exp0")
			{
				changeExpression(a, 0, 0, 0);
			}
			else if(selectedTab == "exp1")
			{
				changeExpression(a, c, 0, 1);	
			}
			else if(selectedTab == "exp2")
			{
				changeExpression(a, Number(document.getElementById("pInput20").value), 0, 2);
			}
			else if(selectedTab == "exp3")
			{
				changeExpression(a, Number(document.getElementById("pInput30").value), Number(document.getElementById("qInput30").value), 3);
			}
			else
			{
				changeExpression(a, b, c, 4);
			}
		}
		else if(a == 0)
		{
			document.getElementById("alert").innerHTML = "aは0以外の数値を入力してください。";
			document.getElementById("alert").style.display = "block";
		}
		//アラートの表示
		else
		{
			document.getElementById("alert").innerHTML = "入力された値が不正です。半角数字を入力してください。";
			document.getElementById("alert").style.display = "block";
		}
	}
	catch(e)
	{
		alert("changeLine:" + e.toString());
	}
}

function showConfigBlock()
{
	try
	{
		
		document.getElementById("configBlock").style.display = "block";
	}
	catch(e)
	{
		alert("showConfigBlock:" + e.toString());
	}
}